/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], E_V8QImode)
      || GET_MODE (x1) != E_V8QImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      if (!register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern20 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case AND:
      return pattern19 (x3, pnum_clobbers); /* [-1, 1] */

    case PLUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!nonimmediate_operand (operands[2], E_QImode))
        return -1;
      res = pattern17 (x3);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case MINUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!const_int_operand (operands[3], E_QImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!nonimmediate_operand (operands[2], E_QImode))
        return -1;
      res = pattern16 (x3);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return 6;

    default:
      return -1;
    }
}

int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!nonimmediate_operand (operands[0], E_TImode)
      || GET_MODE (x2) != E_TImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!nonimmediate_operand (operands[1], E_DImode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case ASHIFT:
      if (GET_MODE (x6) != E_TImode)
        return -1;
      return pattern37 (x6, 
E_TImode, 
E_DImode); /* [-1, 2] */

    case CONST_INT:
    case CONST_WIDE_INT:
      operands[2] = x6;
      if (!const_scalar_int_operand (operands[2], E_TImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern41 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern44 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 17
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern49 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  switch (GET_MODE (x5))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[1], E_QImode)
          || !const_1_to_31_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[1], E_HImode)
          || !const_1_to_31_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !const_1_to_31_operand (operands[2], E_QImode))
        return -1;
      return 2;

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !const_1_to_63_operand (operands[2], E_QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern63 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern71 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern75 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_or_x86_64_const_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern82 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x4;
      return 0;

    case STRICT_LOW_PART:
      res = pattern72 (x1, pnum_clobbers);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != VEC_SELECT)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL)
    return -1;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  x8 = XEXP (x3, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
    case MEM:
      return 0;

    case VEC_CONCAT:
      return 1;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 1)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XEXP (x1, 1);
  if (GET_CODE (x7) != PLUS
      || GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != VEC_SELECT
      || GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 1)
    return -1;
  x10 = XEXP (x7, 1);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != i2)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 1
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x12 = XEXP (x3, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], i1))
    return -1;
  x13 = XVECEXP (x4, 0, 0);
  operands[3] = x13;
  if (!const_0_to_1_operand (operands[3], E_SImode))
    return -1;
  x14 = XVECEXP (x6, 0, 0);
  operands[4] = x14;
  if (!const_0_to_1_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern135 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern142 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  x6 = XEXP (x1, 2);
  operands[4] = x6;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          return pattern130 (x1, 
E_V16SImode, 
E_HImode); /* [-1, 0] */

        case E_V8SImode:
          if (pattern130 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern130 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V8DImode:
          if (pattern130 (x1, 
E_V8DImode, 
E_QImode) != 0)
            return -1;
          return 3;

        case E_V4DImode:
          if (pattern130 (x1, 
E_V4DImode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern130 (x1, 
E_V2DImode, 
E_QImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case CONST_INT:
      if (!const_0_to_255_operand (operands[2], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern141 (x1, 
E_V16SImode, 
E_HImode) != 0)
            return -1;
          return 6;

        case E_V8SImode:
          if (pattern141 (x1, 
E_V8SImode, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_V4SImode:
          if (pattern141 (x1, 
E_V4SImode, 
E_QImode) != 0)
            return -1;
          return 8;

        case E_V8DImode:
          if (pattern141 (x1, 
E_V8DImode, 
E_QImode) != 0)
            return -1;
          return 9;

        case E_V4DImode:
          if (pattern141 (x1, 
E_V4DImode, 
E_QImode) != 0)
            return -1;
          return 10;

        case E_V2DImode:
          if (pattern141 (x1, 
E_V2DImode, 
E_QImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern159 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      return pattern150 (x3, 
E_V16SImode); /* [-1, 0] */

    case E_V8SImode:
      if (pattern150 (x3, 
E_V8SImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern150 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern168 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!vector_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern177 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i2)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern181 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      return pattern180 (x1, 
E_V32HFmode); /* [-1, 0] */

    case E_V16HFmode:
      if (pattern180 (x1, 
E_V16HFmode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern180 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V16SFmode:
      if (pattern180 (x1, 
E_V16SFmode) != 0)
        return -1;
      return 3;

    case E_V8SFmode:
      if (pattern180 (x1, 
E_V8SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern180 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V8DFmode:
      if (pattern180 (x1, 
E_V8DFmode) != 0)
        return -1;
      return 6;

    case E_V4DFmode:
      if (pattern180 (x1, 
E_V4DFmode) != 0)
        return -1;
      return 7;

    case E_V2DFmode:
      if (pattern180 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 8;

    case E_V64QImode:
      if (pattern180 (x1, 
E_V64QImode) != 0)
        return -1;
      return 9;

    case E_V32QImode:
      if (pattern180 (x1, 
E_V32QImode) != 0)
        return -1;
      return 10;

    case E_V16QImode:
      if (pattern180 (x1, 
E_V16QImode) != 0)
        return -1;
      return 11;

    case E_V32HImode:
      if (pattern180 (x1, 
E_V32HImode) != 0)
        return -1;
      return 12;

    case E_V16HImode:
      if (pattern180 (x1, 
E_V16HImode) != 0)
        return -1;
      return 13;

    case E_V8HImode:
      if (pattern180 (x1, 
E_V8HImode) != 0)
        return -1;
      return 14;

    case E_V16SImode:
      if (pattern180 (x1, 
E_V16SImode) != 0)
        return -1;
      return 15;

    case E_V8SImode:
      if (pattern180 (x1, 
E_V8SImode) != 0)
        return -1;
      return 16;

    case E_V4SImode:
      if (pattern180 (x1, 
E_V4SImode) != 0)
        return -1;
      return 17;

    case E_V8DImode:
      if (pattern180 (x1, 
E_V8DImode) != 0)
        return -1;
      return 18;

    case E_V4DImode:
      if (pattern180 (x1, 
E_V4DImode) != 0)
        return -1;
      return 19;

    case E_V2DImode:
      if (pattern180 (x1, 
E_V2DImode) != 0)
        return -1;
      return 20;

    case E_V32BFmode:
      if (pattern14 (x1, 
E_V32BFmode) != 0)
        return -1;
      return 21;

    case E_V16BFmode:
      if (pattern14 (x1, 
E_V16BFmode) != 0)
        return -1;
      return 22;

    case E_V8BFmode:
      if (pattern14 (x1, 
E_V8BFmode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern197 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  return pattern196 (x3); /* [-1, 1] */
}

int
pattern201 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nonimmediate_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern213 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern209 (x6, 
E_DImode); /* [-1, 0] */

    case E_TImode:
      if (pattern209 (x6, 
E_TImode) != 0)
        return -1;
      return 1;

    case E_QImode:
      if (pattern209 (x6, 
E_QImode) != 0)
        return -1;
      return 2;

    case E_HImode:
      if (pattern209 (x6, 
E_HImode) != 0)
        return -1;
      return 3;

    case E_SImode:
      if (pattern209 (x6, 
E_SImode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern223 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH)
    return -1;
  return 0;
}

int
pattern232 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_CODE (operands[2]))
    {
    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          return pattern236 (x1, 
E_V32HImode); /* [-1, 0] */

        case E_V16SImode:
          if (pattern236 (x1, 
E_V16SImode) != 0)
            return -1;
          return 1;

        case E_V8DImode:
          if (pattern236 (x1, 
E_V8DImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
      if (!const_0_to_255_not_mul_8_operand (operands[2], E_SImode)
          || !register_operand (operands[0], E_V1TImode)
          || GET_MODE (x1) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern254 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (XWINT (x3, 0) != 8L)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != ZERO_EXTRACT)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x6 = XEXP (x4, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x7 = XEXP (x4, 0);
  operands[0] = x7;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern268 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !register_mmxmem_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern278 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  return pattern277 (x1); /* [-1, 4] */
}

int
pattern284 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      return 0;

    case AND:
      if (GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      res = pattern283 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern295 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (!ix86_comparison_operator (x2, E_QImode))
    return -1;
  operands[1] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern301 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern310 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i3
      || !nonimmediate_operand (operands[2], i2)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern318 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V16SImode:
      if (!register_operand (operands[0], E_V16SImode)
          || GET_MODE (x1) != E_V16SImode
          || !memory_operand (operands[1], E_V16SImode))
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode
          || !memory_operand (operands[1], E_V8SImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !memory_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode
          || !memory_operand (operands[1], E_V8DImode))
        return -1;
      return 3;

    case E_V4DImode:
      if (!register_operand (operands[0], E_V4DImode)
          || GET_MODE (x1) != E_V4DImode
          || !memory_operand (operands[1], E_V4DImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !memory_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x1) != E_V16SFmode
          || !memory_operand (operands[1], E_V16SFmode))
        return -1;
      return 6;

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x1) != E_V8SFmode
          || !memory_operand (operands[1], E_V8SFmode))
        return -1;
      return 7;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !memory_operand (operands[1], E_V4SFmode))
        return -1;
      return 8;

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x1) != E_V8DFmode
          || !memory_operand (operands[1], E_V8DFmode))
        return -1;
      return 9;

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x1) != E_V4DFmode
          || !memory_operand (operands[1], E_V4DFmode))
        return -1;
      return 10;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !memory_operand (operands[1], E_V2DFmode))
        return -1;
      return 11;

    case E_V64QImode:
      if (!register_operand (operands[0], E_V64QImode)
          || GET_MODE (x1) != E_V64QImode
          || !memory_operand (operands[1], E_V64QImode))
        return -1;
      return 12;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !memory_operand (operands[1], E_V16QImode))
        return -1;
      return 13;

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !memory_operand (operands[1], E_V32QImode))
        return -1;
      return 14;

    case E_V32HImode:
      if (!register_operand (operands[0], E_V32HImode)
          || GET_MODE (x1) != E_V32HImode
          || !memory_operand (operands[1], E_V32HImode))
        return -1;
      return 15;

    case E_V16HImode:
      if (!register_operand (operands[0], E_V16HImode)
          || GET_MODE (x1) != E_V16HImode
          || !memory_operand (operands[1], E_V16HImode))
        return -1;
      return 16;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !memory_operand (operands[1], E_V8HImode))
        return -1;
      return 17;

    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x1) != E_V32HFmode
          || !memory_operand (operands[1], E_V32HFmode))
        return -1;
      return 18;

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x1) != E_V16HFmode
          || !memory_operand (operands[1], E_V16HFmode))
        return -1;
      return 19;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !memory_operand (operands[1], E_V8HFmode))
        return -1;
      return 20;

    case E_V32BFmode:
      if (!register_operand (operands[0], E_V32BFmode)
          || GET_MODE (x1) != E_V32BFmode
          || !memory_operand (operands[1], E_V32BFmode))
        return -1;
      return 21;

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || GET_MODE (x1) != E_V16BFmode
          || !memory_operand (operands[1], E_V16BFmode))
        return -1;
      return 22;

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x1) != E_V8BFmode
          || !memory_operand (operands[1], E_V8BFmode))
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern356 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern361 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XVECEXP (x5, 0, 0);
  operands[0] = x6;
  x7 = XVECEXP (x5, 0, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x4, 1);
  operands[1] = x8;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  x12 = XEXP (x10, 1);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  x13 = XEXP (x9, 0);
  if (!rtx_equal_p (x13, operands[0]))
    return -1;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      return pattern360 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern360 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern360 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern360 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern374 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern379 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != UNSPEC
      || XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  return 0;
}

int
pattern384 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode)
        return -1;
      return 1;

    case E_XFmode:
      if (!register_operand (operands[0], E_XFmode)
          || GET_MODE (x1) != E_XFmode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern393 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !memory_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !memory_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern402 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  switch (GET_CODE (x6))
    {
    case AND:
      if (GET_MODE (x6) != E_QImode)
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      return pattern205 (x5); /* [-1, 3] */

    case PLUS:
      if (GET_MODE (x6) != E_QImode)
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      res = pattern206 (x5);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case MINUS:
      if (GET_MODE (x6) != E_QImode)
        return -1;
      x7 = XEXP (x4, 0);
      operands[0] = x7;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      res = pattern207 (x5);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return 12;

    default:
      return -1;
    }
}

int
pattern420 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  return pattern419 (x2, 
i1); /* [-1, 0] */
}

int
pattern427 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  x4 = XEXP (x1, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern426 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern426 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern437 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !nonimmediate_operand (operands[4], E_DImode)
          || !const_0_to_63_operand (operands[2], E_QImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode
          || !nonimmediate_operand (operands[1], E_DImode)
          || !const_0_to_63_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !nonimmediate_operand (operands[4], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !nonimmediate_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[3], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern455 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (!rtx_equal_p (x2, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern454 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern454 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern454 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern465 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern469 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  x6 = XEXP (x1, 1);
  switch (GET_CODE (x6))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      operands[4] = x6;
      x7 = XEXP (x1, 2);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 223)
        return -1;
      x8 = XVECEXP (x7, 0, 0);
      operands[5] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x1) != E_V32HFmode
              || GET_MODE (x2) != E_V32HFmode
              || !vector_operand (operands[1], E_V32HFmode)
              || !vector_operand (operands[2], E_V32HFmode)
              || !vector_operand (operands[3], E_V32HFmode)
              || !const0_operand (operands[4], E_V32HFmode)
              || GET_MODE (x7) != E_SImode
              || !register_operand (operands[5], E_HImode))
            return -1;
          return 0;

        case E_V16HFmode:
          if (pattern467 (x1, 
E_HImode, 
E_V16HFmode) != 0)
            return -1;
          return 1;

        case E_V8HFmode:
          if (pattern467 (x1, 
E_QImode, 
E_V8HFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x7 = XEXP (x1, 2);
      switch (GET_CODE (x7))
        {
        case UNSPEC:
          if (XVECLEN (x7, 0) != 1
              || XINT (x7, 1) != 223)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[4] = x8;
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (!register_operand (operands[0], E_V32HFmode)
                  || GET_MODE (x1) != E_V32HFmode
                  || GET_MODE (x2) != E_V32HFmode
                  || !vector_operand (operands[1], E_V32HFmode)
                  || !vector_operand (operands[2], E_V32HFmode)
                  || !vector_operand (operands[3], E_V32HFmode)
                  || GET_MODE (x7) != E_SImode
                  || !register_operand (operands[4], E_HImode))
                return -1;
              return 3;

            case E_V16HFmode:
              if (pattern468 (x1, 
E_HImode, 
E_V16HFmode) != 0)
                return -1;
              return 4;

            case E_V8HFmode:
              if (pattern468 (x1, 
E_QImode, 
E_V8HFmode) != 0)
                return -1;
              return 5;

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x7, 0) != 3L
              || !register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x1) != E_V8HFmode
              || GET_MODE (x2) != E_V8HFmode
              || !vector_operand (operands[1], E_V8HFmode)
              || !vector_operand (operands[2], E_V8HFmode)
              || !vector_operand (operands[3], E_V8HFmode)
              || !rtx_equal_p (x6, operands[2]))
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern503 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4SImode:
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[1], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern512 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !bcst_vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern514 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!vector_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16SImode:
      if (!vector_operand (operands[1], E_V16SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern518 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!vector_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!vector_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern524 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !permvar_truncate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern532 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !regmem_or_bitnot_regmem_operand (operands[1], i1)
      || !regmem_or_bitnot_regmem_operand (operands[2], i1)
      || !regmem_or_bitnot_regmem_operand (operands[3], i1)
      || !regmem_or_bitnot_regmem_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern537 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      return 0;

    case E_V8SImode:
      if (!register_operand (operands[0], E_V8SImode)
          || GET_MODE (x1) != E_V8SImode)
        return -1;
      return 1;

    case E_V8DImode:
      if (!register_operand (operands[0], E_V8DImode)
          || GET_MODE (x1) != E_V8DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern539 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 8:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x8 = XVECEXP (x3, 0, 4);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x9 = XVECEXP (x3, 0, 5);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x10 = XVECEXP (x3, 0, 6);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x11 = XVECEXP (x3, 0, 7);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return pattern537 (x1); /* [-1, 2] */

    case 4:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x3, 0, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x7 = XVECEXP (x3, 0, 3);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          res = pattern538 (x1, 
E_V4SImode);
          if (res >= 0)
            return res + 3; /* [3, 4] */
          return -1;

        case E_V4DImode:
          res = pattern538 (x1, 
E_V4DImode);
          if (res >= 0)
            return res + 5; /* [5, 6] */
          return -1;

        default:
          return -1;
        }

    case 2:
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V2QImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 7;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 8;

        case E_V2SImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern567 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 174)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern566 (x5, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern566 (x5, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern566 (x5, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern566 (x5, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern581 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!int248_register_operand (operands[0], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_HImode:
      if (!extract_operator (operands[3], E_HImode)
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x4) != E_HImode)
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[3], E_SImode)
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      return 1;

    case E_DImode:
      if (!extract_operator (operands[3], E_DImode)
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x4) != E_DImode)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern590 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !bcst_vector_operand (operands[2], i2)
      || !vector_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern595 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_V2DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 119
      || GET_MODE (x3) != E_V16QImode)
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_CODE (x4) != SUBREG
      || maybe_ne (SUBREG_BYTE (x4), 0)
      || GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != 119
      || GET_MODE (x5) != E_V16QImode)
    return -1;
  return 0;
}

int
pattern603 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_QImode)
      || !const_scalar_int_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern609 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern613 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !general_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern620 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != SUBREG
      || maybe_ne (SUBREG_BYTE (x2), 0)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != AND
      || pattern419 (x1, 
E_DImode) != 0)
    return -1;
  return 0;
}

int
pattern627 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 2);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SFmode:
          return pattern625 (x1, 
E_V16SFmode, 
E_HImode); /* [-1, 0] */

        case E_V8SFmode:
          if (pattern625 (x1, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          return 1;

        case E_V4SFmode:
          if (pattern625 (x1, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          return 2;

        case E_V8DFmode:
          if (pattern625 (x1, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          return 3;

        case E_V4DFmode:
          if (pattern625 (x1, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          return 4;

        case E_V2DFmode:
          if (pattern625 (x1, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x4, 0) != 1L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern626 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 6;

        case E_V2DFmode:
          if (pattern626 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern642 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4DFmode:
      if (!vector_operand (operands[1], E_V4DFmode))
        return -1;
      return 1;

    case E_V4SFmode:
      if (!vector_operand (operands[1], E_V4SFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern649 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  if (!const48_operand (x6, E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      return pattern648 (x1); /* [-1, 5] */

    case CONST_INT:
      res = pattern646 (x1);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern656 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  x5 = XEXP (x3, 1);
  operands[4] = x5;
  switch (GET_CODE (operands[4]))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          return pattern653 (x1, 
E_V8SFmode); /* [-1, 0] */

        case E_V4SFmode:
          if (pattern653 (x1, 
E_V4SFmode) != 0)
            return -1;
          return 1;

        case E_V4DFmode:
          if (pattern653 (x1, 
E_V4DFmode) != 0)
            return -1;
          return 2;

        case E_V2DFmode:
          if (pattern653 (x1, 
E_V2DFmode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern654 (x1, 
E_V8SImode, 
E_V8SFmode) != 0)
            return -1;
          return 4;

        case E_V4SFmode:
          if (pattern654 (x1, 
E_V4SImode, 
E_V4SFmode) != 0)
            return -1;
          return 5;

        case E_V4DFmode:
          if (pattern654 (x1, 
E_V4DImode, 
E_V4DFmode) != 0)
            return -1;
          return 6;

        case E_V2DFmode:
          if (pattern654 (x1, 
E_V2DImode, 
E_V2DFmode) != 0)
            return -1;
          return 7;

        case E_V32QImode:
          if (pattern655 (x1, 
E_V32QImode) != 0)
            return -1;
          return 8;

        case E_V16QImode:
          if (pattern655 (x1, 
E_V16QImode) != 0)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern677 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_V2DImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!memory_operand (operands[1], E_DImode))
    return -1;
  x7 = XEXP (x2, 1);
  switch (XVECLEN (x7, 0))
    {
    case 8:
      x8 = XVECEXP (x7, 0, 0);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x9 = XVECEXP (x7, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x10 = XVECEXP (x7, 0, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x11 = XVECEXP (x7, 0, 3);
      if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x12 = XVECEXP (x7, 0, 4);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x13 = XVECEXP (x7, 0, 5);
      if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
        return -1;
      x14 = XVECEXP (x7, 0, 6);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
        return -1;
      x15 = XVECEXP (x7, 0, 7);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
          || GET_MODE (x2) != E_V8QImode
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return pattern537 (x1); /* [-1, 2] */

    case 4:
      res = pattern675 (x1, 
E_V8HImode, 
E_V4HImode);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    case 2:
      if (pattern676 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern700 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      return 0;

    case STRICT_LOW_PART:
      return 1;

    default:
      return -1;
    }
}

int
pattern708 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 17
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  operands[3] = x8;
  return 0;
}

int
pattern713 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          return pattern711 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

        case E_TImode:
          if (pattern711 (x1, 
E_DImode, 
E_TImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern712 (x1, 
E_DImode, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_TImode:
          if (pattern712 (x1, 
E_TImode, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern728 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[3] = x3;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[4] = x4;
  if (!register_operand (operands[4], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  if (!nonmemory_operand (operands[2], E_SImode))
    return -1;
  x6 = PATTERN (peep2_next_insn (2));
  return pattern727 (x6, 
i1); /* [-1, 0] */
}

int
pattern738 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !nonimmediate_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode)
          || !nonimmediate_operand (operands[2], E_V16HImode))
        return -1;
      return 1;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern749 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern755 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x2, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern753 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern753 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x2, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern754 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern754 (x1, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern771 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern776 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern775 (x1, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern775 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern775 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern786 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  if (!register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (!rtx_equal_p (x3, operands[0]))
    return -1;
  return 0;
}

int
pattern797 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !sse_comparison_operator (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern804 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  if (XVECLEN (x4, 0) < 1)
    return -1;
  operands[3] = x4;
  x5 = XVECEXP (x4, 0, 0);
  operands[4] = x5;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V32QImode:
      return pattern800 (x1, 
E_V32QImode, 
E_V64QImode); /* [-1, 0] */

    case E_V64QImode:
      if (pattern800 (x1, 
E_V64QImode, 
E_V128QImode) != 0)
        return -1;
      return 1;

    case E_V16QImode:
      if (pattern801 (x1, 
E_V16QImode, 
E_V32QImode) != 0)
        return -1;
      return 2;

    case E_V32HImode:
      if (pattern800 (x1, 
E_V32HImode, 
E_V64HImode) != 0)
        return -1;
      return 3;

    case E_V16HImode:
      if (pattern800 (x1, 
E_V16HImode, 
E_V32HImode) != 0)
        return -1;
      return 4;

    case E_V8HImode:
      if (pattern801 (x1, 
E_V8HImode, 
E_V16HImode) != 0)
        return -1;
      return 5;

    case E_V16SImode:
      if (pattern802 (x1, 
E_V16SImode, 
E_V32SImode) != 0)
        return -1;
      return 6;

    case E_V8SImode:
      if (pattern802 (x1, 
E_V8SImode, 
E_V16SImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V8SImode
          || !const0_operand (operands[2], E_V4SImode))
        return -1;
      return 8;

    case E_V8DImode:
      if (pattern803 (x1, 
E_V8DImode, 
E_V16DImode) != 0)
        return -1;
      return 9;

    case E_V4DImode:
      if (pattern803 (x1, 
E_V4DImode, 
E_V8DImode) != 0)
        return -1;
      return 10;

    case E_V2DImode:
      if (pattern803 (x1, 
E_V2DImode, 
E_V4DImode) != 0)
        return -1;
      return 11;

    case E_V32HFmode:
      if (pattern803 (x1, 
E_V32HFmode, 
E_V64HFmode) != 0)
        return -1;
      return 12;

    case E_V16HFmode:
      if (pattern803 (x1, 
E_V16HFmode, 
E_V32HFmode) != 0)
        return -1;
      return 13;

    case E_V8HFmode:
      if (pattern803 (x1, 
E_V8HFmode, 
E_V16HFmode) != 0)
        return -1;
      return 14;

    case E_V32BFmode:
      if (pattern803 (x1, 
E_V32BFmode, 
E_V64BFmode) != 0)
        return -1;
      return 15;

    case E_V16BFmode:
      if (pattern803 (x1, 
E_V16BFmode, 
E_V32BFmode) != 0)
        return -1;
      return 16;

    case E_V8BFmode:
      if (pattern803 (x1, 
E_V8BFmode, 
E_V16BFmode) != 0)
        return -1;
      return 17;

    case E_V16SFmode:
      if (pattern803 (x1, 
E_V16SFmode, 
E_V32SFmode) != 0)
        return -1;
      return 18;

    case E_V8SFmode:
      if (pattern803 (x1, 
E_V8SFmode, 
E_V16SFmode) != 0)
        return -1;
      return 19;

    case E_V4SFmode:
      if (pattern803 (x1, 
E_V4SFmode, 
E_V8SFmode) != 0)
        return -1;
      return 20;

    case E_V8DFmode:
      if (pattern803 (x1, 
E_V8DFmode, 
E_V16DFmode) != 0)
        return -1;
      return 21;

    case E_V4DFmode:
      if (pattern803 (x1, 
E_V4DFmode, 
E_V8DFmode) != 0)
        return -1;
      return 22;

    case E_V2DFmode:
      if (pattern803 (x1, 
E_V2DFmode, 
E_V4DFmode) != 0)
        return -1;
      return 23;

    default:
      return -1;
    }
}

int
pattern845 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !nonmemory_operand (operands[4], i1)
      || !const0_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern849 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !immediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern853 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern858 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !const_0_to_15_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern861 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern869 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern876 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  switch (GET_MODE (x3))
    {
    case E_DFmode:
      if (!register_operand (operands[1], E_V2DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern885 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern896 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V2DImode)
      || GET_MODE (x1) != E_V2DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V2DImode
      || !nonimm_or_0_operand (operands[2], E_V2DImode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2HFmode:
      if (!memory_operand (operands[1], E_V2HFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!vector_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern904 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 0)
      || !register_operand (operands[3], E_QImode))
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case VEC_CONCAT:
      if (GET_MODE (x5) != E_V2DImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!memory_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x3, 1);
      switch (XVECLEN (x8, 0))
        {
        case 8:
          x9 = XVECEXP (x8, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XVECEXP (x8, 0, 1);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x11 = XVECEXP (x8, 0, 2);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x12 = XVECEXP (x8, 0, 3);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
            return -1;
          x13 = XVECEXP (x8, 0, 4);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return -1;
          x14 = XVECEXP (x8, 0, 5);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
            return -1;
          x15 = XVECEXP (x8, 0, 6);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
            return -1;
          x16 = XVECEXP (x8, 0, 7);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || GET_MODE (x3) != E_V8QImode
              || GET_MODE (x4) != E_V16QImode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              return pattern135 (x1, 
E_V8HImode); /* [-1, 0] */

            case E_V8SImode:
              if (pattern135 (x1, 
E_V8SImode) != 0)
                return -1;
              return 1;

            case E_V8DImode:
              if (pattern135 (x1, 
E_V8DImode) != 0)
                return -1;
              return 2;

            default:
              return -1;
            }

        case 4:
          res = pattern902 (x1, 
E_V8HImode, 
E_V4HImode);
          if (res >= 0)
            return res + 3; /* [3, 4] */
          return -1;

        case 2:
          if (pattern903 (x1, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case VEC_MERGE:
      if (GET_MODE (x5) != E_V4SImode)
        return -1;
      x7 = XEXP (x5, 0);
      if (GET_CODE (x7) != VEC_DUPLICATE
          || GET_MODE (x7) != E_V4SImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != CONST_VECTOR
          || XVECLEN (x6, 0) != 4
          || GET_MODE (x6) != E_V4SImode)
        return -1;
      x17 = XVECEXP (x6, 0, 0);
      if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x18 = XVECEXP (x6, 0, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XVECEXP (x6, 0, 2);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x20 = XVECEXP (x6, 0, 3);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x21 = XEXP (x5, 2);
      if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x22 = XEXP (x7, 0);
      operands[1] = x22;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x3, 1);
      switch (XVECLEN (x8, 0))
        {
        case 4:
          res = pattern902 (x1, 
E_V16QImode, 
E_V4QImode);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        case 2:
          if (pattern903 (x1, 
E_V8HImode, 
E_V2HImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern953 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern952 (x1, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case E_TImode:
      if (pattern952 (x1, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern960 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != IF_THEN_ELSE
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (!ix86_comparison_operator (x3, E_VOIDmode))
    return -1;
  operands[4] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 1);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  x7 = XEXP (x2, 2);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XEXP (x1, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern967 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern970 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode)
          || !nonimmediate_operand (operands[2], E_V16SImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_V16HFmode:
      if (!register_operand (operands[1], E_V16HFmode)
          || !nonimmediate_operand (operands[2], E_V16HFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 1;

    case E_V16SFmode:
      if (!register_operand (operands[1], E_V16SFmode)
          || !nonimmediate_operand (operands[2], E_V16SFmode)
          || !const_0_to_31_operand (operands[3], E_SImode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !nonimmediate_operand (operands[2], E_V16QImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 3;

    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode)
          || !nonimmediate_operand (operands[2], E_V16HImode)
          || !const_0_to_7_operand (operands[3], E_SImode))
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern979 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (x1))
    {
    case E_V8SFmode:
      if (!register_operand (operands[1], E_V8SImode)
          || !const0_operand (operands[2], E_V8SImode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!register_operand (operands[1], E_V4SImode)
          || !const0_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    case E_V4DFmode:
      if (!register_operand (operands[1], E_V4DImode)
          || !const0_operand (operands[2], E_V4DImode))
        return -1;
      return 2;

    case E_V2DFmode:
      if (!register_operand (operands[1], E_V2DImode)
          || !const0_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    case E_V32QImode:
      if (!register_operand (operands[1], E_V32QImode)
          || !const0_operand (operands[2], E_V32QImode))
        return -1;
      return 4;

    case E_V16QImode:
      if (!register_operand (operands[1], E_V16QImode)
          || !const0_operand (operands[2], E_V16QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern992 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16SImode)
      || GET_MODE (x1) != E_V16SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V16SImode
      || !nonimm_or_0_operand (operands[2], E_V16SImode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HFmode:
      if (!vector_operand (operands[1], E_V16HFmode))
        return -1;
      return 0;

    case E_V16SFmode:
      if (!vector_operand (operands[1], E_V16SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1000 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern1009 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_operand (operands[1], i1)
      || !vector_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1019 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16HFmode)
      || GET_MODE (x1) != E_V16HFmode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V16HFmode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V16HImode:
      if (!register_operand (operands[1], E_V16HImode))
        return -1;
      return 0;

    case E_V16SImode:
      if (!register_operand (operands[1], E_V16SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1030 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_VECTOR
      || XVECLEN (x5, 0) != 4
      || GET_MODE (x5) != E_V4SImode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XVECEXP (x5, 0, 2);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x9 = XVECEXP (x5, 0, 3);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x10 = XEXP (x4, 2);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
      || GET_MODE (x4) != E_V4SImode)
    return -1;
  return pattern678 (x1); /* [-1, 2] */
}

int
pattern1041 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!int248_register_operand (operands[2], E_VOIDmode))
    return -1;
  x6 = XEXP (x1, 0);
  switch (GET_CODE (x6))
    {
    case STRICT_LOW_PART:
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return pattern1040 (); /* [-1, 2] */

    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      res = pattern1040 ();
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1047 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern1046 (x3, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern1046 (x3, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern1046 (x3, 
E_DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1054 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFT)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != ZERO_EXTEND)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != ZERO_EXTEND)
    return -1;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  return pattern353 (x2); /* [-1, 3] */
}

int
pattern1060 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !vector_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1067 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1070 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  return pattern738 (); /* [-1, 2] */
}

int
pattern1077 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_V64QImode)
          || !nonimmediate_operand (operands[2], E_V64QImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V32QImode:
          if (!register_operand (operands[1], E_V32QImode)
              || !nonimmediate_operand (operands[2], E_V32QImode))
            return -1;
          return 1;

        case E_V32HImode:
          if (!register_operand (operands[1], E_V32HImode)
              || !nonimmediate_operand (operands[2], E_V32HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_HImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_HImode
          || !register_operand (operands[3], E_HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !nonimmediate_operand (operands[2], E_V16QImode))
            return -1;
          return 3;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16HImode)
              || !nonimmediate_operand (operands[2], E_V16HImode))
            return -1;
          return 4;

        case E_V16SImode:
          if (!register_operand (operands[1], E_V16SImode)
              || !nonimmediate_operand (operands[2], E_V16SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_QImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_QImode
          || !register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !nonimmediate_operand (operands[2], E_V8HImode))
            return -1;
          return 6;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8SImode)
              || !nonimmediate_operand (operands[2], E_V8SImode))
            return -1;
          return 7;

        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !nonimmediate_operand (operands[2], E_V4SImode))
            return -1;
          return 8;

        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode)
              || !nonimmediate_operand (operands[2], E_V8DImode))
            return -1;
          return 9;

        case E_V4DImode:
          if (!register_operand (operands[1], E_V4DImode)
              || !nonimmediate_operand (operands[2], E_V4DImode))
            return -1;
          return 10;

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !nonimmediate_operand (operands[2], E_V2DImode))
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1120 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i4
      || !vector_operand (operands[2], i3))
    return -1;
  x4 = XEXP (x2, 1);
  return pattern1118 (x4, 
i1, 
i2, 
i3, 
i4); /* [-1, 0] */
}

int
pattern1128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 2);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x4;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[4] = x5;
          x6 = XEXP (x2, 2);
          operands[5] = x6;
          x7 = XVECEXP (x1, 0, 1);
          operands[6] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              return 0;

            case E_V16HFmode:
              return 1;

            case E_V16SFmode:
              return 2;

            case E_V8SFmode:
              return 3;

            case E_V8DFmode:
              return 4;

            case E_V4DFmode:
              return 5;

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          res = pattern1127 (x1);
          if (res >= 0)
            return res + 6; /* [6, 14] */
          return -1;

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x4, 0);
      operands[3] = x8;
      return 15;

    default:
      return -1;
    }
}

int
pattern1148 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1160 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern1159 (x3, 
E_SImode, 
E_DImode); /* [-1, 0] */

    case E_TImode:
      if (pattern1159 (x3, 
E_DImode, 
E_TImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1170 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  return pattern1169 (x6, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1177 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x2), 0)
          || GET_MODE (x2) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[1] = x3;
      return pattern1166 (x1); /* [-1, 11] */

    case CONST_INT:
      return 12;

    default:
      return -1;
    }
}

int
pattern1184 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !nonmemory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1191 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MINUS
      || GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 1);
  if (!ix86_carry_flag_operator (x5, i1))
    return -1;
  operands[4] = x5;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 17
      || GET_MODE (x8) != E_CCmode)
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!flags_reg_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[2] = x10;
  if (!memory_operand (operands[2], i1))
    return -1;
  x11 = XEXP (x4, 0);
  if (!rtx_equal_p (x11, operands[0]))
    return -1;
  x12 = XEXP (x2, 0);
  return pattern1189 (x12, 
i1); /* [-1, 1] */
}

int
pattern1202 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1206 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case UNSPEC:
      if (XVECLEN (x1, 0) != 2
          || XINT (x1, 1) != 52
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[1] = x2;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[2] = x3;
      return 0;

    case VEC_SELECT:
      if (GET_MODE (x1) != E_V4SImode)
        return -1;
      x4 = XEXP (x1, 1);
      if (GET_CODE (x4) != PARALLEL
          || XVECLEN (x4, 0) != 4)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x7 = XVECEXP (x4, 0, 2);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
        return -1;
      x8 = XVECEXP (x4, 0, 3);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
        return -1;
      x9 = XEXP (x1, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1225 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (maybe_ne (SUBREG_BYTE (x4), 0))
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != NOT)
    return -1;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XEXP (x3, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !vector_operand (operands[2], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || GET_MODE (x5) != E_V16QImode
          || !register_operand (operands[3], E_V16QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V4SImode:
          if (GET_MODE (x4) != E_V4SImode
              || !const0_operand (operands[4], E_V4SImode))
            return -1;
          return 0;

        case E_V2DImode:
          if (GET_MODE (x4) != E_V2DImode
              || !const0_operand (operands[4], E_V2DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V32QImode:
      if (!register_operand (operands[0], E_V32QImode)
          || GET_MODE (x1) != E_V32QImode
          || !register_operand (operands[1], E_V32QImode)
          || !vector_operand (operands[2], E_V32QImode)
          || GET_MODE (x2) != E_V32QImode
          || GET_MODE (x5) != E_V32QImode
          || !register_operand (operands[3], E_V32QImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8SImode:
          if (GET_MODE (x4) != E_V8SImode
              || !const0_operand (operands[4], E_V8SImode))
            return -1;
          return 2;

        case E_V4DImode:
          if (GET_MODE (x4) != E_V4DImode
              || !const0_operand (operands[4], E_V4DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1247 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern1254 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 7
      || GET_MODE (x3) != E_SImode)
    return -1;
  return 0;
}

int
pattern1259 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (x1))
        {
        case E_V32QImode:
          if (!vector_all_ones_operand (operands[0], E_V32QImode)
              || !const0_operand (operands[3], E_V32QImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_V16QImode:
          if (!vector_all_ones_operand (operands[0], E_V16QImode)
              || !const0_operand (operands[3], E_V16QImode)
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != 59)
        return -1;
      x5 = XVECEXP (x2, 0, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      x4 = XEXP (x1, 1);
      operands[4] = x4;
      x6 = XVECEXP (x2, 0, 0);
      operands[0] = x6;
      x7 = XVECEXP (x2, 0, 1);
      operands[1] = x7;
      switch (GET_MODE (x1))
        {
        case E_V32QImode:
          if (pattern1258 (x2, 
E_V32QImode, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_V16QImode:
          if (pattern1258 (x2, 
E_V16QImode, 
E_HImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1289 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !vector_operand (operands[2], i1)
      || !register_operand (operands[4], i2))
    return -1;
  return 0;
}

int
pattern1297 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !nonimmediate_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x2, 2);
  return pattern1292 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1304 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8HFmode)
      || GET_MODE (x1) != E_V8HFmode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V8HFmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V8HFmode
      || !nonimm_or_0_operand (operands[2], E_V8HFmode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8SImode:
      if (!register_operand (operands[1], E_V8SImode))
        return -1;
      return 0;

    case E_V8DImode:
      if (!register_operand (operands[1], E_V8DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1316 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 2);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 0);
  operands[2] = x6;
  x7 = XEXP (x4, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern1315 (x2, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1315 (x2, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1325 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
    case MEM:
      if (!rtx_equal_p (x2, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern201 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern201 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case NOT:
      x3 = XEXP (x2, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1324 (x1, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          if (pattern1324 (x1, 
E_DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCZmode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCZmode)
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern1351 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_HImode:
      if (!extract_operator (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!extract_operator (operands[2], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!extract_operator (operands[2], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1359 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[3] = x6;
  if (!const_0_to_63_operand (operands[3], E_QImode))
    return -1;
  x7 = XEXP (x1, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[0]))
    return -1;
  return 0;
}

int
pattern1368 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1380 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 2);
  return pattern1379 (x3, 
i1); /* [-1, 0] */
}

int
pattern1389 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 2);
  return pattern1379 (x4, 
i1); /* [-1, 0] */
}

int
pattern1398 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonimm_or_0_operand (operands[2], i1)
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern1404 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[4] = x2;
  if (!const48_operand (operands[4], E_SImode))
    return -1;
  return pattern1403 (x1); /* [-1, 2] */
}

int
pattern1409 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1418 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return pattern1149 (x1); /* [-1, 5] */
}

int
pattern1424 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern1432 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1439 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[5], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1450 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern1460 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i2
      || !nonimmediate_operand (operands[3], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1468 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !vector_all_ones_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 2);
  return pattern1467 (x2, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1473 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4DImode)
      || GET_MODE (x1) != E_V4DImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != E_V4DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V4DImode
      || !nonimm_or_0_operand (operands[2], E_V4DImode)
      || !register_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HFmode:
      return 0;

    case E_V4SFmode:
      return 1;

    case E_V4DFmode:
      return 2;

    default:
      return -1;
    }
}

int
pattern1481 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 7);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  x3 = XVECEXP (x1, 0, 8);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x4 = XVECEXP (x1, 0, 9);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x5 = XVECEXP (x1, 0, 10);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x6 = XVECEXP (x1, 0, 11);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
      || pattern1469 (x1) != 0)
    return -1;
  return 0;
}

int
pattern1491 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1504 (rtx x1, int i1, int i2, int i3, int i4, int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 7);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i5])
    return -1;
  x3 = XVECEXP (x1, 0, 8);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x4 = XVECEXP (x1, 0, 9);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x5 = XVECEXP (x1, 0, 10);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x6 = XVECEXP (x1, 0, 11);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1]
      || pattern1412 (x1) != 0)
    return -1;
  return 0;
}

int
pattern1516 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1526 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x7, 1);
  operands[3] = x9;
  if (!nonimmediate_operand (operands[3], E_SImode))
    return -1;
  x10 = XEXP (x2, 0);
  operands[1] = x10;
  x11 = XEXP (x3, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XEXP (x3, 1);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  return 0;
}

int
pattern1537 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1543 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !nonimm_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1552 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const0_operand (operands[4], E_V4HFmode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4DFmode:
      if (!vector_operand (operands[1], E_V4DFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!vector_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1558 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !const_int_operand (operands[3], i2))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !x86_64_immediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1571 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      return pattern1570 (x1, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (pattern1570 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    case E_DImode:
      if (pattern1570 (x1, 
E_DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1580 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1587 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x3, 2);
  return pattern1586 (x4, 
i2, 
i1); /* [-1, 0] */
}

int
pattern1596 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!vsib_mem_operator (operands[5], i1)
      || !register_operand (operands[6], E_QImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      return pattern1595 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1595 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1607 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1606 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1606 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1619 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !ix86_carry_flag_operator (operands[4], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1626 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[2]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  return pattern1567 (x6, pnum_clobbers); /* [-1, 2] */
}

int
pattern1636 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1644 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x3, 2);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1656 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      return pattern1655 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1655 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1667 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !const_0_to_7_operand (operands[3], E_VOIDmode)
      || pattern1666 () != 0)
    return -1;
  return 0;
}

int
pattern1677 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SUBREG
      || maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTRACT:
    case ZERO_EXTRACT:
      operands[4] = x4;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x6 = XEXP (x4, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      return pattern1041 (x1); /* [-1, 5] */

    default:
      return -1;
    }
}

int
pattern1688 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x3, 2);
  if (GET_MODE (x6) != i1
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  x7 = XEXP (x2, 1);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  x8 = XEXP (x1, 1);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern1695 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[3], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1702 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode)
      || !const_0_to_3_operand (operands[3], E_VOIDmode)
      || !const_0_to_3_operand (operands[4], E_VOIDmode)
      || !const_0_to_3_operand (operands[5], E_VOIDmode)
      || !const_4_to_7_operand (operands[6], E_VOIDmode)
      || !const_4_to_7_operand (operands[7], E_VOIDmode)
      || !const_4_to_7_operand (operands[8], E_VOIDmode)
      || !const_4_to_7_operand (operands[9], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1713 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[6], E_QImode)
      || !vsib_mem_operator (operands[5], i1)
      || !scratch_operand (operands[1], E_QImode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1712 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1712 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1725 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[4], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1731 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[0], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8SImode:
      if (!register_operand (operands[2], E_V8SImode)
          || !register_operand (operands[3], E_V8SFmode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[2], E_V4DImode)
          || !register_operand (operands[3], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1739 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V4DImode:
      if (!register_operand (operands[3], E_V4DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1747 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimm_or_0_operand (operands[11], i1))
    return -1;
  return 0;
}

int
pattern1756 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 1;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1765 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!vsib_address_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 0;

    case E_V2DImode:
      if (!register_operand (operands[3], E_V2DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1773 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17
      || GET_MODE (x4) != E_CCZmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 2);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  return 0;
}

int
pattern1783 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !vsib_mem_operator (operands[7], i2)
      || !register_operand (operands[5], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_SImode:
      return pattern1782 (
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern1782 (
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1794 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 17)
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  return 0;
}

int
pattern1801 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_0_to_3_operand (operands[2], E_VOIDmode)
      || !const_0_to_3_operand (operands[3], E_VOIDmode)
      || !const_0_to_3_operand (operands[4], E_VOIDmode)
      || !const_0_to_3_operand (operands[5], E_VOIDmode)
      || !const_4_to_7_operand (operands[6], E_VOIDmode)
      || !const_4_to_7_operand (operands[7], E_VOIDmode)
      || !const_4_to_7_operand (operands[8], E_VOIDmode)
      || !const_4_to_7_operand (operands[9], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern1809 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != VEC_SELECT
      || GET_MODE (x5) != E_V2QImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PARALLEL
      || XVECLEN (x6, 0) != 2)
    return -1;
  x7 = XVECEXP (x6, 0, 0);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x9 = XEXP (x3, 1);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != VEC_SELECT
      || GET_MODE (x10) != E_V2QImode)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PARALLEL
      || XVECLEN (x11, 0) != 2)
    return -1;
  x12 = XVECEXP (x11, 0, 0);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x13 = XVECEXP (x11, 0, 1);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x14 = XEXP (x2, 1);
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != i1)
    return -1;
  x16 = XEXP (x15, 0);
  if (GET_CODE (x16) != VEC_SELECT
      || GET_MODE (x16) != E_V2QImode)
    return -1;
  x17 = XEXP (x16, 1);
  if (GET_CODE (x17) != PARALLEL
      || XVECLEN (x17, 0) != 2)
    return -1;
  x18 = XVECEXP (x17, 0, 0);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x19 = XVECEXP (x17, 0, 1);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x20 = XEXP (x14, 1);
  if (GET_CODE (x20) != i1)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != VEC_SELECT
      || GET_MODE (x21) != E_V2QImode)
    return -1;
  x22 = XEXP (x21, 1);
  if (GET_CODE (x22) != PARALLEL
      || XVECLEN (x22, 0) != 2)
    return -1;
  x23 = XVECEXP (x22, 0, 0);
  if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x24 = XVECEXP (x22, 0, 1);
  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  x25 = XEXP (x1, 1);
  x26 = XEXP (x25, 0);
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != i1)
    return -1;
  x28 = XEXP (x27, 0);
  if (GET_CODE (x28) != VEC_SELECT
      || GET_MODE (x28) != E_V2QImode)
    return -1;
  x29 = XEXP (x28, 1);
  if (GET_CODE (x29) != PARALLEL
      || XVECLEN (x29, 0) != 2)
    return -1;
  x30 = XVECEXP (x29, 0, 0);
  if (x30 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x31 = XVECEXP (x29, 0, 1);
  if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x32 = XEXP (x26, 1);
  if (GET_CODE (x32) != i1)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != VEC_SELECT
      || GET_MODE (x33) != E_V2QImode)
    return -1;
  x34 = XEXP (x33, 1);
  if (GET_CODE (x34) != PARALLEL
      || XVECLEN (x34, 0) != 2)
    return -1;
  x35 = XVECEXP (x34, 0, 0);
  if (x35 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x36 = XVECEXP (x34, 0, 1);
  if (x36 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x37 = XEXP (x25, 1);
  x38 = XEXP (x37, 0);
  if (GET_CODE (x38) != i1)
    return -1;
  x39 = XEXP (x38, 0);
  if (GET_CODE (x39) != VEC_SELECT
      || GET_MODE (x39) != E_V2QImode)
    return -1;
  x40 = XEXP (x39, 1);
  if (GET_CODE (x40) != PARALLEL
      || XVECLEN (x40, 0) != 2)
    return -1;
  x41 = XVECEXP (x40, 0, 0);
  if (x41 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x42 = XVECEXP (x40, 0, 1);
  if (x42 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  x43 = XEXP (x37, 1);
  if (GET_CODE (x43) != i1)
    return -1;
  x44 = XEXP (x43, 0);
  if (GET_CODE (x44) != VEC_SELECT
      || GET_MODE (x44) != E_V2QImode)
    return -1;
  x45 = XEXP (x44, 1);
  if (GET_CODE (x45) != PARALLEL
      || XVECLEN (x45, 0) != 2)
    return -1;
  x46 = XVECEXP (x45, 0, 0);
  if (x46 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x47 = XVECEXP (x45, 0, 1);
  if (x47 != const_int_rtx[MAX_SAVED_CONST_INT + 15])
    return -1;
  x48 = XEXP (x5, 0);
  operands[1] = x48;
  if (!nonimmediate_operand (operands[1], E_V16QImode))
    return -1;
  x49 = XEXP (x10, 0);
  if (!rtx_equal_p (x49, operands[1]))
    return -1;
  x50 = XEXP (x16, 0);
  if (!rtx_equal_p (x50, operands[1]))
    return -1;
  x51 = XEXP (x21, 0);
  if (!rtx_equal_p (x51, operands[1]))
    return -1;
  x52 = XEXP (x28, 0);
  if (!rtx_equal_p (x52, operands[1]))
    return -1;
  x53 = XEXP (x33, 0);
  if (!rtx_equal_p (x53, operands[1]))
    return -1;
  x54 = XEXP (x39, 0);
  if (!rtx_equal_p (x54, operands[1]))
    return -1;
  x55 = XEXP (x44, 0);
  if (!rtx_equal_p (x55, operands[1]))
    return -1;
  return 0;
}

int
pattern1864 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !ix86_carry_flag_operator (operands[4], i2))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i2
      || !sext_operand (operands[2], i1)
      || pattern1863 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1871 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !ix86_carry_flag_operator (operands[4], i2)
      || !const_int_operand (operands[6], i2))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1
      || !ix86_carry_flag_operator (operands[5], i1))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 1);
  return pattern1866 (x11, 
i1); /* [-1, 0] */
}

int
pattern1881 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 24);
  if (XWINT (x2, 0) != 28L)
    return -1;
  x3 = XVECEXP (x1, 0, 25);
  if (XWINT (x3, 0) != 60L)
    return -1;
  x4 = XVECEXP (x1, 0, 26);
  if (XWINT (x4, 0) != 29L)
    return -1;
  x5 = XVECEXP (x1, 0, 27);
  if (XWINT (x5, 0) != 61L)
    return -1;
  x6 = XVECEXP (x1, 0, 28);
  if (XWINT (x6, 0) != 30L)
    return -1;
  x7 = XVECEXP (x1, 0, 29);
  if (XWINT (x7, 0) != 62L)
    return -1;
  x8 = XVECEXP (x1, 0, 30);
  if (XWINT (x8, 0) != 31L)
    return -1;
  x9 = XVECEXP (x1, 0, 31);
  if (XWINT (x9, 0) != 63L)
    return -1;
  return 0;
}

 int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x4) != E_CCFPmode)
    return -1;
  switch (GET_CODE (x4))
    {
    case COMPARE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case REG:
        case SUBREG:
        case MEM:
          operands[2] = x6;
          switch (GET_MODE (operands[1]))
            {
            case E_XFmode:
              if (!register_operand (operands[1], E_XFmode)
                  || !reg_or_0_operand (operands[2], E_XFmode)
                  || !
#line 1936 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 35; /* *cmpxf_i387 */

            case E_SFmode:
              if (!register_operand (operands[1], E_SFmode)
                  || !nonimm_or_0_operand (operands[2], E_SFmode)
                  || !
#line 1949 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 36; /* *cmpsf_i387 */

            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !nonimm_or_0_operand (operands[2], E_DFmode)
                  || !
#line 1949 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 37; /* *cmpdf_i387 */

            default:
              return -1;
            }

        case FLOAT:
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              switch (pattern1260 (x6, 
E_SFmode))
                {
                case 0:
                  if (!
#line 1963 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 38; /* *cmpsf_hi_i387 */

                case 1:
                  if (!
#line 1963 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 41; /* *cmpsf_si_i387 */

                default:
                  return -1;
                }

            case E_DFmode:
              switch (pattern1260 (x6, 
E_DFmode))
                {
                case 0:
                  if (!
#line 1963 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 39; /* *cmpdf_hi_i387 */

                case 1:
                  if (!
#line 1963 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 42; /* *cmpdf_si_i387 */

                default:
                  return -1;
                }

            case E_XFmode:
              switch (pattern1260 (x6, 
E_XFmode))
                {
                case 0:
                  if (!
#line 1963 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_HIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 40; /* *cmpxf_hi_i387 */

                case 1:
                  if (!
#line 1963 "../../../gcc/config/i386/i386.md"
(TARGET_80387
   && (TARGET_USE_SIMODE_FIOP
       || optimize_function_for_size_p (cfun))))
                    return -1;
                  return 43; /* *cmpxf_si_i387 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 26)
        return -1;
      x8 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x8) != COMPARE
          || GET_MODE (x8) != E_CCFPmode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      x10 = XEXP (x8, 1);
      operands[2] = x10;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !register_operand (operands[2], E_SFmode)
              || !
#line 1981 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 44; /* *cmpusf_i387 */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !register_operand (operands[2], E_DFmode)
              || !
#line 1981 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 45; /* *cmpudf_i387 */

        case E_XFmode:
          if (!register_operand (operands[1], E_XFmode)
              || !register_operand (operands[2], E_XFmode)
              || !
#line 1981 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
            return -1;
          return 46; /* *cmpuxf_i387 */

        default:
          return -1;
        }

    case REG:
      if (REGNO (x4) != 18
          || !
#line 23710 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
        return -1;
      return 1708; /* x86_fnstsw_1 */

    default:
      return -1;
    }
}

 int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 24:
      return recog_7 (x1, insn, pnum_clobbers);

    case 25:
      if (pattern55 (x1, 
E_HImode) != 0
          || !
#line 1994 "../../../gcc/config/i386/i386.md"
(TARGET_SAHF))
        return -1;
      return 47; /* x86_sahf_1 */

    case 26:
      return recog_6 (x1, insn, pnum_clobbers);

    case 44:
      if (GET_MODE (x2) != E_CCFPmode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x3) != COMPARE
          || GET_MODE (x3) != E_CCFPmode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 17
          || GET_MODE (x4) != E_CCFPmode)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || !nonimmediate_operand (operands[1], E_SFmode)
              || !
#line 2045 "../../../gcc/config/i386/i386.md"
(TARGET_AVX10_2_256))
            return -1;
          return 50; /* *cmpxsf */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || !nonimmediate_operand (operands[1], E_DFmode)
              || !
#line 2045 "../../../gcc/config/i386/i386.md"
(TARGET_AVX10_2_256))
            return -1;
          return 52; /* *cmpxdf */

        case E_HFmode:
          if (!register_operand (operands[0], E_HFmode)
              || !nonimmediate_operand (operands[1], E_HFmode)
              || !
#line 2058 "../../../gcc/config/i386/i386.md"
(TARGET_AVX10_2_256))
            return -1;
          return 54; /* *cmpxhf */

        default:
          return -1;
        }

    case 41:
      if (pattern57 (x1, 
E_CCCmode) != 0)
        return -1;
      return 63; /* x86_stc */

    case 42:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!flags_reg_operand (operands[1], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!push_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !(
#line 2323 "../../../gcc/config/i386/i386.md"
(GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_CC) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode)))
            return -1;
          return 80; /* pushflsi2 */

        case E_DImode:
          if (!push_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !(
#line 2323 "../../../gcc/config/i386/i386.md"
(GET_MODE_CLASS (GET_MODE (operands[1])) == MODE_CC) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode)))
            return -1;
          return 81; /* pushfldi2 */

        default:
          return -1;
        }

    case 43:
      if (GET_MODE (x2) != E_CCmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!flags_reg_operand (operands[0], E_CCmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!pop_operand (operands[1], E_SImode)
              || !
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode))
            return -1;
          return 82; /* popflsi1 */

        case E_DImode:
          if (!pop_operand (operands[1], E_DImode)
              || !
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode))
            return -1;
          return 83; /* popfldi1 */

        default:
          return -1;
        }

    case 60:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_BFmode)
          || !
#line 5471 "../../../gcc/config/i386/i386.md"
(TARGET_SSE2))
        return -1;
      return 203; /* extendbfsf2_1 */

    case 28:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!memory_operand (operands[0], E_HImode)
          || !
#line 6045 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
        return -1;
      return 238; /* x86_fnstcw_1 */

    case 97:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      if ((
#line 21714 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21624 "../../../gcc/config/i386/i386.md"
(TARGET_BMI)))
        return 1562; /* tzcnt_hi_nf */
      if (pnum_clobbers == NULL
          || !(
#line 21714 "../../../gcc/config/i386/i386.md"
(true) && 
#line 21624 "../../../gcc/config/i386/i386.md"
(TARGET_BMI)))
        return -1;
      *pnum_clobbers = 1;
      return 1563; /* tzcnt_hi */

    case 96:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_HImode))
        return -1;
      if ((
#line 21714 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21625 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT)))
        return 1564; /* lzcnt_hi_nf */
      if (pnum_clobbers == NULL
          || !(
#line 21714 "../../../gcc/config/i386/i386.md"
(true) && 
#line 21625 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT)))
        return -1;
      *pnum_clobbers = 1;
      return 1565; /* lzcnt_hi */

    case 27:
      if (pattern55 (x1, 
E_QImode) != 0)
        return -1;
      return 1642; /* parityqi2_cmp */

    case 54:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 23307 "../../../gcc/config/i386/i386.md"
(TARGET_SSE && TARGET_SSE_MATH))
            return -1;
          return 1674; /* *rcpsf2_sse */

        case 1:
          if (!
#line 23333 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1675; /* rcphf2 */

        default:
          return -1;
        }

    case 31:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!nonimmediate_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !
#line 23550 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1700; /* truncxfsf2_i387_noop_unspec */

        case E_DFmode:
          if (!nonimmediate_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !
#line 23550 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1701; /* truncxfdf2_i387_noop_unspec */

        default:
          return -1;
        }

    case 55:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 23570 "../../../gcc/config/i386/i386.md"
(TARGET_SSE))
            return -1;
          return 1703; /* *rsqrtsf2_sse */

        case 1:
          if (!
#line 23606 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1704; /* rsqrthf2 */

        default:
          return -1;
        }

    case 64:
      if (GET_MODE (x2) != E_XFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 23873 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1711; /* sinxf2 */

    case 65:
      if (GET_MODE (x2) != E_XFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 23873 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1712; /* cosxf2 */

    case 71:
      if (GET_MODE (x2) != E_XFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 24499 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
        return -1;
      return 1719; /* *f2xm1xf2_i387 */

    case 69:
      if (GET_MODE (x2) != E_XFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_XFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 24833 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
        return -1;
      return 1726; /* rintxf2 */

    case 70:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!nonimmediate_operand (operands[0], E_HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_XFmode)
          || !
#line 24974 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
        return -1;
      return 1728; /* lrintxfhi2 */

    case 74:
      if (pattern59 (x1, pnum_clobbers, 
E_XFmode) != 0
          || !
#line 25064 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1730; /* frndintxf2_roundeven */

    case 75:
      if (pattern59 (x1, pnum_clobbers, 
E_XFmode) != 0
          || !
#line 25064 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1731; /* frndintxf2_floor */

    case 76:
      if (pattern59 (x1, pnum_clobbers, 
E_XFmode) != 0
          || !
#line 25064 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1732; /* frndintxf2_ceil */

    case 77:
      if (pattern59 (x1, pnum_clobbers, 
E_XFmode) != 0
          || !
#line 25064 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && (flag_fp_int_builtin_inexact || !flag_trapping_math)
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1733; /* frndintxf2_trunc */

    case 78:
      if (pattern60 (x1, pnum_clobbers) != 0
          || !
#line 25181 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1738; /* *fisthi2_floor_1 */

    case 79:
      if (pattern60 (x1, pnum_clobbers) != 0
          || !
#line 25181 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 1739; /* *fisthi2_ceil_1 */

    case 73:
      if (GET_MODE (x2) != E_HImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !
#line 25283 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1750; /* fxamsf2_i387 */

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !
#line 25283 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1751; /* fxamdf2_i387 */

        case E_XFmode:
          if (!register_operand (operands[1], E_XFmode)
              || !
#line 25283 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387))
            return -1;
          return 1752; /* fxamxf2_i387 */

        default:
          return -1;
        }

    case 112:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_V2SFmode)
          || !
#line 900 "../../../gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 2053; /* mmx_rcpv2sf2 */

    case 115:
      if (GET_MODE (x2) != E_V2SFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_V2SFmode)
          || !
#line 948 "../../../gcc/config/i386/mmx.md"
(TARGET_3DNOW))
        return -1;
      return 2056; /* mmx_rsqrtv2sf2 */

    case 172:
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !
#line 8463 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSE))
            return -1;
          return 4782; /* unspec_sse_cvttps2pi */

        case E_V2DFmode:
          if (!vector_operand (operands[1], E_V2DFmode)
              || !
#line 8928 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
            return -1;
          return 4898; /* unspec_sse2_cvttpd2pi */

        default:
          return -1;
        }

    case 46:
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!vector_operand (operands[1], E_V2DFmode)
          || !
#line 8910 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 4897; /* sse2_cvtpd2pi */

    case 173:
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_V2DFmode)
          || !
#line 8969 "../../../gcc/config/i386/sse.md"
(TARGET_MMX_WITH_SSE && TARGET_AVX512VL))
        return -1;
      return 4900; /* unspec_fixuns_truncv2dfv2si2 */

    case 191:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!register_operand (operands[1], E_V16QImode)
                  || !(
#line 10273 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5195; /* avx512vl_cvtb2maskv16qi */

            case E_V16HImode:
              if (!register_operand (operands[1], E_V16HImode)
                  || !(
#line 10273 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5198; /* avx512vl_cvtw2maskv16hi */

            case E_V16SImode:
              if (!register_operand (operands[1], E_V16SImode)
                  || !(
#line 10283 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 5200; /* avx512f_cvtd2maskv16si */

            default:
              return -1;
            }

        case E_QImode:
          if (!register_operand (operands[0], E_QImode)
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!register_operand (operands[1], E_V8HImode)
                  || !(
#line 10273 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5199; /* avx512vl_cvtw2maskv8hi */

            case E_V8SImode:
              if (!register_operand (operands[1], E_V8SImode)
                  || !(
#line 10283 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5201; /* avx512vl_cvtd2maskv8si */

            case E_V4SImode:
              if (!register_operand (operands[1], E_V4SImode)
                  || !(
#line 10283 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5202; /* avx512vl_cvtd2maskv4si */

            case E_V8DImode:
              if (!register_operand (operands[1], E_V8DImode)
                  || !(
#line 10283 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 5203; /* avx512f_cvtq2maskv8di */

            case E_V4DImode:
              if (!register_operand (operands[1], E_V4DImode)
                  || !(
#line 10283 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5204; /* avx512vl_cvtq2maskv4di */

            case E_V2DImode:
              if (!register_operand (operands[1], E_V2DImode)
                  || !(
#line 10283 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 5205; /* avx512vl_cvtq2maskv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 117:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (!memory_operand (operands[0], E_SFmode)
                  || GET_MODE (x2) != E_SFmode
                  || !register_operand (operands[1], E_SFmode)
                  || !
#line 23425 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4A))
                return -1;
              return 8669; /* sse4a_movntsf */

            case E_DFmode:
              if (!memory_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode
                  || !register_operand (operands[1], E_DFmode)
                  || !
#line 23425 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4A))
                return -1;
              return 8670; /* sse4a_movntdf */

            default:
              return -1;
            }

        case VEC_SELECT:
          x6 = XEXP (x3, 1);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 1)
            return -1;
          x7 = XVECEXP (x6, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x5 = XEXP (x3, 0);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern1064 (x2, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 23437 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4A))
                return -1;
              return 8671; /* sse4a_vmmovntv4sf */

            case E_DFmode:
              if (pattern1064 (x2, 
E_V2DFmode, 
E_DFmode) != 0
                  || !(
#line 23437 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4A) && 
#line 474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 8672; /* sse4a_vmmovntv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 136:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode
              || !nonimmediate_operand (operands[1], E_SFmode)
              || !
#line 27004 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9051; /* xop_frczsf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !nonimmediate_operand (operands[1], E_DFmode)
              || !
#line 27004 "../../../gcc/config/i386/sse.md"
(TARGET_XOP))
            return -1;
          return 9052; /* xop_frczdf2 */

        default:
          return -1;
        }

    case 283:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!memory_operand (operands[1], E_DImode)
          || !
#line 346 "../../../gcc/config/i386/sync.md"
(TARGET_80387))
        return -1;
      return 11017; /* loaddi_via_fpu */

    case 285:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!memory_operand (operands[1], E_DImode)
          || !
#line 369 "../../../gcc/config/i386/sync.md"
(TARGET_SSE))
        return -1;
      return 11019; /* loaddi_via_sse */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      if (register_operand (operands[0], E_SImode))
        {
          switch (pattern260 ())
            {
            case 0:
              if (
#line 5769 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
                return 212; /* fix_trunchfsi2 */
              break;

            case 1:
              if (
#line 5945 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)))
                return 225; /* fix_truncsfsi_sse */
              break;

            case 2:
              if (
#line 5945 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)))
                return 227; /* fix_truncdfsi_sse */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || !register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 5975 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || SImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 230; /* fix_truncsi_i387_fisttp */
        }
      if (!
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || SImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 233; /* *fix_truncsi_i387_1 */

    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      if (register_operand (operands[0], E_DImode))
        {
          switch (pattern260 ())
            {
            case 0:
              if ((
#line 5769 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 214; /* fix_trunchfdi2 */
              break;

            case 1:
              if ((
#line 5945 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (SFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 226; /* fix_truncsfdi_sse */
              break;

            case 2:
              if ((
#line 5945 "../../../gcc/config/i386/i386.md"
(SSE_FLOAT_MODE_P (DFmode)
   && (!TARGET_FISTTP || TARGET_SSE_MATH)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 228; /* fix_truncdfdi_sse */
              break;

            default:
              break;
            }
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_DImode)
          || !register_operand (operands[1], E_VOIDmode))
        return -1;
      if (
#line 5975 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || DImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 231; /* fix_truncdi_i387_fisttp */
        }
      if (!
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || DImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 234; /* *fix_truncdi_i387_1 */

    case E_HImode:
      if (pattern259 (x3, pnum_clobbers, 
E_VOIDmode, 
E_HImode) != 0)
        return -1;
      if (
#line 5975 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && TARGET_FISTTP
   && !((SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || HImode != DImode))
	&& TARGET_SSE_MATH)))
        {
          *pnum_clobbers = 1;
          return 229; /* fix_trunchi_i387_fisttp */
        }
      if (!
#line 5993 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(SSE_FLOAT_MODE_P (GET_MODE (operands[1]))
	 && (TARGET_64BIT || HImode != DImode))
   && ix86_pre_reload_split ()))
        return -1;
      *pnum_clobbers = 1;
      return 232; /* *fix_trunchi_i387_1 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !vector_operand (operands[1], E_V2DFmode)
          || !
#line 8945 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
        return -1;
      return 4899; /* sse2_cvttpd2pi */

    default:
      return -1;
    }
}

 int
recog_39 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern741 (x2, 
E_HImode) != 0
              || !
#line 13607 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, HImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 835; /* *notxorhi_1 */

        case E_QImode:
          if (pattern741 (x2, 
E_QImode) != 0
              || !
#line 13807 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, QImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 871; /* *notxorqi_1 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern40 (x1))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !(
#line 14976 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1031; /* *one_cmplti2_doubleword */

            case E_HImode:
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !nonimmediate_operand (operands[1], E_HImode)
                  || !
#line 14989 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, HImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1032; /* *one_cmplhi2_1 */

            case E_QImode:
              if (!nonimmediate_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !nonimmediate_operand (operands[1], E_QImode)
                  || !
#line 15033 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, QImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1041; /* *one_cmplqi2_1 */

            case E_V4QImode:
              if (!register_operand (operands[0], E_V4QImode)
                  || GET_MODE (x2) != E_V4QImode
                  || !register_operand (operands[1], E_V4QImode))
                return -1;
              return 2259; /* one_cmplv4qi2 */

            case E_V2QImode:
              if (!register_operand (operands[0], E_V2QImode)
                  || GET_MODE (x2) != E_V2QImode
                  || !register_operand (operands[1], E_V2QImode))
                return -1;
              return 2260; /* one_cmplv2qi2 */

            case E_V2HImode:
              if (!register_operand (operands[0], E_V2HImode)
                  || GET_MODE (x2) != E_V2HImode
                  || !register_operand (operands[1], E_V2HImode))
                return -1;
              return 2261; /* one_cmplv2hi2 */

            default:
              return -1;
            }

        case 1:
          if (!
#line 15059 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 1042; /* *one_cmplqi_1_slp */

        case 2:
          if (!
#line 15059 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 1043; /* *one_cmplhi_1_slp */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_CODE (x4) != ZERO_EXTRACT
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x4, 0);
      operands[0] = x8;
      if (!nonimmediate_operand (operands[0], E_DImode))
        return -1;
      x9 = XEXP (x4, 2);
      operands[1] = x9;
      if (!const_0_to_63_operand (operands[1], E_QImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      x10 = XEXP (x3, 2);
      if (!rtx_equal_p (x10, operands[1])
          || !
#line 19040 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && (TARGET_USE_BT || reload_completed)))
        return -1;
      *pnum_clobbers = 1;
      return 1415; /* *btcq_imm */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 3)
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x11 = XVECEXP (x3, 0, 0);
      operands[1] = x11;
      x12 = XVECEXP (x3, 0, 1);
      operands[2] = x12;
      x13 = XVECEXP (x3, 0, 2);
      operands[3] = x13;
      switch (XINT (x3, 1))
        {
        case 59:
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              switch (pattern970 (x2))
                {
                case 0:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3415; /* *avx512f_cmpv16si3 */

                case 1:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return -1;
                  return 3422; /* *avx512vl_cmpv16hf3 */

                case 2:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3424; /* *avx512f_cmpv16sf3 */

                case 3:
                  if (!(
#line 4563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3480; /* *avx512vl_cmpv16qi3 */

                case 4:
                  if (!(
#line 4563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3486; /* *avx512vl_cmpv16hi3 */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern971 (x2))
                {
                case 0:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3416; /* *avx512vl_cmpv8si3 */

                case 1:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 307 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3417; /* *avx512vl_cmpv4si3 */

                case 2:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3418; /* *avx512f_cmpv8di3 */

                case 3:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3419; /* *avx512vl_cmpv4di3 */

                case 4:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 308 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3420; /* *avx512vl_cmpv2di3 */

                case 5:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 311 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return -1;
                  return 3423; /* *avx512fp16_cmpv8hf3 */

                case 6:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3425; /* *avx512vl_cmpv8sf3 */

                case 7:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 312 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3426; /* *avx512vl_cmpv4sf3 */

                case 8:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3427; /* *avx512f_cmpv8df3 */

                case 9:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3428; /* *avx512vl_cmpv4df3 */

                case 10:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 313 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3429; /* *avx512vl_cmpv2df3 */

                case 11:
                  if (!(
#line 4563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3488; /* *avx512vl_cmpv8hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 157:
          if (!const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_HImode:
              switch (pattern1070 (x2))
                {
                case 0:
                  if (!(
#line 4563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3481; /* *avx512vl_cmpv16qi3 */

                case 1:
                  if (!(
#line 4563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3487; /* *avx512vl_cmpv16hi3 */

                case 2:
                  if (!(
#line 4761 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3634; /* *avx512f_ucmpv16si3 */

                default:
                  return -1;
                }

            case E_QImode:
              switch (pattern1071 (x2))
                {
                case 0:
                  if (!(
#line 4563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3489; /* *avx512vl_cmpv8hi3 */

                case 1:
                  if (!(
#line 4761 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3635; /* *avx512vl_ucmpv8si3 */

                case 2:
                  if (!(
#line 4761 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3636; /* *avx512vl_ucmpv4si3 */

                case 3:
                  if (!(
#line 4761 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3637; /* *avx512f_ucmpv8di3 */

                case 4:
                  if (!(
#line 4761 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3638; /* *avx512vl_ucmpv4di3 */

                case 5:
                  if (!(
#line 4761 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3639; /* *avx512vl_ucmpv2di3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x3;
      res = recog_55 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers == NULL
          || GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case SIGN_EXTRACT:
        case ZERO_EXTRACT:
          operands[3] = x4;
          x5 = XEXP (x4, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x6 = XEXP (x4, 2);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x2, 1);
          if (pattern599 (x7) != 0)
            return -1;
          x8 = XEXP (x7, 0);
          operands[4] = x8;
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x10 = XEXP (x8, 2);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || GET_MODE (x2) != E_QImode)
            return -1;
          switch (pattern1264 (x1))
            {
            case 0:
              if (!
#line 8248 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 408; /* *subqi_exthi_2_slp */

            case 1:
              if (!
#line 8248 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
                return -1;
              *pnum_clobbers = 1;
              return 409; /* *subqi_extsi_2_slp */

            case 2:
              if (!(
#line 8248 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 410; /* *subqi_extdi_2_slp */

            case 3:
              *pnum_clobbers = 1;
              return 419; /* *subqi_ext2hi_0 */

            case 4:
              *pnum_clobbers = 1;
              return 420; /* *subqi_ext2si_0 */

            case 5:
              if (!
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 421; /* *subqi_ext2di_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x11 = XEXP (x1, 0);
      operands[0] = x11;
      switch (pattern288 (x2))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1355 (x2, 
E_QImode) != 0
                  || !
#line 9277 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 487; /* subqi3_carry */

            case E_HImode:
              if (pattern1355 (x2, 
E_HImode) != 0
                  || !
#line 9277 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 488; /* subhi3_carry */

            default:
              return -1;
            }

        case 1:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1269 (x2, 
E_QImode) != 0
                  || !
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, QImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 570; /* *subqi3_eq */

            case E_HImode:
              if (pattern1269 (x2, 
E_HImode) != 0
                  || !
#line 10230 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (MINUS, HImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 571; /* *subhi3_eq */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern91 (x1))
        {
        case 0:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          if (pattern972 (x2) != 0)
            return -1;
          x7 = XEXP (x2, 1);
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern1507 (x2, 
E_SFmode, 
E_V2SFmode) != 0
                  || !
#line 1058 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE3 && TARGET_MMX_WITH_SSE && ix86_partial_vec_fp_math
   && ix86_pre_reload_split ()))
                return -1;
              return 2061; /* *mmx_hsubv2sf3_low */

            case E_DFmode:
              if (pattern1507 (x2, 
E_DFmode, 
E_V2DFmode) != 0
                  || !
#line 3768 "../../../gcc/config/i386/sse.md"
(TARGET_SSE3 && TARGET_V2DF_REDUCTION_PREFER_HADDPD))
                return -1;
              return 3184; /* *sse3_hsubv2df3_low */

            default:
              return -1;
            }

        case 1:
          switch (pattern852 (x2))
            {
            case 0:
              if (!
#line 22628 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
                return -1;
              return 8595; /* ssse3_phsubwv4hi3 */

            case 1:
              if (!
#line 22715 "../../../gcc/config/i386/sse.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE) && TARGET_SSSE3))
                return -1;
              return 8602; /* ssse3_phsubdv2si3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 1722 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2083; /* *vec_dupv2sf */

        case E_V4HFmode:
          if (!register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !register_operand (operands[1], E_HFmode)
              || !
#line 5674 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
            return -1;
          return 2338; /* *vec_dupv4hf */

        case E_V4BFmode:
          if (!register_operand (operands[0], E_V4BFmode)
              || GET_MODE (x3) != E_V4BFmode
              || !register_operand (operands[1], E_BFmode)
              || !
#line 5674 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
            return -1;
          return 2339; /* *vec_dupv4bf */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 5674 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX_WITH_SSE))
            return -1;
          return 2340; /* *vec_dupv4hi */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_SImode)
              || !
#line 5685 "../../../gcc/config/i386/mmx.md"
(TARGET_MMX || TARGET_MMX_WITH_SSE))
            return -1;
          return 2341; /* *vec_dupv2si */

        case E_V2HFmode:
          if (!register_operand (operands[0], E_V2HFmode)
              || GET_MODE (x3) != E_V2HFmode
              || !register_operand (operands[1], E_HFmode)
              || !
#line 6266 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2369; /* *vec_dupv2hf */

        case E_V2BFmode:
          if (!register_operand (operands[0], E_V2BFmode)
              || GET_MODE (x3) != E_V2BFmode
              || !register_operand (operands[1], E_BFmode)
              || !
#line 6266 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2370; /* *vec_dupv2bf */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_HImode)
              || !
#line 6266 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2371; /* *vec_dupv2hi */

        default:
          return -1;
        }

    case TRUNCATE:
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !
#line 5659 "../../../gcc/config/i386/mmx.md"
((TARGET_MMX || TARGET_MMX_WITH_SSE)
   && (TARGET_SSE || TARGET_3DNOW_A)))
            return -1;
          return 2337; /* *vec_dupv4hi */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !
#line 6256 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE2))
            return -1;
          return 2368; /* *vec_dupv2hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern433 (x3))
        {
        case 0:
          if (pnum_clobbers != NULL
              && x86_64_hilo_general_operand (operands[2], E_DImode)
              && (
#line 6465 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 266; /* *adddi3_doubleword */
            }
          if (x86_64_general_operand (operands[2], E_DImode))
            {
              if ((
#line 6615 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 284; /* *adddi_1_nf */
              if (pnum_clobbers != NULL
                  && (
#line 6615 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
  && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 285; /* *adddi_1 */
                }
            }
          break;

        case 1:
          if (
#line 6615 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
  && TARGET_APX_NF))
            return 282; /* *addsi_1_nf */
          if (pnum_clobbers != NULL
              && 
#line 6615 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
  && true))
            {
              *pnum_clobbers = 1;
              return 283; /* *addsi_1 */
            }
          break;

        default:
          break;
        }
      if (!register_operand (operands[1], E_SImode)
          || pattern434 (x3, 
22) != 0)
        return -1;
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[2] = x7;
      if (!tls_symbolic_operand (operands[2], E_VOIDmode)
          || !
#line 23124 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS))
        return -1;
      return 1658; /* *tls_dynamic_gnu2_lea_32 */

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      switch (pattern276 (x3, pnum_clobbers, 
E_DImode, 
E_SImode))
        {
        case 0:
          if (!(
#line 6511 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (UNKNOWN, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 268; /* *adddi3_doubleword_zext */

        case 1:
          if (!(
#line 14077 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 898; /* *concatsidi3_2 */

        case 2:
          if (!(
#line 14121 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 916; /* *concatsidi3_4 */

        case 3:
          if (!(
#line 14121 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 919; /* *concatsidi3_4 */

        case 4:
          if (!(
#line 14198 "../../../gcc/config/i386/i386.md"
(DImode == DImode
   ? CONST_INT_P (operands[2])
     && (UINTVAL (operands[2]) & GET_MODE_MASK (SImode)) == 0
     && !ix86_endbr_immediate_operand (operands[2], VOIDmode)
   : CONST_WIDE_INT_P (operands[2])
     && CONST_WIDE_INT_NUNITS (operands[2]) == 2
     && CONST_WIDE_INT_ELT (operands[2], 0) == 0
     && !ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[2],
								    1)),
				       VOIDmode)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          return 946; /* *concatsidi3_7 */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case ASHIFT:
          if (GET_MODE (x8) != E_DImode)
            return -1;
          x9 = XEXP (x8, 0);
          if (GET_CODE (x9) != ZERO_EXTEND
              || GET_MODE (x9) != E_DImode)
            return -1;
          x10 = XEXP (x4, 1);
          if (GET_CODE (x10) != ZERO_EXTEND
              || GET_MODE (x10) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          switch (pattern84 (x3, 
E_DImode, 
E_SImode))
            {
            case 0:
              if (!(
#line 6542 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 270; /* *adddi3_doubleword_concat */

            case 1:
              if (!(
#line 6573 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 276; /* *adddi3_doubleword_concat_zext */

            default:
              return -1;
            }

        case LTU:
        case UNLT:
          operands[4] = x8;
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!flags_reg_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1270 (x3, 
E_SImode) != 0
                  || !
#line 8793 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              *pnum_clobbers = 1;
              return 455; /* addsi3_carry */

            case E_DImode:
              if (pattern1270 (x3, 
E_DImode) != 0
                  || !(
#line 8793 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 456; /* adddi3_carry */

            default:
              return -1;
            }

        case EQ:
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1200 (x3, 
E_SImode) != 0
                  || !
#line 10136 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 556; /* *addsi3_eq */

            case E_DImode:
              if (pattern1200 (x3, 
E_DImode) != 0
                  || !(
#line 10136 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 557; /* *adddi3_eq */

            default:
              return -1;
            }

        case NE:
          x11 = XEXP (x8, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x9 = XEXP (x8, 0);
          operands[3] = x9;
          if (!int_nonimmediate_operand (operands[3], E_VOIDmode))
            return -1;
          x10 = XEXP (x4, 1);
          operands[1] = x10;
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1201 (x3, 
E_SImode) != 0
                  || !
#line 10157 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 560; /* *addsi3_ne */

            case E_DImode:
              if (pattern1201 (x3, 
E_DImode) != 0
                  || !(
#line 10157 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (PLUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 561; /* *adddi3_ne */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case IOR:
      switch (pattern102 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 6542 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 271; /* *adddi3_doubleword_concat */

        case 1:
          if (!(
#line 6573 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 277; /* *adddi3_doubleword_concat_zext */

        default:
          return -1;
        }

    case XOR:
      switch (pattern102 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 6542 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 272; /* *adddi3_doubleword_concat */

        case 1:
          if (!(
#line 6573 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 278; /* *adddi3_doubleword_concat_zext */

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern103 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern1075 (x3, 
E_SImode) != 0
              || !
#line 8865 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 459; /* *addsi3_carry_0 */

        case 1:
          if (pattern1075 (x3, 
E_DImode) != 0
              || !(
#line 8865 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 460; /* *adddi3_carry_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern103 (x3, pnum_clobbers))
        {
        case 0:
          if (pattern1076 (x3, 
E_SImode) != 0
              || !
#line 8879 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])))
            return -1;
          *pnum_clobbers = 1;
          return 463; /* *addsi3_carry_0r */

        case 1:
          if (pattern1076 (x3, 
E_DImode) != 0
              || !(
#line 8879 "../../../gcc/config/i386/i386.md"
(!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[1])) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 464; /* *adddi3_carry_0r */

        default:
          return -1;
        }

    case EQ:
      switch (pattern105 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 10183 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 564; /* *addsi3_eq_0 */

        case 1:
          if (!(
#line 10183 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 565; /* *adddi3_eq_0 */

        default:
          return -1;
        }

    case NE:
      switch (pattern105 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 10204 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, SImode, operands)
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 568; /* *addsi3_ne_0 */

        case 1:
          if (!(
#line 10204 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (PLUS, DImode, operands)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 569; /* *adddi3_ne_0 */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      x10 = XEXP (x4, 1);
      switch (GET_CODE (x10))
        {
        case NE:
          switch (pattern748 (x3))
            {
            case 0:
              if (!
#line 10252 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 576; /* *subsi3_ne */

            case 1:
              if (!(
#line 10252 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 577; /* *subdi3_ne */

            default:
              return -1;
            }

        case EQ:
          switch (pattern748 (x3))
            {
            case 0:
              if (!
#line 10281 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (SImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, SImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()))
                return -1;
              *pnum_clobbers = 1;
              return 580; /* *subsi3_eq_1 */

            case 1:
              if (!(
#line 10281 "../../../gcc/config/i386/i386.md"
(CONST_INT_P (operands[2])
   && (DImode != DImode
       || INTVAL (operands[2]) != HOST_WIDE_INT_C (-0x80000000))
   && ix86_binary_operator_ok (MINUS, DImode, operands, TARGET_APX_NDD)
   && ix86_pre_reload_split ()) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 581; /* *subdi3_eq_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x4) != E_DImode
          || !nonimmediate_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_QImode))
        return -1;
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x5 = XEXP (x3, 1);
          switch (pattern256 (x5, 
E_SImode, 
E_DImode))
            {
            case 0:
              if (!(
#line 14060 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 892; /* *concatsidi3_1 */

            case 1:
              if (!(
#line 14137 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 8 * BITS_PER_UNIT / 2
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 928; /* *concatsidi3_5 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern978 (x3))
            {
            case 0:
              if (!(
#line 14096 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 904; /* *concatsidi3_3 */

            case 1:
              if (!(
#line 14169 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 934; /* *concatsidi3_6 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern978 (x3))
            {
            case 0:
              if (!(
#line 14096 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 907; /* *concatsidi3_3 */

            case 1:
              if (!(
#line 14169 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == 4 * BITS_PER_UNIT
   && (DImode == DImode
       ? CONST_INT_P (operands[3])
	 && (UINTVAL (operands[3]) & ~GET_MODE_MASK (SImode)) == 0
       : CONST_INT_P (operands[3])
       ? INTVAL (operands[3]) >= 0
       : CONST_WIDE_INT_NUNITS (operands[3]) == 2
	 && CONST_WIDE_INT_ELT (operands[3], 1) == 0)
   && !(CONST_INT_P (operands[3])
	? ix86_endbr_immediate_operand (operands[3], VOIDmode)
	: ix86_endbr_immediate_operand (GEN_INT (CONST_WIDE_INT_ELT (operands[3],
								     0)),
					VOIDmode))) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
                return -1;
              return 937; /* *concatsidi3_6 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      if (pnum_clobbers == NULL)
        return -1;
      x10 = XEXP (x4, 1);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x3, 1);
      if (pattern414 (x5, 
E_CCCmode, 
ASHIFT) != 0)
        return -1;
      x12 = XEXP (x5, 1);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x8 = XEXP (x4, 0);
      operands[1] = x8;
      switch (XWINT (x12, 0))
        {
        case 31L:
          if (pattern1450 (x3, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 1385; /* rcrsi2 */

        case 63L:
          if (pattern1450 (x3, 
E_DImode) != 0
              || !
#line 18754 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1386; /* rcrdi2 */

        default:
          return -1;
        }

    case UNSPEC:
      if (pnum_clobbers == NULL)
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 3:
          x13 = XVECEXP (x4, 0, 2);
          if (GET_CODE (x13) != REG
              || REGNO (x13) != 7)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != CONST)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != UNSPEC
              || XVECLEN (x6, 0) != 1
              || XINT (x6, 1) != 6)
            return -1;
          x7 = XVECEXP (x6, 0, 0);
          if (!tls_symbolic_operand (x7, E_VOIDmode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 21:
              if (GET_MODE (x4) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode)
                return -1;
              x14 = XVECEXP (x4, 0, 0);
              operands[1] = x14;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              x15 = XVECEXP (x4, 0, 1);
              operands[2] = x15;
              if (!constant_call_address_operand (operands[2], E_VOIDmode)
                  || GET_MODE (x13) != E_SImode
                  || GET_MODE (x5) != E_SImode
                  || GET_MODE (x6) != E_SImode)
                return -1;
              operands[3] = x7;
              *pnum_clobbers = 3;
              return 1651; /* *tls_local_dynamic_32_once */

            case 22:
              x14 = XVECEXP (x4, 0, 0);
              operands[2] = x14;
              if (!tls_modbase_operand (operands[2], E_VOIDmode))
                return -1;
              x15 = XVECEXP (x4, 0, 1);
              operands[3] = x15;
              operands[1] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern1628 (x3, 
E_SImode) != 0
                      || !(
#line 23217 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1665; /* *tls_dynamic_gnu2_combine_64_si */

                case E_DImode:
                  if (pattern1628 (x3, 
E_DImode) != 0
                      || !(
#line 23217 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_GNU2_TLS) && 
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1666; /* *tls_dynamic_gnu2_combine_64_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          if (XINT (x4, 1) != 19)
            return -1;
          x14 = XVECEXP (x4, 0, 0);
          if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern750 (x3))
            {
            case 0:
              if (!
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == SImode))
                return -1;
              *pnum_clobbers = 1;
              return 1655; /* *add_tp_si */

            case 1:
              if (!
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == DImode))
                return -1;
              *pnum_clobbers = 1;
              return 1656; /* *add_tp_di */

            default:
              return -1;
            }

        case 4:
          if (XINT (x4, 1) != 22
              || GET_MODE (x4) != E_SImode)
            return -1;
          x16 = XVECEXP (x4, 0, 3);
          if (GET_CODE (x16) != REG
              || REGNO (x16) != 7
              || GET_MODE (x16) != E_SImode
              || pattern434 (x3, 
6) != 0)
            return -1;
          x14 = XVECEXP (x4, 0, 0);
          operands[3] = x14;
          if (!tls_modbase_operand (operands[3], E_VOIDmode))
            return -1;
          x15 = XVECEXP (x4, 0, 1);
          operands[4] = x15;
          x13 = XVECEXP (x4, 0, 2);
          operands[2] = x13;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x5 = XEXP (x3, 1);
          x6 = XEXP (x5, 0);
          x7 = XVECEXP (x6, 0, 0);
          operands[1] = x7;
          if (!tls_symbolic_operand (operands[1], E_VOIDmode)
              || !
#line 23158 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_GNU2_TLS))
            return -1;
          *pnum_clobbers = 1;
          return 1660; /* *tls_dynamic_gnu2_combine_32 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern617 (x3, 
E_SImode) != 0)
            return -1;
          if (
#line 10604 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && TARGET_APX_NF))
            return 592; /* *mulsi3_1_nf */
          if (pnum_clobbers == NULL
              || !
#line 10604 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
            return -1;
          *pnum_clobbers = 1;
          return 593; /* *mulsi3_1 */

        case E_DImode:
          if (pattern617 (x3, 
E_DImode) != 0)
            return -1;
          if ((
#line 10604 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && TARGET_APX_NF) && 
#line 1192 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 594; /* *muldi3_1_nf */
          if (pnum_clobbers == NULL
              || !(
#line 10604 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true) && 
#line 1192 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 595; /* *muldi3_1 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pnum_clobbers == NULL
          || pattern114 (x3, 
ZERO_EXTEND) != 0
          || !(
#line 10994 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 617; /* *umulsidi3_1 */

    case SIGN_EXTEND:
      if (pattern114 (x3, 
SIGN_EXTEND) != 0)
        return -1;
      if ((
#line 11040 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && TARGET_APX_NF) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return 619; /* *mulsidi3_1_nf */
      if (pnum_clobbers == NULL
          || !(
#line 11040 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        return -1;
      *pnum_clobbers = 1;
      return 620; /* *mulsidi3_1 */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      if (pnum_clobbers == NULL)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern760 (x3, 
E_SImode) != 0
              || !
#line 13607 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)))
            return -1;
          *pnum_clobbers = 1;
          return 836; /* *notxorsi_1 */

        case E_DImode:
          if (pattern760 (x3, 
E_DImode) != 0
              || !(
#line 13607 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (XOR, DImode, operands, TARGET_APX_NDD)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 837; /* *notxordi_1 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern115 (x3))
        {
        case 0:
          if ((
#line 14976 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            return 1030; /* *one_cmpldi2_doubleword */
          if (!(
#line 14989 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1034; /* *one_cmpldi2_1 */

        case 1:
          if (!
#line 14989 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 1033; /* *one_cmplsi2_1 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3)
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 1);
      operands[2] = x8;
      x9 = XVECEXP (x4, 0, 2);
      operands[3] = x9;
      switch (XINT (x4, 1))
        {
        case 59:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern986 (x3))
                {
                case 0:
                  if (!(
#line 4468 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ix86_pre_reload_split ()) && 
#line 309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                    return -1;
                  return 3421; /* *avx512bw_cmpv32hf3 */

                case 1:
                  if (!(
#line 4563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3482; /* *avx512vl_cmpv32qi3 */

                case 2:
                  if (!(
#line 4563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3484; /* *avx512bw_cmpv32hi3 */

                default:
                  return -1;
                }

            case E_DImode:
              if (pattern987 (x3) != 0
                  || !(
#line 4563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3478; /* *avx512bw_cmpv64qi3 */

            default:
              return -1;
            }

        case 157:
          if (!const_0_to_7_operand (operands[3], E_SImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern1087 (x3, 
E_V64QImode, 
E_DImode) != 0
                  || !(
#line 4563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 3479; /* *avx512bw_cmpv64qi3 */

            case E_SImode:
              switch (pattern1088 (x3))
                {
                case 0:
                  if (!(
#line 4563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                    return -1;
                  return 3483; /* *avx512vl_cmpv32qi3 */

                case 1:
                  if (!(
#line 4563 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && ix86_pre_reload_split ()) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                    return -1;
                  return 3485; /* *avx512bw_cmpv32hi3 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      if (pnum_clobbers != NULL
          && GET_CODE (x4) == SUBREG
          && pattern420 (x1, 
E_DImode) == 0
          && (
#line 16582 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
        {
          *pnum_clobbers = 1;
          return 1122; /* *lshrdi3_doubleword_mask */
        }
      operands[2] = x4;
      res = recog_97 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (pnum_clobbers != NULL)
        {
          switch (GET_CODE (x4))
            {
            case CONST_INT:
              if (XWINT (x4, 0) == 32L)
                {
                  x5 = XEXP (x1, 0);
                  if (GET_CODE (x5) == SUBREG
                      && known_eq (SUBREG_BYTE (x5), 0)
                      && GET_MODE (x5) == E_DImode)
                    {
                      x6 = XEXP (x5, 0);
                      operands[0] = x6;
                      if (register_operand (operands[0], E_SImode)
                          && GET_MODE (x2) == E_DImode
                          && nonimmediate_operand (operands[1], E_DImode)
                          && 
#line 17361 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                        {
                          *pnum_clobbers = 1;
                          return 1179; /* *highpartdisi2 */
                        }
                    }
                }
              break;

            case SUBREG:
              switch (pattern444 (x1, 
E_SImode))
                {
                case 0:
                  if (
#line 17840 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
                    {
                      *pnum_clobbers = 1;
                      return 1245; /* *lshrsi3_mask */
                    }
                  break;

                case 1:
                  if (
#line 17888 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                    {
                      *pnum_clobbers = 1;
                      return 1257; /* *lshrsi3_add */
                    }
                  break;

                case 2:
                  if (
#line 17934 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
                    {
                      *pnum_clobbers = 1;
                      return 1269; /* *lshrsi3_sub */
                    }
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
        }
      operands[2] = x4;
      if (nonmemory_operand (operands[2], E_QImode))
        {
          x5 = XEXP (x1, 0);
          operands[0] = x5;
          if (nonimmediate_operand (operands[0], E_DImode)
              && GET_MODE (x2) == E_DImode
              && nonimmediate_operand (operands[1], E_DImode))
            {
              if ((
#line 17385 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands, TARGET_APX_NDD)
   && TARGET_APX_NF) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 1182; /* *lshrdi3_1_nf */
              if (pnum_clobbers != NULL
                  && (
#line 17385 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                {
                  *pnum_clobbers = 1;
                  return 1183; /* *lshrdi3_1 */
                }
            }
        }
      if (pnum_clobbers == NULL
          || GET_CODE (x4) != SUBREG)
        return -1;
      switch (pattern444 (x1, 
E_DImode))
        {
        case 0:
          if (!(
#line 17840 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1248; /* *lshrdi3_mask */

        case 1:
          if (!(
#line 17888 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1260; /* *lshrdi3_add */

        case 2:
          if (!(
#line 17934 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1272; /* *lshrdi3_sub */

        default:
          return -1;
        }

    case AND:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern116 (x2))
        {
        case 0:
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && (
#line 16643 "../../../gcc/config/i386/i386.md"
(((INTVAL (operands[3]) & (4 * BITS_PER_UNIT)) == 0
    || ((INTVAL (operands[3]) & (2 * 4 * BITS_PER_UNIT - 1))
	 == (2 * 4 * BITS_PER_UNIT - 1)))
   && ix86_pre_reload_split ()) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)))
            {
              *pnum_clobbers = 1;
              return 1126; /* *lshrdi3_doubleword_mask_1 */
            }
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 17865 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1))
      == 8 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1254; /* *lshrdi3_mask_1 */

        case 1:
          if (!
#line 17865 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1))
      == 4 * BITS_PER_UNIT - 1
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1251; /* *lshrsi3_mask_1 */

        default:
          return -1;
        }

    case PLUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern18 (x2))
        {
        case 0:
          if (!
#line 17912 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1263; /* *lshrsi3_add_1 */

        case 1:
          if (!(
#line 17912 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1266; /* *lshrdi3_add_1 */

        default:
          return -1;
        }

    case MINUS:
      if (pnum_clobbers == NULL
          || GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern117 (x2))
        {
        case 0:
          if (!
#line 17964 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, SImode, operands)
   && (INTVAL (operands[3]) & (4 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()))
            return -1;
          *pnum_clobbers = 1;
          return 1275; /* *lshrsi3_sub_1 */

        case 1:
          if (!(
#line 17964 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (LSHIFTRT, DImode, operands)
   && (INTVAL (operands[3]) & (8 * BITS_PER_UNIT - 1)) == 0
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1278; /* *lshrdi3_sub_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_111 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XEXP (x2, 1);
  operands[2] = x6;
  if (call_insn_operand (operands[1], E_SImode)
      && (
#line 20326 "../../../gcc/config/i386/i386.md"
(!SIBLING_CALL_P (insn)) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode)))
    return 1475; /* *call_value */
  if (call_insn_operand (operands[1], E_DImode)
      && (
#line 20326 "../../../gcc/config/i386/i386.md"
(!SIBLING_CALL_P (insn)) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode)))
    return 1476; /* *call_value */
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) == E_DImode)
        {
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (GOT_memory_operand (operands[1], E_SImode))
            {
              operands[2] = x6;
              if (
#line 20337 "../../../gcc/config/i386/i386.md"
(TARGET_X32 && !TARGET_INDIRECT_BRANCH_REGISTER))
                return 1477; /* *call_value_got_x32 */
            }
        }
      break;

    case MEM:
      if (GET_MODE (x5) == E_SImode)
        {
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) == PLUS
              && GET_MODE (x7) == E_SImode)
            {
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (register_no_elim_operand (operands[1], E_SImode))
                {
                  x9 = XEXP (x7, 1);
                  operands[2] = x9;
                  if (GOT32_symbol_operand (operands[2], E_SImode))
                    {
                      operands[3] = x6;
                      if (
#line 20353 "../../../gcc/config/i386/i386.md"
(!TARGET_MACHO
   && !TARGET_64BIT && !TARGET_INDIRECT_BRANCH_REGISTER
   && SIBLING_CALL_P (insn)))
                        return 1478; /* *sibcall_value_GOT_32 */
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  operands[1] = x5;
  operands[2] = x6;
  if (sibcall_insn_operand (operands[1], E_SImode)
      && (
#line 20367 "../../../gcc/config/i386/i386.md"
(SIBLING_CALL_P (insn)) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode)))
    return 1479; /* *sibcall_value */
  if (!sibcall_insn_operand (operands[1], E_DImode)
      || !(
#line 20367 "../../../gcc/config/i386/i386.md"
(SIBLING_CALL_P (insn)) && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode)))
    return -1;
  return 1480; /* *sibcall_value */
}

 int
recog_117 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      switch (XINT (x3, 1))
        {
        case 2:
          if (pnum_clobbers == NULL)
            return -1;
          switch (pattern301 (x3))
            {
            case 0:
              if (!(
#line 27048 "../../../gcc/config/i386/i386.md"
(ix86_target_stack_probe ()) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              *pnum_clobbers = 1;
              return 1853; /* allocate_stack_worker_probe_si */

            case 1:
              if (!(
#line 27048 "../../../gcc/config/i386/i386.md"
(ix86_target_stack_probe ()) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              *pnum_clobbers = 1;
              return 1854; /* allocate_stack_worker_probe_di */

            default:
              return -1;
            }

        case 11:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 28921 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 1889; /* rdpmc */

        case 9:
          if (GET_MODE (x3) != E_DImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_DImode)
              || !
#line 28940 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 1891; /* rdtsc */

        case 36:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 29164 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_XSAVE))
            return -1;
          return 1919; /* xgetbv */

        case 13:
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern23 (x3))
            {
            case 0:
              if (!(
#line 29258 "../../../gcc/config/i386/i386.md"
(TARGET_LWP) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1927; /* lwp_slwpcbsi */

            case 1:
              if (!(
#line 29258 "../../../gcc/config/i386/i386.md"
(TARGET_LWP) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1928; /* lwp_slwpcbdi */

            default:
              return -1;
            }

        case 16:
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern23 (x3))
            {
            case 0:
              if (!
#line 29306 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_FSGSBASE))
                return -1;
              return 1933; /* rdfsbasesi */

            case 1:
              if (!(
#line 29306 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_FSGSBASE) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1935; /* rdfsbasedi */

            default:
              return -1;
            }

        case 17:
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern23 (x3))
            {
            case 0:
              if (!
#line 29306 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_FSGSBASE))
                return -1;
              return 1934; /* rdgsbasesi */

            case 1:
              if (!(
#line 29306 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_FSGSBASE) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1936; /* rdgsbasedi */

            default:
              return -1;
            }

        case 59:
          switch (pattern301 (x3))
            {
            case 0:
              if (!
#line 29374 "../../../gcc/config/i386/i386.md"
(TARGET_SHSTK || (flag_cf_protection & CF_RETURN)))
                return -1;
              return 1950; /* rdsspsi */

            case 1:
              if (!(
#line 29374 "../../../gcc/config/i386/i386.md"
(TARGET_SHSTK || (flag_cf_protection & CF_RETURN)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1951; /* rdsspdi */

            default:
              return -1;
            }

        case 57:
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          switch (pattern23 (x3))
            {
            case 0:
              if (!
#line 29614 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_RDPID))
                return -1;
              return 1976; /* rdpid */

            case 1:
              if (!
#line 29621 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_RDPID))
                return -1;
              return 1977; /* rdpid_rex64 */

            default:
              return -1;
            }

        case 85:
          if (GET_MODE (x3) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          if (!x86_64_szext_nonmemory_operand (operands[1], E_DImode)
              || !
#line 29897 "../../../gcc/config/i386/i386.md"
(TARGET_USER_MSR && TARGET_64BIT))
            return -1;
          return 2005; /* urdmsr */

        case 89:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !memory_operand (operands[1], E_SImode)
                  || !
#line 29935 "../../../gcc/config/i386/i386.md"
(TARGET_MOVRS && TARGET_64BIT))
                return -1;
              return 2011; /* movrssi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !memory_operand (operands[1], E_DImode)
                  || !
#line 29935 "../../../gcc/config/i386/i386.md"
(TARGET_MOVRS && TARGET_64BIT))
                return -1;
              return 2012; /* movrsdi */

            default:
              return -1;
            }

        case 93:
          if (GET_MODE (x3) != E_SImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !memory_operand (operands[0], E_SImode)
              || !
#line 22508 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 8580; /* sse_stmxcsr */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x3, 1))
        {
        case 3:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x3, 0, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern878 (x3, 
E_SImode) != 0
                  || !
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))
                return -1;
              *pnum_clobbers = 1;
              return 1859; /* probe_stack_range_si */

            case E_DImode:
              if (pattern878 (x3, 
E_DImode) != 0
                  || !
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))
                return -1;
              *pnum_clobbers = 1;
              return 1860; /* probe_stack_range_di */

            default:
              return -1;
            }

        case 113:
          x5 = XVECEXP (x3, 0, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case AND:
              switch (pattern624 (x3))
                {
                case 0:
                  if (!
#line 821 "../../../gcc/config/i386/sync.md"
(TARGET_RAOINT))
                    return -1;
                  return 11039; /* rao_aandsi */

                case 1:
                  if (!(
#line 821 "../../../gcc/config/i386/sync.md"
(TARGET_RAOINT) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 11043; /* rao_aanddi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern624 (x3))
                {
                case 0:
                  if (!
#line 821 "../../../gcc/config/i386/sync.md"
(TARGET_RAOINT))
                    return -1;
                  return 11040; /* rao_aorsi */

                case 1:
                  if (!(
#line 821 "../../../gcc/config/i386/sync.md"
(TARGET_RAOINT) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 11044; /* rao_aordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern624 (x3))
                {
                case 0:
                  if (!
#line 821 "../../../gcc/config/i386/sync.md"
(TARGET_RAOINT))
                    return -1;
                  return 11041; /* rao_axorsi */

                case 1:
                  if (!(
#line 821 "../../../gcc/config/i386/sync.md"
(TARGET_RAOINT) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 11045; /* rao_axordi */

                default:
                  return -1;
                }

            case PLUS:
              switch (pattern624 (x3))
                {
                case 0:
                  if (!
#line 821 "../../../gcc/config/i386/sync.md"
(TARGET_RAOINT))
                    return -1;
                  return 11042; /* rao_aaddsi */

                case 1:
                  if (!(
#line 821 "../../../gcc/config/i386/sync.md"
(TARGET_RAOINT) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return -1;
                  return 11046; /* rao_aadddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 111:
          if (pnum_clobbers == NULL)
            return -1;
          x5 = XVECEXP (x3, 0, 1);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case PLUS:
              switch (pattern879 (x3))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 11049; /* atomic_addsi */

                case 1:
                  if (!
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 11050; /* atomic_adddi */

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern879 (x3))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 11053; /* atomic_subsi */

                case 1:
                  if (!
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 11054; /* atomic_subdi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern879 (x3))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 11061; /* atomic_andsi */

                case 1:
                  if (!
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 11064; /* atomic_anddi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern879 (x3))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 11062; /* atomic_orsi */

                case 1:
                  if (!
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 11065; /* atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern879 (x3))
                {
                case 0:
                  *pnum_clobbers = 1;
                  return 11063; /* atomic_xorsi */

                case 1:
                  if (!
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                    return -1;
                  *pnum_clobbers = 1;
                  return 11066; /* atomic_xordi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[3] = x6;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[4] = x7;
          x8 = XEXP (x2, 2);
          operands[5] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1363 (x2, 
E_V32HFmode, 
E_SImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 4089; /* fma_fmaddsub_v32hf_maskz_1 */

            case E_V16HFmode:
              if (pattern1363 (x2, 
E_V16HFmode, 
E_HImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4093; /* fma_fmaddsub_v16hf_maskz_1 */

            case E_V8HFmode:
              if (pattern1363 (x2, 
E_V8HFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4097; /* fma_fmaddsub_v8hf_maskz_1 */

            case E_V16SFmode:
              if (pattern1363 (x2, 
E_V16SFmode, 
E_HImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4099; /* fma_fmaddsub_v16sf_maskz_1 */

            case E_V8SFmode:
              if (pattern1363 (x2, 
E_V8SFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4103; /* fma_fmaddsub_v8sf_maskz_1 */

            case E_V4SFmode:
              if (pattern1363 (x2, 
E_V4SFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4107; /* fma_fmaddsub_v4sf_maskz_1 */

            case E_V8DFmode:
              if (pattern1363 (x2, 
E_V8DFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4109; /* fma_fmaddsub_v8df_maskz_1 */

            case E_V4DFmode:
              if (pattern1363 (x2, 
E_V4DFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4113; /* fma_fmaddsub_v4df_maskz_1 */

            case E_V2DFmode:
              if (pattern1363 (x2, 
E_V2DFmode, 
E_QImode) != 0
                  || !(
#line 6421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4117; /* fma_fmaddsub_v2df_maskz_1 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          x8 = XEXP (x2, 2);
          operands[4] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1273 (x2, 
E_V32HFmode, 
E_SImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V32HFmode)
                  && vector_operand (operands[3], E_V32HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return 4118; /* avx512bw_fmaddsub_v32hf_mask */
              if (!nonimmediate_operand (operands[1], E_V32HFmode)
                  || !nonimmediate_operand (operands[3], E_V32HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 4133; /* avx512bw_fmaddsub_v32hf_mask3 */

            case E_V16HFmode:
              if (pattern1273 (x2, 
E_V16HFmode, 
E_HImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V16HFmode)
                  && vector_operand (operands[3], E_V16HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 4120; /* avx512vl_fmaddsub_v16hf_mask */
              if (!nonimmediate_operand (operands[1], E_V16HFmode)
                  || !nonimmediate_operand (operands[3], E_V16HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4135; /* avx512vl_fmaddsub_v16hf_mask3 */

            case E_V8HFmode:
              if (pattern1273 (x2, 
E_V8HFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V8HFmode)
                  && vector_operand (operands[3], E_V8HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 4122; /* avx512fp16_fmaddsub_v8hf_mask */
              if (!nonimmediate_operand (operands[1], E_V8HFmode)
                  || !nonimmediate_operand (operands[3], E_V8HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4137; /* avx512fp16_fmaddsub_v8hf_mask3 */

            case E_V16SFmode:
              if (pattern1273 (x2, 
E_V16SFmode, 
E_HImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V16SFmode)
                  && vector_operand (operands[3], E_V16SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 4123; /* avx512f_fmaddsub_v16sf_mask */
              if (!nonimmediate_operand (operands[1], E_V16SFmode)
                  || !nonimmediate_operand (operands[3], E_V16SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4138; /* avx512f_fmaddsub_v16sf_mask3 */

            case E_V8SFmode:
              if (pattern1273 (x2, 
E_V8SFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V8SFmode)
                  && vector_operand (operands[3], E_V8SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4125; /* avx512vl_fmaddsub_v8sf_mask */
              if (!nonimmediate_operand (operands[1], E_V8SFmode)
                  || !nonimmediate_operand (operands[3], E_V8SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4140; /* avx512vl_fmaddsub_v8sf_mask3 */

            case E_V4SFmode:
              if (pattern1273 (x2, 
E_V4SFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V4SFmode)
                  && vector_operand (operands[3], E_V4SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4127; /* avx512vl_fmaddsub_v4sf_mask */
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !nonimmediate_operand (operands[3], E_V4SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4142; /* avx512vl_fmaddsub_v4sf_mask3 */

            case E_V8DFmode:
              if (pattern1273 (x2, 
E_V8DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V8DFmode)
                  && vector_operand (operands[3], E_V8DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 4128; /* avx512f_fmaddsub_v8df_mask */
              if (!nonimmediate_operand (operands[1], E_V8DFmode)
                  || !nonimmediate_operand (operands[3], E_V8DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4143; /* avx512f_fmaddsub_v8df_mask3 */

            case E_V4DFmode:
              if (pattern1273 (x2, 
E_V4DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V4DFmode)
                  && vector_operand (operands[3], E_V4DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4130; /* avx512vl_fmaddsub_v4df_mask */
              if (!nonimmediate_operand (operands[1], E_V4DFmode)
                  || !nonimmediate_operand (operands[3], E_V4DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4145; /* avx512vl_fmaddsub_v4df_mask3 */

            case E_V2DFmode:
              if (pattern1273 (x2, 
E_V2DFmode, 
E_QImode) != 0)
                return -1;
              if (register_operand (operands[1], E_V2DFmode)
                  && vector_operand (operands[3], E_V2DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4132; /* avx512vl_fmaddsub_v2df_mask */
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !nonimmediate_operand (operands[3], E_V2DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6458 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4147; /* avx512vl_fmaddsub_v2df_mask3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x9 = XEXP (x6, 0);
      operands[3] = x9;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
          operands[4] = x7;
          x8 = XEXP (x2, 2);
          operands[5] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1364 (x2, 
E_V32HFmode, 
E_SImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 4153; /* fma_fmsubadd_v32hf_maskz_1 */

            case E_V16HFmode:
              if (pattern1364 (x2, 
E_V16HFmode, 
E_HImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4157; /* fma_fmsubadd_v16hf_maskz_1 */

            case E_V8HFmode:
              if (pattern1364 (x2, 
E_V8HFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4161; /* fma_fmsubadd_v8hf_maskz_1 */

            case E_V16SFmode:
              if (pattern1364 (x2, 
E_V16SFmode, 
E_HImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4163; /* fma_fmsubadd_v16sf_maskz_1 */

            case E_V8SFmode:
              if (pattern1364 (x2, 
E_V8SFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4167; /* fma_fmsubadd_v8sf_maskz_1 */

            case E_V4SFmode:
              if (pattern1364 (x2, 
E_V4SFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4171; /* fma_fmsubadd_v4sf_maskz_1 */

            case E_V8DFmode:
              if (pattern1364 (x2, 
E_V8DFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4173; /* fma_fmsubadd_v8df_maskz_1 */

            case E_V4DFmode:
              if (pattern1364 (x2, 
E_V4DFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4177; /* fma_fmsubadd_v4df_maskz_1 */

            case E_V2DFmode:
              if (pattern1364 (x2, 
E_V2DFmode, 
E_QImode) != 0
                  || !(
#line 6491 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4181; /* fma_fmsubadd_v2df_maskz_1 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          x8 = XEXP (x2, 2);
          operands[4] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1274 (x2, 
E_V32HFmode, 
E_SImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V32HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return 4182; /* avx512bw_fmsubadd_v32hf_mask */
              if (!nonimmediate_operand (operands[3], E_V32HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return -1;
              return 4200; /* avx512bw_fmsubadd_v32hf_mask3 */

            case E_V16HFmode:
              if (pattern1274 (x2, 
E_V16HFmode, 
E_HImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V16HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 4184; /* avx512vl_fmsubadd_v16hf_mask */
              if (!nonimmediate_operand (operands[3], E_V16HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4202; /* avx512vl_fmsubadd_v16hf_mask3 */

            case E_V8HFmode:
              if (pattern1274 (x2, 
E_V8HFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V8HFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 4186; /* avx512fp16_fmsubadd_v8hf_mask */
              if (!nonimmediate_operand (operands[3], E_V8HFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return -1;
              return 4204; /* avx512fp16_fmsubadd_v8hf_mask3 */

            case E_V16SFmode:
              if (pattern1274 (x2, 
E_V16SFmode, 
E_HImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V16SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 4188; /* avx512f_fmsubadd_v16sf_mask */
              if (!nonimmediate_operand (operands[3], E_V16SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4206; /* avx512f_fmsubadd_v16sf_mask3 */

            case E_V8SFmode:
              if (pattern1274 (x2, 
E_V8SFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V8SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4190; /* avx512vl_fmsubadd_v8sf_mask */
              if (!nonimmediate_operand (operands[3], E_V8SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4208; /* avx512vl_fmsubadd_v8sf_mask3 */

            case E_V4SFmode:
              if (pattern1274 (x2, 
E_V4SFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V4SFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4192; /* avx512vl_fmsubadd_v4sf_mask */
              if (!nonimmediate_operand (operands[3], E_V4SFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4210; /* avx512vl_fmsubadd_v4sf_mask3 */

            case E_V8DFmode:
              if (pattern1274 (x2, 
E_V8DFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V8DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 4194; /* avx512f_fmsubadd_v8df_mask */
              if (!nonimmediate_operand (operands[3], E_V8DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 4212; /* avx512f_fmsubadd_v8df_mask3 */

            case E_V4DFmode:
              if (pattern1274 (x2, 
E_V4DFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V4DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4196; /* avx512vl_fmsubadd_v4df_mask */
              if (!nonimmediate_operand (operands[3], E_V4DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4214; /* avx512vl_fmsubadd_v4df_mask3 */

            case E_V2DFmode:
              if (pattern1274 (x2, 
E_V2DFmode, 
E_QImode) != 0)
                return -1;
              if (vector_operand (operands[3], E_V2DFmode)
                  && rtx_equal_p (x7, operands[1])
                  && (
#line 6511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 4198; /* avx512vl_fmsubadd_v2df_mask */
              if (!nonimmediate_operand (operands[3], E_V2DFmode)
                  || !rtx_equal_p (x7, operands[3])
                  || !(
#line 6530 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 4216; /* avx512vl_fmsubadd_v2df_mask3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x2, 2);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          return recog_155 (x1, insn, pnum_clobbers);

        case CONST_INT:
          if (XWINT (x4, 0) == 1L)
            {
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (GET_MODE (x2) == E_V2DImode)
                    {
                      x5 = XEXP (x2, 0);
                      if (nonimmediate_operand (x5, E_V2DImode))
                        {
                          operands[1] = x5;
                          if (register_operand (operands[0], E_V2DImode))
                            {
                              operands[2] = x3;
                              if (const0_operand (operands[2], E_V2DImode)
                                  && 
#line 1857 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 2550; /* *sse2_movq128_v2di_1 */
                            }
                          operands[2] = x5;
                          if (nonimmediate_operand (operands[0], E_V2DImode))
                            {
                              operands[1] = x3;
                              if (nonimmediate_operand (operands[1], E_V2DImode)
                                  && 
#line 14859 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 7214; /* sse2_movsd_v2di */
                            }
                        }
                    }
                  break;

                case E_V2DFmode:
                  if (GET_MODE (x2) == E_V2DFmode)
                    {
                      x5 = XEXP (x2, 0);
                      if (nonimmediate_operand (x5, E_V2DFmode))
                        {
                          operands[1] = x5;
                          if (register_operand (operands[0], E_V2DFmode))
                            {
                              operands[2] = x3;
                              if (const0_operand (operands[2], E_V2DFmode)
                                  && 
#line 1857 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 2551; /* *sse2_movq128_v2df_1 */
                            }
                          operands[2] = x5;
                          if (nonimmediate_operand (operands[0], E_V2DFmode))
                            {
                              operands[1] = x3;
                              if (nonimmediate_operand (operands[1], E_V2DFmode)
                                  && 
#line 14859 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))
                                return 7215; /* sse2_movsd_v2df */
                            }
                        }
                    }
                  break;

                case E_V4SImode:
                  if (pattern888 (x2, 
E_V4SImode) == 0
                      && 
#line 11710 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return 5278; /* sse_movss_v4si */
                  break;

                case E_V4SFmode:
                  if (pattern888 (x2, 
E_V4SFmode) == 0
                      && 
#line 11710 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
                    return 5279; /* sse_movss_v4sf */
                  break;

                case E_V8HImode:
                  if (pattern888 (x2, 
E_V8HImode) == 0
                      && 
#line 12128 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16
  || (TARGET_AVX10_2_256 && const0_operand (operands[1], V8HImode))))
                    return 5317; /* avx512fp16_movv8hi */
                  break;

                case E_V8HFmode:
                  if (pattern888 (x2, 
E_V8HFmode) == 0
                      && 
#line 12128 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16
  || (TARGET_AVX10_2_256 && const0_operand (operands[1], V8HFmode))))
                    return 5318; /* avx512fp16_movv8hf */
                  break;

                case E_V8BFmode:
                  if (pattern888 (x2, 
E_V8BFmode) == 0
                      && 
#line 12128 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16
  || (TARGET_AVX10_2_256 && const0_operand (operands[1], V8BFmode))))
                    return 5319; /* avx512fp16_movv8bf */
                  break;

                default:
                  break;
                }
            }
          operands[3] = x4;
          x5 = XEXP (x2, 0);
          operands[2] = x5;
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_V8SFmode:
              if (pattern1110 (x2, 
E_V8SFmode) != 0
                  || !(
#line 23509 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8677; /* avx_blendps256 */

            case E_V4SFmode:
              if (pattern1111 (x2, 
E_V4SFmode) != 0
                  || !
#line 23509 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8678; /* sse4_1_blendps */

            case E_V4DFmode:
              if (pattern1111 (x2, 
E_V4DFmode) != 0
                  || !(
#line 23509 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return -1;
              return 8679; /* avx_blendpd256 */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x2) != E_V2DFmode
                  || !vector_operand (operands[2], E_V2DFmode)
                  || !register_operand (operands[1], E_V2DFmode)
                  || !const_0_to_3_operand (operands[3], E_SImode)
                  || !(
#line 23509 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                return -1;
              return 8680; /* sse4_1_blendpd */

            case E_V8HImode:
              if (pattern1110 (x2, 
E_V8HImode) != 0
                  || !
#line 24014 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8742; /* sse4_1_pblendw */

            case E_V8HFmode:
              if (pattern1110 (x2, 
E_V8HFmode) != 0
                  || !
#line 24014 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8743; /* sse4_1_pblendph */

            case E_V8BFmode:
              if (pattern1110 (x2, 
E_V8BFmode) != 0
                  || !
#line 24014 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1))
                return -1;
              return 8744; /* sse4_1_pblendbf */

            case E_V16HImode:
              if (pattern1112 (x2, 
E_V16HImode) != 0
                  || !
#line 24087 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8745; /* *avx2_pblendw */

            case E_V16HFmode:
              if (pattern1112 (x2, 
E_V16HFmode) != 0
                  || !
#line 24087 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8746; /* *avx2_pblendph */

            case E_V16BFmode:
              if (pattern1112 (x2, 
E_V16BFmode) != 0
                  || !
#line 24087 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8747; /* *avx2_pblendbf */

            case E_V8SImode:
              if (pattern1113 (x2, 
E_V8SImode) != 0
                  || !
#line 24105 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8748; /* avx2_pblenddv8si */

            case E_V4SImode:
              if (pattern1113 (x2, 
E_V4SImode) != 0
                  || !
#line 24105 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 8749; /* avx2_pblenddv4si */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x4, 0) != 3
              || XINT (x4, 1) != 59)
            return -1;
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          switch (pattern1010 (x2))
            {
            case 0:
              x6 = XVECEXP (x4, 0, 0);
              operands[3] = x6;
              switch (pattern1463 (x2))
                {
                case 0:
                  if ((
#line 3328 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                    return 3048; /* *minmaxv32hf3_1 */
                  break;

                case 1:
                  if ((
#line 3328 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return 3049; /* *minmaxv16hf3_1 */
                  break;

                case 2:
                  if ((
#line 3328 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                    return 3050; /* *minmaxv8hf3_1 */
                  break;

                case 3:
                  if ((
#line 3328 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return 3051; /* *minmaxv16sf3_1 */
                  break;

                case 4:
                  if ((
#line 3328 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3052; /* *minmaxv8sf3_1 */
                  break;

                case 5:
                  if (
#line 3328 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)))
                    return 3053; /* *minmaxv4sf3_1 */
                  break;

                case 6:
                  if ((
#line 3328 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                    return 3054; /* *minmaxv8df3_1 */
                  break;

                case 7:
                  if ((
#line 3328 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3055; /* *minmaxv4df3_1 */
                  break;

                case 8:
                  if ((
#line 3328 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_pre_reload_split ()
   && ((rtx_equal_p (operands[1], operands[3])
	&& rtx_equal_p (operands[2], operands[4]))
       || (rtx_equal_p (operands[1], operands[4])
	   && rtx_equal_p (operands[2], operands[3])))
   && (INTVAL (operands[5]) == 1 || INTVAL (operands[5]) == 14)) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return 3056; /* *minmaxv2df3_1 */
                  break;

                case 9:
                  if ((
#line 4213 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 421 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3251; /* *avx_cmpv8sf3_lt */
                  break;

                case 10:
                  if (
#line 4213 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return 3252; /* *avx_cmpv4sf3_lt */
                  break;

                case 11:
                  if ((
#line 4213 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3253; /* *avx_cmpv4df3_lt */
                  break;

                case 12:
                  if ((
#line 4213 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 422 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
                    return 3254; /* *avx_cmpv2df3_lt */
                  break;

                case 13:
                  if (
#line 4242 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return 3255; /* *avx_cmpv4si3_ltint */
                  break;

                case 14:
                  if (
#line 4242 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return 3256; /* *avx_cmpv2di3_ltint */
                  break;

                case 15:
                  if ((
#line 4242 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3257; /* *avx_cmpv8si3_ltint */
                  break;

                case 16:
                  if ((
#line 4242 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return 3258; /* *avx_cmpv4di3_ltint */
                  break;

                case 17:
                  if ((
#line 18040 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[2]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[1])))) && 
#line 629 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return 7904; /* *avx2_pcmpv32qi3_3 */
                  break;

                case 18:
                  if (
#line 18040 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[2]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[1])))))
                    return 7905; /* *avx2_pcmpv16qi3_3 */
                  break;

                default:
                  break;
                }
              if (GET_CODE (x6) != SUBREG)
                return -1;
              switch (pattern1466 (x2))
                {
                case 0:
                  if (!
#line 4277 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return -1;
                  return 3259; /* *avx_cmpv4si3_ltint_not */

                case 1:
                  if (!
#line 4277 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))))
                    return -1;
                  return 3260; /* *avx_cmpv2di3_ltint_not */

                case 2:
                  if (!(
#line 4277 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return -1;
                  return 3261; /* *avx_cmpv8si3_ltint_not */

                case 3:
                  if (!(
#line 4277 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* not LT or GE 0 */
  && ((INTVAL (operands[5]) == 1) || (INTVAL (operands[5]) == 5))) && 
#line 611 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                    return -1;
                  return 3262; /* *avx_cmpv4di3_ltint_not */

                case 4:
                  if (!(
#line 18069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
  && GET_MODE_SIZE (GET_MODE (operands[3])) == 32
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 629 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                    return -1;
                  return 7906; /* *avx2_pcmpv32qi3_4 */

                case 5:
                  if (!
#line 18069 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  && GET_MODE_CLASS (GET_MODE (operands[3])) == MODE_VECTOR_INT
  && GET_MODE_SIZE (GET_MODE (operands[3])) == 16
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))))
                    return -1;
                  return 7907; /* *avx2_pcmpv16qi3_4 */

                default:
                  return -1;
                }

            case 1:
              if (!(
#line 18101 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))) && 
#line 629 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2)))
                return -1;
              return 7908; /* *avx2_pcmpv32qi3_5 */

            case 2:
              if (!
#line 18101 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()
  /* LT or GE 0 */
  && ((INTVAL (operands[5]) == 1 && !MEM_P (operands[1]))
      || (INTVAL (operands[5]) == 5 && !MEM_P (operands[2])))))
                return -1;
              return 7909; /* *avx2_pcmpv16qi3_5 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x4 = XEXP (x2, 2);
      operands[3] = x4;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (pattern1114 (x2, 
E_V2DFmode, 
E_V8DFmode) != 0
              || !(
#line 20052 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12406 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_EVEX512)))
            return -1;
          return 8387; /* *avx512dq_vinsertf64x2_1 */

        case E_V8DImode:
          if (pattern1114 (x2, 
E_V2DImode, 
E_V8DImode) != 0
              || !(
#line 20052 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12407 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_EVEX512)))
            return -1;
          return 8389; /* *avx512dq_vinserti64x2_1 */

        case E_V16SFmode:
          if (pattern1114 (x2, 
E_V4SFmode, 
E_V16SFmode) != 0
              || !(
#line 20052 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12408 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8391; /* *avx512f_vinsertf32x4_1 */

        case E_V16SImode:
          if (pattern1114 (x2, 
E_V4SImode, 
E_V16SImode) != 0
              || !(
#line 20052 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 12408 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8393; /* *avx512f_vinserti32x4_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_168 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 1);
  operands[3] = x5;
  x6 = XVECEXP (x4, 0, 2);
  operands[4] = x6;
  x7 = XVECEXP (x4, 0, 3);
  operands[5] = x7;
  x8 = XEXP (x2, 1);
  operands[6] = x8;
  x9 = XEXP (x2, 2);
  operands[7] = x9;
  if (!register_operand (operands[7], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || GET_MODE (x3) != E_V4SFmode
          || pattern1661 (
E_V16SFmode) != 0
          || !nonimm_or_0_operand (operands[6], E_V4SFmode)
          || !(
#line 12511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL (operands[2]) % 4 == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[4]) == INTVAL (operands[5]) - 1
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[6]))) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 5339; /* avx512f_vextractf32x4_1_mask */

    case E_V4SImode:
      if (GET_MODE (x2) != E_V4SImode
          || GET_MODE (x3) != E_V4SImode
          || !nonimm_or_0_operand (operands[6], E_V4SImode))
        return -1;
      if (nonimmediate_operand (operands[0], E_V4SImode)
          && pattern1661 (
E_V16SImode) == 0
          && (
#line 12511 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F
   && INTVAL (operands[2]) % 4 == 0
   && INTVAL (operands[2]) == INTVAL (operands[3]) - 1
   && INTVAL (operands[3]) == INTVAL (operands[4]) - 1
   && INTVAL (operands[4]) == INTVAL (operands[5]) - 1
   && (!MEM_P (operands[0]) || rtx_equal_p (operands[0], operands[6]))) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return 5340; /* avx512f_vextracti32x4_1_mask */
      if (!register_operand (operands[0], E_V4SImode)
          || !vector_operand (operands[1], E_V4SImode)
          || pattern1690 () != 0
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20703 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512VL)))
        return -1;
      return 8440; /* sse2_pshufd_1_mask */

    case E_V4DImode:
      if (pattern753 (x2, 
E_V4DImode) != 0
          || pattern1690 () != 0
          || !nonimm_or_0_operand (operands[6], E_V4DImode)
          || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 27564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && (32 == 64 || TARGET_AVX512VL))))
        return -1;
      return 9168; /* avx2_permv4di_1_mask */

    default:
      return -1;
    }
}

 int
recog_172 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 4);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  operands[6] = x5;
  res = recog_171 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x5, 0) != 4L)
    return -1;
  x6 = XVECEXP (x4, 0, 5);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x7 = XVECEXP (x4, 0, 6);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x8 = XVECEXP (x4, 0, 7);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
      || pattern1299 (x2, 
E_V8HImode) != 0
      || pattern898 (x4) != 0)
    return -1;
  x9 = XEXP (x2, 1);
  operands[6] = x9;
  if (!nonimm_or_0_operand (operands[6], E_V8HImode))
    return -1;
  x10 = XEXP (x2, 2);
  operands[7] = x10;
  if (!register_operand (operands[7], E_QImode)
      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20859 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && TARGET_AVX512BW && TARGET_AVX512VL)))
    return -1;
  return 8446; /* sse2_pshuflw_1_mask */
}

 int
recog_176 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XVECEXP (x4, 0, 0);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  operands[2] = x5;
  res = recog_175 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (XWINT (x5, 0) != 0L)
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
      || pattern1300 (x4, 
11, 
10, 
9, 
8) != 0
      || pattern753 (x2, 
E_V16HImode) != 0
      || pattern1544 (x4) != 0)
    return -1;
  x9 = XVECEXP (x4, 0, 12);
  operands[6] = x9;
  if (!const_12_to_15_operand (operands[6], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x4, 0, 13);
  operands[7] = x10;
  if (!const_12_to_15_operand (operands[7], E_VOIDmode))
    return -1;
  x11 = XVECEXP (x4, 0, 14);
  operands[8] = x11;
  if (!const_12_to_15_operand (operands[8], E_VOIDmode))
    return -1;
  x12 = XVECEXP (x4, 0, 15);
  operands[9] = x12;
  if (!const_12_to_15_operand (operands[9], E_VOIDmode))
    return -1;
  x13 = XEXP (x2, 1);
  operands[10] = x13;
  if (!nonimm_or_0_operand (operands[10], E_V16HImode))
    return -1;
  x14 = XEXP (x2, 2);
  operands[11] = x14;
  if (!register_operand (operands[11], E_HImode)
      || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 20950 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2
   && TARGET_AVX512BW && TARGET_AVX512VL
   && INTVAL (operands[2]) + 8 == INTVAL (operands[6])
   && INTVAL (operands[3]) + 8 == INTVAL (operands[7])
   && INTVAL (operands[4]) + 8 == INTVAL (operands[8])
   && INTVAL (operands[5]) + 8 == INTVAL (operands[9]))))
    return -1;
  return 8450; /* avx2_pshufhw_1_mask */
}

 int
recog_182 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x5;
      switch (pattern637 (x2))
        {
        case 0:
          if (pattern1370 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5927 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3801; /* fma_fmadd_v32hf_maskz_1 */

        case 1:
          if (pattern1370 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5928 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3805; /* fma_fmadd_v16hf_maskz_1 */

        case 2:
          if (pattern1370 (x2, 
E_V8HFmode, 
E_QImode) != 0
              || !(
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5929 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3809; /* fma_fmadd_v8hf_maskz_1 */

        case 3:
          if (pattern1370 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5931 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3813; /* fma_fmadd_v16sf_maskz_1 */

        case 4:
          if (pattern1370 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5932 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3817; /* fma_fmadd_v8sf_maskz_1 */

        case 5:
          if (pattern1370 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5932 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3821; /* fma_fmadd_v4sf_maskz_1 */

        case 6:
          if (pattern1370 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 5933 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3824; /* fma_fmadd_v8df_maskz_1 */

        case 7:
          if (pattern1370 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 5934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3828; /* fma_fmadd_v4df_maskz_1 */

        case 8:
          if (pattern1370 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 5942 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 5934 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3832; /* fma_fmadd_v2df_maskz_1 */

        case 9:
          if (pattern1372 (x2, 
E_SImode, 
E_V32BFmode) != 0
              || !(
#line 32148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10628; /* avx10_2_fmaddbf16_v32bf_maskz_1 */

        case 10:
          if (pattern1372 (x2, 
E_HImode, 
E_V16BFmode) != 0
              || !
#line 32148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10630; /* avx10_2_fmaddbf16_v16bf_maskz_1 */

        case 11:
          if (pattern1372 (x2, 
E_QImode, 
E_V8BFmode) != 0
              || !
#line 32148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10632; /* avx10_2_fmaddbf16_v8bf_maskz_1 */

        case 12:
          if (pattern1373 (x2, 
E_V4SFmode) != 0
              || !
#line 6955 "../../../gcc/config/i386/sse.md"
(TARGET_FMA4))
            return -1;
          return 4314; /* *fma4i_vmfmadd_v4sf */

        case 13:
          if (pattern1373 (x2, 
E_V2DFmode) != 0
              || !(
#line 6955 "../../../gcc/config/i386/sse.md"
(TARGET_FMA4) && 
#line 474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 4315; /* *fma4i_vmfmadd_v2df */

        case 14:
          if (pattern1289 (x2, 
E_V32HFmode, 
E_SImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V32HFmode)
              && vector_operand (operands[3], E_V32HFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
                return 3833; /* avx512bw_fmadd_v32hf_mask */
            }
          if (!vector_operand (operands[1], E_V32HFmode)
              || !nonimmediate_operand (operands[3], E_V32HFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
            return -1;
          return 3848; /* avx512bw_fmadd_v32hf_mask3 */

        case 15:
          if (pattern1289 (x2, 
E_V16HFmode, 
E_HImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V16HFmode)
              && vector_operand (operands[3], E_V16HFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 3835; /* avx512vl_fmadd_v16hf_mask */
            }
          if (!vector_operand (operands[1], E_V16HFmode)
              || !nonimmediate_operand (operands[3], E_V16HFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3850; /* avx512vl_fmadd_v16hf_mask3 */

        case 16:
          if (pattern1289 (x2, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8HFmode)
              && vector_operand (operands[3], E_V8HFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
                return 3837; /* avx512fp16_fmadd_v8hf_mask */
            }
          if (!vector_operand (operands[1], E_V8HFmode)
              || !nonimmediate_operand (operands[3], E_V8HFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
            return -1;
          return 3852; /* avx512fp16_fmadd_v8hf_mask3 */

        case 17:
          if (pattern1289 (x2, 
E_V16SFmode, 
E_HImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V16SFmode)
              && vector_operand (operands[3], E_V16SFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 3838; /* avx512f_fmadd_v16sf_mask */
            }
          if (!vector_operand (operands[1], E_V16SFmode)
              || !nonimmediate_operand (operands[3], E_V16SFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3853; /* avx512f_fmadd_v16sf_mask3 */

        case 18:
          if (pattern1289 (x2, 
E_V8SFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8SFmode)
              && vector_operand (operands[3], E_V8SFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3840; /* avx512vl_fmadd_v8sf_mask */
            }
          if (!vector_operand (operands[1], E_V8SFmode)
              || !nonimmediate_operand (operands[3], E_V8SFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3855; /* avx512vl_fmadd_v8sf_mask3 */

        case 19:
          if (pattern1289 (x2, 
E_V4SFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4SFmode)
              && vector_operand (operands[3], E_V4SFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3842; /* avx512vl_fmadd_v4sf_mask */
            }
          if (!vector_operand (operands[1], E_V4SFmode)
              || !nonimmediate_operand (operands[3], E_V4SFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3857; /* avx512vl_fmadd_v4sf_mask3 */

        case 20:
          if (pattern1289 (x2, 
E_V8DFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V8DFmode)
              && vector_operand (operands[3], E_V8DFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return 3843; /* avx512f_fmadd_v8df_mask */
            }
          if (!vector_operand (operands[1], E_V8DFmode)
              || !nonimmediate_operand (operands[3], E_V8DFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 3858; /* avx512f_fmadd_v8df_mask3 */

        case 21:
          if (pattern1289 (x2, 
E_V4DFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V4DFmode)
              && vector_operand (operands[3], E_V4DFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3845; /* avx512vl_fmadd_v4df_mask */
            }
          if (!vector_operand (operands[1], E_V4DFmode)
              || !nonimmediate_operand (operands[3], E_V4DFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3860; /* avx512vl_fmadd_v4df_mask3 */

        case 22:
          if (pattern1289 (x2, 
E_V2DFmode, 
E_QImode) != 0)
            return -1;
          if (nonimmediate_operand (operands[1], E_V2DFmode)
              && vector_operand (operands[3], E_V2DFmode))
            {
              x6 = XEXP (x2, 1);
              if (rtx_equal_p (x6, operands[1])
                  && (
#line 5983 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return 3847; /* avx512vl_fmadd_v2df_mask */
            }
          if (!vector_operand (operands[1], E_V2DFmode)
              || !nonimmediate_operand (operands[3], E_V2DFmode))
            return -1;
          x6 = XEXP (x2, 1);
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 6000 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 3862; /* avx512vl_fmadd_v2df_mask3 */

        case 23:
          if (pattern1290 (x2, 
E_SImode, 
E_V32BFmode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 32166 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return 10633; /* avx10_2_fmaddbf16_v32bf_mask */
          if (!rtx_equal_p (x6, operands[3])
              || !(
#line 32183 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
            return -1;
          return 10636; /* avx10_2_fmaddbf16_v32bf_mask3 */

        case 24:
          if (pattern1290 (x2, 
E_HImode, 
E_V16BFmode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 32166 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return 10634; /* avx10_2_fmaddbf16_v16bf_mask */
          if (!rtx_equal_p (x6, operands[3])
              || !
#line 32183 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10637; /* avx10_2_fmaddbf16_v16bf_mask3 */

        case 25:
          if (pattern1290 (x2, 
E_QImode, 
E_V8BFmode) != 0)
            return -1;
          x6 = XEXP (x2, 1);
          if (rtx_equal_p (x6, operands[1])
              && 
#line 32166 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return 10635; /* avx10_2_fmaddbf16_v8bf_mask */
          if (!rtx_equal_p (x6, operands[3])
              || !
#line 32183 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
            return -1;
          return 10638; /* avx10_2_fmaddbf16_v8bf_mask3 */

        case 26:
          if (pattern1374 (x2, 
E_V8HFmode) != 0
              || !(
#line 6596 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 4218; /* *fmai_fmadd_v8hf */

        case 27:
          if (pattern1374 (x2, 
E_V4SFmode) != 0
              || !
#line 6596 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F))
            return -1;
          return 4220; /* *fmai_fmadd_v4sf */

        case 28:
          if (pattern1374 (x2, 
E_V2DFmode) != 0
              || !(
#line 6596 "../../../gcc/config/i386/sse.md"
(TARGET_FMA || TARGET_AVX512F) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 4222; /* *fmai_fmadd_v2df */

        case 29:
          return recog_158 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case NEG:
      return recog_160 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_191 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  x6 = XEXP (x2, 2);
  operands[4] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case NOT:
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern1012 (x2, 
E_V8SFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5235 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)) && 
#line 428 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3694; /* avx_andnotv8sf3_mask */

        case E_V4SFmode:
          if (pattern1012 (x2, 
E_V4SFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 5235 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16))))
            return -1;
          return 3696; /* sse_andnotv4sf3_mask */

        case E_V4DFmode:
          if (pattern1012 (x2, 
E_V4DFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5235 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3698; /* avx_andnotv4df3_mask */

        case E_V2DFmode:
          if (pattern1012 (x2, 
E_V2DFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5235 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3700; /* sse2_andnotv2df3_mask */

        case E_V16SFmode:
          if (pattern1013 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (!true || 32 != 16)) && 
#line 493 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3704; /* avx512f_andnotv16sf3_mask */

        case E_V8DFmode:
          if (pattern1013 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5310 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && (!true || 64 != 16)) && 
#line 494 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3706; /* avx512f_andnotv8df3_mask */

        case E_V16SImode:
          if (pattern1013 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 18693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7996; /* *andnotv16si3_mask */

        case E_V8SImode:
          if (pattern1013 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 18693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7997; /* *andnotv8si3_mask */

        case E_V4SImode:
          if (pattern1013 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 18693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 7998; /* *andnotv4si3_mask */

        case E_V8DImode:
          if (pattern1013 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 18693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 7999; /* *andnotv8di3_mask */

        case E_V4DImode:
          if (pattern1013 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 18693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8000; /* *andnotv4di3_mask */

        case E_V2DImode:
          if (pattern1013 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 18693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8001; /* *andnotv2di3_mask */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
    case VEC_DUPLICATE:
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (pattern127 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 428 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3720; /* *andv8sf3_mask */

        case E_V4SFmode:
          if (pattern127 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 32 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 3726; /* *andv4sf3_mask */

        case E_V4DFmode:
          if (pattern127 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 3732; /* *andv4df3_mask */

        case E_V2DFmode:
          if (pattern127 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5362 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && TARGET_AVX512VL
   && (!true || 64 != 16)
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 429 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3738; /* *andv2df3_mask */

        case E_V16SFmode:
          if (pattern128 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5432 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 32 != 16)) && 
#line 493 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3750; /* *andv16sf3_mask */

        case E_V8DFmode:
          if (pattern128 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 5432 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (!true || 64 != 16)) && 
#line 494 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 3756; /* *andv8df3_mask */

        case E_V16SImode:
          if (pattern484 (x2, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V16SImode, operands)) && 
#line 807 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 8003; /* *andv16si3_mask */

        case E_V8SImode:
          if (pattern484 (x2, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V8SImode, operands)) && 
#line 807 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 8009; /* *andv8si3_mask */

        case E_V4SImode:
          if (pattern484 (x2, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V4SImode, operands))))
            return -1;
          return 8015; /* *andv4si3_mask */

        case E_V8DImode:
          if (pattern484 (x2, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V8DImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 8021; /* *andv8di3_mask */

        case E_V4DImode:
          if (pattern484 (x2, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V4DImode, operands)) && 
#line 808 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 8027; /* *andv4di3_mask */

        case E_V2DImode:
          if (pattern484 (x2, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 18744 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL)
   && ix86_binary_operator_ok (AND, V2DImode, operands))))
            return -1;
          return 8033; /* *andv2di3_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_200 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern886 (x2, 
E_V32HFmode, 
E_SImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512))))
            return -1;
          return 2906; /* avx512fp16_sqrtv32hf2_mask */

        case E_V16HFmode:
          if (pattern886 (x2, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2910; /* avx512fp16_sqrtv16hf2_mask */

        case E_V8HFmode:
          if (pattern886 (x2, 
E_V8HFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))))
            return -1;
          return 2913; /* avx512fp16_sqrtv8hf2_mask */

        case E_V16SFmode:
          if (pattern886 (x2, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2916; /* avx512f_sqrtv16sf2_mask */

        case E_V8SFmode:
          if (pattern886 (x2, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2920; /* avx_sqrtv8sf2_mask */

        case E_V4SFmode:
          if (pattern886 (x2, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL) && 1)))
            return -1;
          return 2923; /* sse_sqrtv4sf2_mask */

        case E_V8DFmode:
          if (pattern886 (x2, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 2926; /* avx512f_sqrtv8df2_mask */

        case E_V4DFmode:
          if (pattern886 (x2, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX))))
            return -1;
          return 2930; /* avx_sqrtv4df2_mask */

        case E_V2DFmode:
          if (pattern886 (x2, 
E_V2DFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (16 == 64 || TARGET_AVX512VL) && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2933; /* sse2_sqrtv2df2_mask */

        case E_V32BFmode:
          if (pattern144 (x2, 
E_V32BFmode, 
E_SImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 32400 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512))))
            return -1;
          return 10682; /* avx10_2_sqrtbf16_v32bf_mask */

        case E_V16BFmode:
          if (pattern144 (x2, 
E_V16BFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32400 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10684; /* avx10_2_sqrtbf16_v16bf_mask */

        case E_V8BFmode:
          if (pattern144 (x2, 
E_V8BFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 32400 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256)))
            return -1;
          return 10686; /* avx10_2_sqrtbf16_v8bf_mask */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x6, 0) != 1L)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern887 (x2, 
E_V8HFmode) != 0
              || !(
#line 3082 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16)))
            return -1;
          return 2934; /* avx512fp16_vmsqrtv8hf2 */

        case E_V4SFmode:
          if (pattern887 (x2, 
E_V4SFmode) != 0
              || !
#line 3082 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 2938; /* sse_vmsqrtv4sf2 */

        case E_V2DFmode:
          if (pattern887 (x2, 
E_V2DFmode) != 0
              || !(
#line 3082 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 2942; /* sse2_vmsqrtv2df2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_208 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (!register_operand (operands[0], E_V32HFmode)
          || GET_MODE (x2) != E_V32HFmode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 524 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 7035; /* avx512bw_getexpv32hf */

    case E_V16HFmode:
      if (!register_operand (operands[0], E_V16HFmode)
          || GET_MODE (x2) != E_V16HFmode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 525 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 7039; /* avx512vl_getexpv16hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 526 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 7043; /* avx512fp16_getexpv8hf */

    case E_V16SFmode:
      if (!register_operand (operands[0], E_V16SFmode)
          || GET_MODE (x2) != E_V16SFmode
          || !vector_operand (operands[1], E_V16SFmode)
          || !(
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7045; /* avx512f_getexpv16sf */

    case E_V8SFmode:
      if (!register_operand (operands[0], E_V8SFmode)
          || GET_MODE (x2) != E_V8SFmode
          || !vector_operand (operands[1], E_V8SFmode)
          || !(
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7049; /* avx512vl_getexpv8sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode
          || !vector_operand (operands[1], E_V4SFmode)
          || !(
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 527 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7053; /* avx512vl_getexpv4sf */

    case E_V8DFmode:
      if (!register_operand (operands[0], E_V8DFmode)
          || GET_MODE (x2) != E_V8DFmode
          || !vector_operand (operands[1], E_V8DFmode)
          || !(
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 7055; /* avx512f_getexpv8df */

    case E_V4DFmode:
      if (!register_operand (operands[0], E_V4DFmode)
          || GET_MODE (x2) != E_V4DFmode
          || !vector_operand (operands[1], E_V4DFmode)
          || !(
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7059; /* avx512vl_getexpv4df */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode
          || !vector_operand (operands[1], E_V2DFmode)
          || !(
#line 14044 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && 1) && 
#line 528 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 7063; /* avx512vl_getexpv2df */

    case E_V32BFmode:
      if (!register_operand (operands[0], E_V32BFmode)
          || GET_MODE (x2) != E_V32BFmode
          || !nonimmediate_operand (operands[1], E_V32BFmode)
          || !(
#line 32418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10693; /* avx10_2_getexpbf16_v32bf */

    case E_V16BFmode:
      if (!register_operand (operands[0], E_V16BFmode)
          || GET_MODE (x2) != E_V16BFmode
          || !nonimmediate_operand (operands[1], E_V16BFmode)
          || !
#line 32418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10695; /* avx10_2_getexpbf16_v16bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x2) != E_V8BFmode
          || !nonimmediate_operand (operands[1], E_V8BFmode)
          || !
#line 32418 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10697; /* avx10_2_getexpbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_216 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern318 (x2))
    {
    case 0:
      if (!(
#line 1633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2455; /* *avx512f_loadv16si */

    case 1:
      if (!(
#line 1633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2456; /* *avx512vl_loadv8si */

    case 2:
      if (!(
#line 1633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2457; /* *avx512vl_loadv4si */

    case 3:
      if (!(
#line 1633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2458; /* *avx512f_loadv8di */

    case 4:
      if (!(
#line 1633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2459; /* *avx512vl_loadv4di */

    case 5:
      if (!(
#line 1633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2460; /* *avx512vl_loadv2di */

    case 6:
      if (!(
#line 1633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2461; /* *avx512f_loadv16sf */

    case 7:
      if (!(
#line 1633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2462; /* *avx512vl_loadv8sf */

    case 8:
      if (!(
#line 1633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2463; /* *avx512vl_loadv4sf */

    case 9:
      if (!(
#line 1633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2464; /* *avx512f_loadv8df */

    case 10:
      if (!(
#line 1633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2465; /* *avx512vl_loadv4df */

    case 11:
      if (!(
#line 1633 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2466; /* *avx512vl_loadv2df */

    case 12:
      if (!(
#line 1677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2479; /* *avx512bw_loadv64qi */

    case 13:
      if (!(
#line 1677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2480; /* *avx512vl_loadv16qi */

    case 14:
      if (!(
#line 1677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2481; /* *avx512vl_loadv32qi */

    case 15:
      if (!(
#line 1677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2482; /* *avx512bw_loadv32hi */

    case 16:
      if (!(
#line 1677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2483; /* *avx512vl_loadv16hi */

    case 17:
      if (!(
#line 1677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2484; /* *avx512vl_loadv8hi */

    case 18:
      if (!(
#line 1677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2485; /* *avx512bw_loadv32hf */

    case 19:
      if (!(
#line 1677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2486; /* *avx512vl_loadv16hf */

    case 20:
      if (!(
#line 1677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2487; /* *avx512fp16_loadv8hf */

    case 21:
      if (!(
#line 1677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 2488; /* *avx512bw_loadv32bf */

    case 22:
      if (!(
#line 1677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2489; /* *avx512vl_loadv16bf */

    case 23:
      if (!(
#line 1677 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 2490; /* *avx512vl_loadv8bf */

    default:
      return -1;
    }
}

 int
recog_226 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (!const48_operand (x3, E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XEXP (x4, 2);
      operands[3] = x8;
      operands[4] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_V8DFmode:
          if (pattern1307 (x2, 
E_QImode, 
E_V8DFmode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!register_operand (operands[1], E_V8HFmode)
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8031 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4711; /* avx512fp16_float_extend_phv8df2_mask_round */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 10234 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && (64 == 64 || TARGET_AVX512VL) && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 467 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                return -1;
              return 5187; /* avx512f_cvtps2pd512_mask_round */

            default:
              return -1;
            }

        case E_V16SFmode:
          if (pattern650 (x2, 
E_V16SFmode, 
E_V16HFmode, 
E_HImode) != 0
              || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8031 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4715; /* avx512fp16_float_extend_phv16sf2_mask_round */

        case E_V8SFmode:
          if (pattern650 (x2, 
E_V8SFmode, 
E_V8HFmode, 
E_QImode) != 0
              || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8031 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4719; /* avx512fp16_float_extend_phv8sf2_mask_round */

        case E_V4DFmode:
          if (pattern650 (x2, 
E_V4DFmode, 
E_V4SFmode, 
E_QImode) != 0
              || !(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10234 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && (32 == 64 || TARGET_AVX512VL) && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))))))
            return -1;
          return 5191; /* avx_cvtps2pd256_mask_round */

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != PARALLEL)
        return -1;
      switch (XVECLEN (x9, 0))
        {
        case 4:
          x10 = XVECEXP (x9, 0, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x12 = XVECEXP (x9, 0, 2);
          if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
            return -1;
          x13 = XVECEXP (x9, 0, 3);
          if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || pattern1401 (x2, 
E_V4HFmode, 
E_V4DFmode) != 0)
            return -1;
          x14 = XEXP (x6, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_V8HFmode))
            return -1;
          x7 = XEXP (x4, 1);
          operands[2] = x7;
          if (!nonimm_or_0_operand (operands[2], E_V4DFmode))
            return -1;
          x8 = XEXP (x4, 2);
          operands[3] = x8;
          if (!register_operand (operands[3], E_QImode))
            return -1;
          operands[4] = x3;
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8060 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))))))
            return -1;
          return 4723; /* avx512fp16_float_extend_phv4df2_mask_round */

        case 2:
          x10 = XVECEXP (x9, 0, 0);
          if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x11 = XVECEXP (x9, 0, 1);
          if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XEXP (x4, 2);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || pattern1401 (x2, 
E_V2SFmode, 
E_V2DFmode) != 0)
            return -1;
          x14 = XEXP (x6, 0);
          operands[2] = x14;
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          x7 = XEXP (x4, 1);
          operands[1] = x7;
          if (!register_operand (operands[1], E_V2DFmode))
            return -1;
          operands[3] = x3;
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10060 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 5168; /* sse2_cvtss2sd_round */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_228 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      switch (pattern647 (x2))
        {
        case 0:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V32HFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2680; /* *addv32hf3_mask_round */

        case 1:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16HFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2688; /* *addv16hf3_mask_round */

        case 2:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8HFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && ((V8HFmode == V16SFmode
							       || V8HFmode == V8DFmode
							       || V8HFmode == V8DImode
							       || V8HFmode == V16SImode
							       || V8HFmode == V32HImode
							       || V8HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8HFmode == V8SFmode
								       || V8HFmode == V4DFmode
								       || V8HFmode == V4DImode
								       || V8HFmode == V8SImode
								       || V8HFmode == V16HImode
								       || V8HFmode == V16HFmode)))) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2696; /* *addv8hf3_mask_round */

        case 3:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V16SFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2704; /* *addv16sf3_mask_round */

        case 4:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8SFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2712; /* *addv8sf3_mask_round */

        case 5:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4SFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && ((V4SFmode == V16SFmode
							       || V4SFmode == V8DFmode
							       || V4SFmode == V8DImode
							       || V4SFmode == V16SImode
							       || V4SFmode == V32HImode
							       || V4SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4SFmode == V8SFmode
								       || V4SFmode == V4DFmode
								       || V4SFmode == V4DImode
								       || V4SFmode == V8SImode
								       || V4SFmode == V16HImode
								       || V4SFmode == V16HFmode)))))))
            return -1;
          return 2720; /* *addv4sf3_mask_round */

        case 6:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V8DFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2728; /* *addv8df3_mask_round */

        case 7:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V4DFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2736; /* *addv4df3_mask_round */

        case 8:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (PLUS, V2DFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && ((V2DFmode == V16SFmode
							       || V2DFmode == V8DFmode
							       || V2DFmode == V8DImode
							       || V2DFmode == V16SImode
							       || V2DFmode == V32HImode
							       || V2DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V2DFmode == V8SFmode
								       || V2DFmode == V4DFmode
								       || V2DFmode == V4DImode
								       || V2DFmode == V8SImode
								       || V2DFmode == V16HImode
								       || V2DFmode == V16HFmode)))) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2744; /* *addv2df3_mask_round */

        case 9:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2756; /* avx512fp16_vmaddv8hf3_round */

        case 10:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2764; /* sse_vmaddv4sf3_round */

        case 11:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2772; /* sse2_vmaddv2df3_round */

        default:
          return -1;
        }

    case MINUS:
      switch (pattern647 (x2))
        {
        case 0:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V32HFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2684; /* *subv32hf3_mask_round */

        case 1:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V16HFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2692; /* *subv16hf3_mask_round */

        case 2:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8HFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && ((V8HFmode == V16SFmode
							       || V8HFmode == V8DFmode
							       || V8HFmode == V8DImode
							       || V8HFmode == V16SImode
							       || V8HFmode == V32HImode
							       || V8HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8HFmode == V8SFmode
								       || V8HFmode == V4DFmode
								       || V8HFmode == V4DImode
								       || V8HFmode == V8SImode
								       || V8HFmode == V16HImode
								       || V8HFmode == V16HFmode)))) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2700; /* *subv8hf3_mask_round */

        case 3:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V16SFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2708; /* *subv16sf3_mask_round */

        case 4:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8SFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2716; /* *subv8sf3_mask_round */

        case 5:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V4SFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && ((V4SFmode == V16SFmode
							       || V4SFmode == V8DFmode
							       || V4SFmode == V8DImode
							       || V4SFmode == V16SImode
							       || V4SFmode == V32HImode
							       || V4SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4SFmode == V8SFmode
								       || V4SFmode == V4DFmode
								       || V4SFmode == V4DImode
								       || V4SFmode == V8SImode
								       || V4SFmode == V16HImode
								       || V4SFmode == V16HFmode)))))))
            return -1;
          return 2724; /* *subv4sf3_mask_round */

        case 6:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V8DFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2732; /* *subv8df3_mask_round */

        case 7:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V4DFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2740; /* *subv4df3_mask_round */

        case 8:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2660 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MINUS, V2DFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && ((V2DFmode == V16SFmode
							       || V2DFmode == V8DFmode
							       || V2DFmode == V8DImode
							       || V2DFmode == V16SImode
							       || V2DFmode == V32HImode
							       || V2DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V2DFmode == V8SFmode
								       || V2DFmode == V4DFmode
								       || V2DFmode == V4DImode
								       || V2DFmode == V8SImode
								       || V2DFmode == V16HImode
								       || V2DFmode == V16HFmode)))) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2748; /* *subv2df3_mask_round */

        case 9:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2760; /* avx512fp16_vmsubv8hf3_round */

        case 10:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2768; /* sse_vmsubv4sf3_round */

        case 11:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2709 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2776; /* sse2_vmsubv2df3_round */

        default:
          return -1;
        }

    case VEC_MERGE:
      return recog_222 (x1, insn, pnum_clobbers);

    case MULT:
      switch (pattern647 (x2))
        {
        case 0:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V32HFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2782; /* *mulv32hf3_mask_round */

        case 1:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16HFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2786; /* *mulv16hf3_mask_round */

        case 2:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8HFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && ((V8HFmode == V16SFmode
							       || V8HFmode == V8DFmode
							       || V8HFmode == V8DImode
							       || V8HFmode == V16SImode
							       || V8HFmode == V32HImode
							       || V8HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8HFmode == V8SFmode
								       || V8HFmode == V4DFmode
								       || V8HFmode == V4DImode
								       || V8HFmode == V8SImode
								       || V8HFmode == V16HImode
								       || V8HFmode == V16HFmode)))) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2790; /* *mulv8hf3_mask_round */

        case 3:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V16SFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2794; /* *mulv16sf3_mask_round */

        case 4:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8SFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2798; /* *mulv8sf3_mask_round */

        case 5:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4SFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && ((V4SFmode == V16SFmode
							       || V4SFmode == V8DFmode
							       || V4SFmode == V8DImode
							       || V4SFmode == V16SImode
							       || V4SFmode == V32HImode
							       || V4SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4SFmode == V8SFmode
								       || V4SFmode == V4DFmode
								       || V4SFmode == V4DImode
								       || V4SFmode == V8SImode
								       || V4SFmode == V16HImode
								       || V4SFmode == V16HFmode)))))))
            return -1;
          return 2802; /* *mulv4sf3_mask_round */

        case 6:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V8DFmode, operands)
   && (64 == 64 || TARGET_AVX512VL) && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 2806; /* *mulv8df3_mask_round */

        case 7:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V4DFmode, operands)
   && (32 == 64 || TARGET_AVX512VL) && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 2810; /* *mulv4df3_mask_round */

        case 8:
          if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2749 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && ix86_binary_operator_ok (MULT, V2DFmode, operands)
   && (16 == 64 || TARGET_AVX512VL) && ((V2DFmode == V16SFmode
							       || V2DFmode == V8DFmode
							       || V2DFmode == V8DImode
							       || V2DFmode == V16SImode
							       || V2DFmode == V32HImode
							       || V2DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V2DFmode == V8SFmode
								       || V2DFmode == V4DFmode
								       || V2DFmode == V4DImode
								       || V2DFmode == V8SImode
								       || V2DFmode == V16HImode
								       || V2DFmode == V16HFmode)))) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))))
            return -1;
          return 2814; /* *mulv2df3_mask_round */

        case 9:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2800 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 2822; /* avx512fp16_vmmulv8hf3_round */

        case 10:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2800 "../../../gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 2830; /* sse_vmmulv4sf3_round */

        case 11:
          if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2800 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 2838; /* sse2_vmmulv2df3_round */

        default:
          return -1;
        }

    case DIV:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x2, 0, 1);
      if (!const_4_or_8_to_11_operand (x7, E_SImode))
        return -1;
      x8 = XEXP (x3, 2);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
          switch (pattern646 (x2))
            {
            case 0:
              if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2800 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 2826; /* avx512fp16_vmdivv8hf3_round */

            case 1:
              if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 2800 "../../../gcc/config/i386/sse.md"
(TARGET_SSE)))
                return -1;
              return 2834; /* sse_vmdivv4sf3_round */

            case 2:
              if (!(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2800 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 2842; /* sse2_vmdivv2df3_round */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern648 (x2))
            {
            case 0:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
                return -1;
              return 2848; /* avx512fp16_divv32hf3_mask_round */

            case 1:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
                return -1;
              return 2852; /* avx512fp16_divv16hf3_mask_round */

            case 2:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                return -1;
              return 2858; /* avx512f_divv16sf3_mask_round */

            case 3:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
                return -1;
              return 2862; /* avx_divv8sf3_mask_round */

            case 4:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                return -1;
              return 2868; /* avx512f_divv8df3_mask_round */

            case 5:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
                return -1;
              return 2872; /* avx_divv4df3_mask_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SQRT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x7 = XVECEXP (x2, 0, 1);
      if (!const_4_or_8_to_11_operand (x7, E_SImode))
        return -1;
      x8 = XEXP (x3, 2);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[3] = x8;
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HFmode:
              if (pattern1398 (x2, 
E_V32HFmode, 
E_SImode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
                return -1;
              return 2907; /* avx512fp16_sqrtv32hf2_mask_round */

            case E_V16HFmode:
              if (pattern1398 (x2, 
E_V16HFmode, 
E_HImode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
                return -1;
              return 2911; /* avx512fp16_sqrtv16hf2_mask_round */

            case E_V16SFmode:
              if (pattern1398 (x2, 
E_V16SFmode, 
E_HImode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                return -1;
              return 2917; /* avx512f_sqrtv16sf2_mask_round */

            case E_V8SFmode:
              if (pattern1398 (x2, 
E_V8SFmode, 
E_QImode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
                return -1;
              return 2921; /* avx_sqrtv8sf2_mask_round */

            case E_V8DFmode:
              if (pattern1398 (x2, 
E_V8DFmode, 
E_QImode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (64 == 64 || TARGET_AVX512VL) && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
                return -1;
              return 2927; /* avx512f_sqrtv8df2_mask_round */

            case E_V4DFmode:
              if (pattern1398 (x2, 
E_V4DFmode, 
E_QImode) != 0
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3064 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && (32 == 64 || TARGET_AVX512VL) && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
                return -1;
              return 2931; /* avx_sqrtv4df2_mask_round */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x8, 0) != 1L)
            return -1;
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern1399 (x2, 
E_V8HFmode) != 0
                  || !(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3082 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
                return -1;
              return 2935; /* avx512fp16_vmsqrtv8hf2_round */

            case E_V4SFmode:
              if (pattern1399 (x2, 
E_V4SFmode) != 0
                  || !(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3082 "../../../gcc/config/i386/sse.md"
(TARGET_SSE)))
                return -1;
              return 2939; /* sse_vmsqrtv4sf2_round */

            case E_V2DFmode:
              if (pattern1399 (x2, 
E_V2DFmode) != 0
                  || !(
#line 444 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3082 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
                return -1;
              return 2943; /* sse2_vmsqrtv2df2_round */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      return recog_225 (x1, insn, pnum_clobbers);

    case SMAX:
      switch (pattern649 (x2))
        {
        case 0:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2991; /* *smaxv32hf3_mask_round */

        case 1:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 2999; /* *smaxv16hf3_mask_round */

        case 2:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 3011; /* *smaxv16sf3_mask_round */

        case 3:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 3019; /* *smaxv8sf3_mask_round */

        case 4:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 3031; /* *smaxv8df3_mask_round */

        case 5:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 3039; /* *smaxv4df3_mask_round */

        case 6:
          if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 3129; /* *avx512fp16_vmsmaxv8hf3_round */

        case 7:
          if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 3137; /* *sse_vmsmaxv4sf3_round */

        case 8:
          if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3145; /* *sse2_vmsmaxv2df3_round */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern649 (x2))
        {
        case 0:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && ((V32HFmode == V16SFmode
									       || V32HFmode == V8DFmode
									       || V32HFmode == V8DImode
									       || V32HFmode == V16SImode
									       || V32HFmode == V32HImode
									       || V32HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HFmode == V8SFmode
										       || V32HFmode == V4DFmode
										       || V32HFmode == V4DImode
										       || V32HFmode == V8SImode
										       || V32HFmode == V16HImode
										       || V32HFmode == V16HFmode)))) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))))
            return -1;
          return 2995; /* *sminv32hf3_mask_round */

        case 1:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && ((V16HFmode == V16SFmode
									       || V16HFmode == V8DFmode
									       || V16HFmode == V8DImode
									       || V16HFmode == V16SImode
									       || V16HFmode == V32HImode
									       || V16HFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HFmode == V8SFmode
										       || V16HFmode == V4DFmode
										       || V16HFmode == V4DImode
										       || V16HFmode == V8SImode
										       || V16HFmode == V16HImode
										       || V16HFmode == V16HFmode)))) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))))
            return -1;
          return 3003; /* *sminv16hf3_mask_round */

        case 2:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && ((V16SFmode == V16SFmode
									       || V16SFmode == V8DFmode
									       || V16SFmode == V8DImode
									       || V16SFmode == V16SImode
									       || V16SFmode == V32HImode
									       || V16SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SFmode == V8SFmode
										       || V16SFmode == V4DFmode
										       || V16SFmode == V4DImode
										       || V16SFmode == V8SImode
										       || V16SFmode == V16HImode
										       || V16SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 3015; /* *sminv16sf3_mask_round */

        case 3:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && ((V8SFmode == V16SFmode
									       || V8SFmode == V8DFmode
									       || V8SFmode == V8DImode
									       || V8SFmode == V16SImode
									       || V8SFmode == V32HImode
									       || V8SFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SFmode == V8SFmode
										       || V8SFmode == V4DFmode
										       || V8SFmode == V4DImode
										       || V8SFmode == V8SImode
										       || V8SFmode == V16HImode
										       || V8SFmode == V16HFmode)))) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 3023; /* *sminv8sf3_mask_round */

        case 4:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (64 == 64 || TARGET_AVX512VL)
   && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 3035; /* *sminv8df3_mask_round */

        case 5:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3305 "../../../gcc/config/i386/sse.md"
(TARGET_SSE
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && (32 == 64 || TARGET_AVX512VL)
   && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
            return -1;
          return 3043; /* *sminv4df3_mask_round */

        case 6:
          if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 478 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16))))
            return -1;
          return 3133; /* *avx512fp16_vmsminv8hf3_round */

        case 7:
          if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE)))
            return -1;
          return 3141; /* *sse_vmsminv4sf3_round */

        case 8:
          if (!(
#line 486 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 3466 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 479 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2))))
            return -1;
          return 3149; /* *sse2_vmsminv2df3_round */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_224 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_223 (x1, insn, pnum_clobbers);

    case FLOAT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x8 = XEXP (x3, 2);
      operands[3] = x8;
      x7 = XVECEXP (x2, 0, 1);
      operands[4] = x7;
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HFmode:
          switch (pattern1303 (x2))
            {
            case 0:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
							       || V16HImode == V8DFmode
							       || V16HImode == V8DImode
							       || V16HImode == V16SImode
							       || V16HImode == V32HImode
							       || V16HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HImode == V8SFmode
								       || V16HImode == V4DFmode
								       || V16HImode == V4DImode
								       || V16HImode == V8SImode
								       || V16HImode == V16HImode
								       || V16HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4483; /* avx512fp16_vcvtw2ph_v16hi_mask_round */

            case 1:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
							       || V16SImode == V8DFmode
							       || V16SImode == V8DImode
							       || V16SImode == V16SImode
							       || V16SImode == V32HImode
							       || V16SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SImode == V8SFmode
								       || V16SImode == V4DFmode
								       || V16SImode == V4DImode
								       || V16SImode == V8SImode
								       || V16SImode == V16HImode
								       || V16SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4507; /* avx512fp16_vcvtdq2ph_v16si_mask_round */

            default:
              return -1;
            }

        case E_V32HFmode:
          if (pattern650 (x2, 
E_V32HFmode, 
E_V32HImode, 
E_SImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
							       || V32HImode == V8DFmode
							       || V32HImode == V8DImode
							       || V32HImode == V16SImode
							       || V32HImode == V32HImode
							       || V32HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HImode == V8SFmode
								       || V32HImode == V4DFmode
								       || V32HImode == V4DImode
								       || V32HImode == V8SImode
								       || V32HImode == V16HImode
								       || V32HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4491; /* avx512fp16_vcvtw2ph_v32hi_mask_round */

        case E_V8HFmode:
          switch (pattern1304 (x2))
            {
            case 0:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
							       || V8SImode == V8DFmode
							       || V8SImode == V8DImode
							       || V8SImode == V16SImode
							       || V8SImode == V32HImode
							       || V8SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SImode == V8SFmode
								       || V8SImode == V4DFmode
								       || V8SImode == V4DImode
								       || V8SImode == V8SImode
								       || V8SImode == V16HImode
								       || V8SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4499; /* avx512fp16_vcvtdq2ph_v8si_mask_round */

            case 1:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4515; /* avx512fp16_vcvtqq2ph_v8di_mask_round */

            default:
              return -1;
            }

        case E_V16SFmode:
          if (pattern650 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8650 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))))
            return -1;
          return 4812; /* floatv16siv16sf2_mask_round */

        case E_V8SFmode:
          switch (pattern1305 (x2))
            {
            case 0:
              if (!register_operand (operands[1], E_V8SImode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8650 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 433 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))))
                return -1;
              return 4816; /* floatv8siv8sf2_mask_round */

            case 1:
              if (!nonimmediate_operand (operands[1], E_V8DImode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4970; /* floatv8div8sf2_mask_round */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (pattern1306 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9184 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4950; /* floatv8div8df2_mask_round */

        case E_V4DFmode:
          if (pattern1306 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9184 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4958; /* floatv4div4df2_mask_round */

        case E_V4SFmode:
          if (pattern1306 (x2, 
E_V4SFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DImode == V16SFmode
							       || V4DImode == V8DFmode
							       || V4DImode == V8DImode
							       || V4DImode == V16SImode
							       || V4DImode == V32HImode
							       || V4DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DImode == V8SFmode
								       || V4DImode == V4DFmode
								       || V4DImode == V4DImode
								       || V4DImode == V8SImode
								       || V4DImode == V16HImode
								       || V4DImode == V16HFmode)))) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4978; /* floatv4div4sf2_mask_round */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x8 = XEXP (x3, 2);
      operands[3] = x8;
      x7 = XVECEXP (x2, 0, 1);
      operands[4] = x7;
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16HFmode:
          switch (pattern1303 (x2))
            {
            case 0:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
							       || V16HImode == V8DFmode
							       || V16HImode == V8DImode
							       || V16HImode == V16SImode
							       || V16HImode == V32HImode
							       || V16HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HImode == V8SFmode
								       || V16HImode == V4DFmode
								       || V16HImode == V4DImode
								       || V16HImode == V8SImode
								       || V16HImode == V16HImode
								       || V16HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4487; /* avx512fp16_vcvtuw2ph_v16hi_mask_round */

            case 1:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
							       || V16SImode == V8DFmode
							       || V16SImode == V8DImode
							       || V16SImode == V16SImode
							       || V16SImode == V32HImode
							       || V16SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SImode == V8SFmode
								       || V16SImode == V4DFmode
								       || V16SImode == V4DImode
								       || V16SImode == V8SImode
								       || V16SImode == V16HImode
								       || V16SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4511; /* avx512fp16_vcvtudq2ph_v16si_mask_round */

            default:
              return -1;
            }

        case E_V32HFmode:
          if (pattern650 (x2, 
E_V32HFmode, 
E_V32HImode, 
E_SImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
							       || V32HImode == V8DFmode
							       || V32HImode == V8DImode
							       || V32HImode == V16SImode
							       || V32HImode == V32HImode
							       || V32HImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HImode == V8SFmode
								       || V32HImode == V4DFmode
								       || V32HImode == V4DImode
								       || V32HImode == V8SImode
								       || V32HImode == V16HImode
								       || V32HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4495; /* avx512fp16_vcvtuw2ph_v32hi_mask_round */

        case E_V8HFmode:
          switch (pattern1304 (x2))
            {
            case 0:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
							       || V8SImode == V8DFmode
							       || V8SImode == V8DImode
							       || V8SImode == V16SImode
							       || V8SImode == V32HImode
							       || V8SImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SImode == V8SFmode
								       || V8SImode == V4DFmode
								       || V8SImode == V4DImode
								       || V8SImode == V8SImode
								       || V8SImode == V16HImode
								       || V8SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4503; /* avx512fp16_vcvtudq2ph_v8si_mask_round */

            case 1:
              if (!(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7646 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4519; /* avx512fp16_vcvtuqq2ph_v8di_mask_round */

            default:
              return -1;
            }

        case E_V16SFmode:
          if (pattern1306 (x2, 
E_V16SFmode, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8663 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 539 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4822; /* floatunsv16siv16sf2_mask_round */

        case E_V8SFmode:
          switch (pattern1305 (x2))
            {
            case 0:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8663 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 539 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4826; /* floatunsv8siv8sf2_mask_round */

            case 1:
              if (!nonimmediate_operand (operands[1], E_V8DImode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DImode == V16SFmode
							       || V8DImode == V8DFmode
							       || V8DImode == V8DImode
							       || V8DImode == V16SImode
							       || V8DImode == V32HImode
							       || V8DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DImode == V8SFmode
								       || V8DImode == V4DFmode
								       || V8DImode == V4DImode
								       || V8DImode == V8SImode
								       || V8DImode == V16HImode
								       || V8DImode == V16HFmode)))) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4974; /* floatunsv8div8sf2_mask_round */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (pattern1306 (x2, 
E_V8DFmode, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9184 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4954; /* floatunsv8div8df2_mask_round */

        case E_V4DFmode:
          if (pattern1306 (x2, 
E_V4DFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9184 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
							       || V4DFmode == V8DFmode
							       || V4DFmode == V8DImode
							       || V4DFmode == V16SImode
							       || V4DFmode == V32HImode
							       || V4DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DFmode == V8SFmode
								       || V4DFmode == V4DFmode
								       || V4DFmode == V4DImode
								       || V4DFmode == V8SImode
								       || V4DFmode == V16HImode
								       || V4DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4962; /* floatunsv4div4df2_mask_round */

        case E_V4SFmode:
          if (pattern1306 (x2, 
E_V4SFmode, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9198 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DImode == V16SFmode
							       || V4DImode == V8DFmode
							       || V4DImode == V8DImode
							       || V4DImode == V16SImode
							       || V4DImode == V32HImode
							       || V4DImode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V4DImode == V8SFmode
								       || V4DImode == V4DFmode
								       || V4DImode == V4DImode
								       || V4DImode == V8SImode
								       || V4DImode == V16HImode
								       || V4DImode == V16HFmode)))) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4982; /* floatunsv4div4sf2_mask_round */

        default:
          return -1;
        }

    case FIX:
      switch (pattern652 (x2))
        {
        case 0:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
									       || V16HImode == V8DFmode
									       || V16HImode == V8DImode
									       || V16HImode == V16SImode
									       || V16HImode == V32HImode
									       || V16HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HImode == V8SFmode
										       || V16HImode == V4DFmode
										       || V16HImode == V4DImode
										       || V16HImode == V8SImode
										       || V16HImode == V16HImode
										       || V16HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4611; /* avx512fp16_fix_truncv16hi2_mask_round */

        case 1:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
									       || V32HImode == V8DFmode
									       || V32HImode == V8DImode
									       || V32HImode == V16SImode
									       || V32HImode == V32HImode
									       || V32HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HImode == V8SFmode
										       || V32HImode == V4DFmode
										       || V32HImode == V4DImode
										       || V32HImode == V8SImode
										       || V32HImode == V16HImode
										       || V32HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4619; /* avx512fp16_fix_truncv32hi2_mask_round */

        case 2:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
									       || V8SImode == V8DFmode
									       || V8SImode == V8DImode
									       || V8SImode == V16SImode
									       || V8SImode == V32HImode
									       || V8SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SImode == V8SFmode
										       || V8SImode == V4DFmode
										       || V8SImode == V4DImode
										       || V8SImode == V8SImode
										       || V8SImode == V16HImode
										       || V8SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4627; /* avx512fp16_fix_truncv8si2_mask_round */

        case 3:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 5033; /* fix_truncv8dfv8si2_mask_round */

        case 4:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
									       || V16SImode == V8DFmode
									       || V16SImode == V8DImode
									       || V16SImode == V16SImode
									       || V16SImode == V32HImode
									       || V16SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SImode == V8SFmode
										       || V16SImode == V4DFmode
										       || V16SImode == V4DImode
										       || V16SImode == V8SImode
										       || V16SImode == V16HImode
										       || V16SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4635; /* avx512fp16_fix_truncv16si2_mask_round */

        case 5:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8786 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4880; /* fix_truncv16sfv16si2_mask_round */

        case 6:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4643; /* avx512fp16_fix_truncv8di2_mask_round */

        case 7:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 5078; /* fix_truncv8dfv8di2_mask_round */

        case 8:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 5086; /* fix_truncv4dfv4di2_mask_round */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern652 (x2))
        {
        case 0:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16HImode == V16SFmode
									       || V16HImode == V8DFmode
									       || V16HImode == V8DImode
									       || V16HImode == V16SImode
									       || V16HImode == V32HImode
									       || V16HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16HImode == V8SFmode
										       || V16HImode == V4DFmode
										       || V16HImode == V4DImode
										       || V16HImode == V8SImode
										       || V16HImode == V16HImode
										       || V16HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4615; /* avx512fp16_fixuns_truncv16hi2_mask_round */

        case 1:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V32HImode == V16SFmode
									       || V32HImode == V8DFmode
									       || V32HImode == V8DImode
									       || V32HImode == V16SImode
									       || V32HImode == V32HImode
									       || V32HImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V32HImode == V8SFmode
										       || V32HImode == V4DFmode
										       || V32HImode == V4DImode
										       || V32HImode == V8SImode
										       || V32HImode == V16HImode
										       || V32HImode == V16HFmode)))) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4623; /* avx512fp16_fixuns_truncv32hi2_mask_round */

        case 2:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SImode == V16SFmode
									       || V8SImode == V8DFmode
									       || V8SImode == V8DImode
									       || V8SImode == V16SImode
									       || V8SImode == V32HImode
									       || V8SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8SImode == V8SFmode
										       || V8SImode == V4DFmode
										       || V8SImode == V4DImode
										       || V8SImode == V8SImode
										       || V8SImode == V16HImode
										       || V8SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 4631; /* avx512fp16_fixuns_truncv8si2_mask_round */

        case 3:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 9581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 5037; /* fixuns_truncv8dfv8si2_mask_round */

        case 4:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SImode == V16SFmode
									       || V16SImode == V8DFmode
									       || V16SImode == V8DImode
									       || V16SImode == V16SImode
									       || V16SImode == V32HImode
									       || V16SImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V16SImode == V8SFmode
										       || V16SImode == V4DFmode
										       || V16SImode == V4DImode
										       || V16SImode == V8SImode
										       || V16SImode == V16HImode
										       || V16SImode == V16HFmode)))) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4639; /* avx512fp16_fixuns_truncv16si2_mask_round */

        case 5:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 8786 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 4884; /* fixuns_truncv16sfv16si2_mask_round */

        case 6:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DImode == V16SFmode
									       || V8DImode == V8DFmode
									       || V8DImode == V8DImode
									       || V8DImode == V16SImode
									       || V8DImode == V32HImode
									       || V8DImode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DImode == V8SFmode
										       || V8DImode == V4DFmode
										       || V8DImode == V4DImode
										       || V8DImode == V8SImode
										       || V8DImode == V16HImode
										       || V8DImode == V16HFmode)))) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4647; /* avx512fp16_fixuns_truncv8di2_mask_round */

        case 7:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V8DFmode == V16SFmode
									       || V8DFmode == V8DFmode
									       || V8DFmode == V8DImode
									       || V8DFmode == V16SImode
									       || V8DFmode == V32HImode
									       || V8DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V8DFmode == V8SFmode
										       || V8DFmode == V4DFmode
										       || V8DFmode == V4DImode
										       || V8DFmode == V8SImode
										       || V8DFmode == V16HImode
										       || V8DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 5082; /* fixuns_truncv8dfv8di2_mask_round */

        case 8:
          if (!(
#line 286 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && ((V4DFmode == V16SFmode
									       || V4DFmode == V8DFmode
									       || V4DFmode == V8DImode
									       || V4DFmode == V16SImode
									       || V4DFmode == V32HImode
									       || V4DFmode == V32HFmode)
									       || (TARGET_AVX10_2_256
										   && (V4DFmode == V8SFmode
										       || V4DFmode == V4DFmode
										       || V4DFmode == V4DImode
										       || V4DFmode == V8SImode
										       || V4DFmode == V16HImode
										       || V4DFmode == V16HFmode)))) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
            return -1;
          return 5090; /* fixuns_truncv4dfv4di2_mask_round */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      return recog_226 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x3, 1);
      operands[2] = x9;
      x8 = XEXP (x3, 2);
      operands[3] = x8;
      x7 = XVECEXP (x2, 0, 1);
      operands[4] = x7;
      if (!const_4_or_8_to_11_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern1307 (x2, 
E_QImode, 
E_V8HFmode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8DFmode == V16SFmode
							       || V8DFmode == V8DFmode
							       || V8DFmode == V8DImode
							       || V8DFmode == V16SImode
							       || V8DFmode == V32HImode
							       || V8DFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8DFmode == V8SFmode
								       || V8DFmode == V4DFmode
								       || V8DFmode == V4DImode
								       || V8DFmode == V8SImode
								       || V8DFmode == V16HImode
								       || V8DFmode == V16HFmode)))) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
                return -1;
              return 4737; /* avx512fp16_vcvtpd2ph_v8df_mask_round */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V8SFmode == V16SFmode
							       || V8SFmode == V8DFmode
							       || V8SFmode == V8DImode
							       || V8SFmode == V16SImode
							       || V8SFmode == V32HImode
							       || V8SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V8SFmode == V8SFmode
								       || V8SFmode == V4DFmode
								       || V8SFmode == V4DImode
								       || V8SFmode == V8SImode
								       || V8SFmode == V16HImode
								       || V8SFmode == V16HFmode)))) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))))
                return -1;
              return 4745; /* avx512fp16_vcvtps2ph_v8sf_mask_round */

            default:
              return -1;
            }

        case E_V16HFmode:
          if (pattern650 (x2, 
E_V16HFmode, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && ((V16SFmode == V16SFmode
							       || V16SFmode == V8DFmode
							       || V16SFmode == V8DImode
							       || V16SFmode == V16SImode
							       || V16SFmode == V32HImode
							       || V16SFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16SFmode == V8SFmode
								       || V16SFmode == V4DFmode
								       || V16SFmode == V4DImode
								       || V16SFmode == V8SImode
								       || V16SFmode == V16HImode
								       || V16SFmode == V16HFmode)))) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))))
            return -1;
          return 4741; /* avx512fp16_vcvtps2ph_v16sf_mask_round */

        case E_V8SFmode:
          if (pattern650 (x2, 
E_V8SFmode, 
E_V8DFmode, 
E_QImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10099 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))))
            return -1;
          return 5175; /* avx512f_cvtpd2ps512_mask_round */

        case E_V4SFmode:
          if (pattern650 (x2, 
E_V4SFmode, 
E_V4DFmode, 
E_QImode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10109 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL
   && (!true || TARGET_AVX10_2_256)))))
            return -1;
          return 5179; /* avx_cvtpd2ps256_mask_round */

        default:
          return -1;
        }

    case VEC_CONCAT:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != FLOAT_TRUNCATE)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != FLOAT_TRUNCATE)
        return -1;
      x10 = XEXP (x5, 0);
      operands[2] = x10;
      x11 = XEXP (x6, 0);
      operands[1] = x11;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      x8 = XEXP (x3, 2);
      operands[4] = x8;
      x7 = XVECEXP (x2, 0, 1);
      operands[5] = x7;
      if (!const_4_or_8_to_11_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HFmode:
          if (pattern1515 (x2, 
E_SImode, 
E_V32HFmode, 
E_V16SFmode, 
E_V16HFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V32HFmode == V16SFmode
							       || V32HFmode == V8DFmode
							       || V32HFmode == V8DImode
							       || V32HFmode == V16SImode
							       || V32HFmode == V32HImode
							       || V32HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V32HFmode == V8SFmode
								       || V32HFmode == V4DFmode
								       || V32HFmode == V4DImode
								       || V32HFmode == V8SImode
								       || V32HFmode == V16HImode
								       || V32HFmode == V16HFmode)))) && 
#line 561 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))))
            return -1;
          return 10437; /* avx10_2_cvt2ps2phx_v32hf_mask_round */

        case E_V16HFmode:
          if (pattern1515 (x2, 
E_HImode, 
E_V16HFmode, 
E_V8SFmode, 
E_V8HFmode) != 0
              || !(
#line 234 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 31719 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256 && ((V16HFmode == V16SFmode
							       || V16HFmode == V8DFmode
							       || V16HFmode == V8DImode
							       || V16HFmode == V16SImode
							       || V16HFmode == V32HImode
							       || V16HFmode == V32HFmode)
							       || (TARGET_AVX10_2_256
								   && (V16HFmode == V8SFmode
								       || V16HFmode == V4DFmode
								       || V16HFmode == V4DImode
								       || V16HFmode == V8SImode
								       || V16HFmode == V16HImode
								       || V16HFmode == V16HFmode)))))))
            return -1;
          return 10441; /* avx10_2_cvt2ps2phx_v16hf_mask_round */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_283 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern671 (x3) != 0)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 0);
  switch (XWINT (x6, 0))
    {
    case 8L:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 40L)
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      if (XWINT (x8, 0) != 9L)
        return -1;
      x9 = XVECEXP (x3, 0, 3);
      if (XWINT (x9, 0) != 41L)
        return -1;
      x10 = XVECEXP (x3, 0, 4);
      if (XWINT (x10, 0) != 10L)
        return -1;
      x11 = XVECEXP (x3, 0, 5);
      if (XWINT (x11, 0) != 42L)
        return -1;
      x12 = XVECEXP (x3, 0, 6);
      if (XWINT (x12, 0) != 11L)
        return -1;
      x13 = XVECEXP (x3, 0, 7);
      if (XWINT (x13, 0) != 43L
          || pattern1875 (x3) != 0)
        return -1;
      x14 = XVECEXP (x3, 0, 16);
      if (XWINT (x14, 0) != 24L)
        return -1;
      x15 = XVECEXP (x3, 0, 17);
      if (XWINT (x15, 0) != 56L)
        return -1;
      x16 = XVECEXP (x3, 0, 18);
      if (XWINT (x16, 0) != 25L)
        return -1;
      x17 = XVECEXP (x3, 0, 19);
      if (XWINT (x17, 0) != 57L)
        return -1;
      x18 = XVECEXP (x3, 0, 20);
      if (XWINT (x18, 0) != 26L)
        return -1;
      x19 = XVECEXP (x3, 0, 21);
      if (XWINT (x19, 0) != 58L)
        return -1;
      x20 = XVECEXP (x3, 0, 22);
      if (XWINT (x20, 0) != 27L)
        return -1;
      x21 = XVECEXP (x3, 0, 23);
      if (XWINT (x21, 0) != 59L
          || pattern1881 (x3) != 0
          || pattern1411 (x2, 
E_V32QImode, 
E_V64QImode) != 0
          || !
#line 19465 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
        return -1;
      return 8319; /* avx2_interleave_highv32qi */

    case 0L:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 32L)
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      if (XWINT (x8, 0) != 1L)
        return -1;
      x9 = XVECEXP (x3, 0, 3);
      if (XWINT (x9, 0) != 33L)
        return -1;
      x10 = XVECEXP (x3, 0, 4);
      if (XWINT (x10, 0) != 2L)
        return -1;
      x11 = XVECEXP (x3, 0, 5);
      if (XWINT (x11, 0) != 34L)
        return -1;
      x12 = XVECEXP (x3, 0, 6);
      if (XWINT (x12, 0) != 3L)
        return -1;
      x13 = XVECEXP (x3, 0, 7);
      if (XWINT (x13, 0) != 35L)
        return -1;
      x14 = XVECEXP (x3, 0, 16);
      if (XWINT (x14, 0) != 16L)
        return -1;
      x15 = XVECEXP (x3, 0, 17);
      if (XWINT (x15, 0) != 48L)
        return -1;
      x16 = XVECEXP (x3, 0, 18);
      if (XWINT (x16, 0) != 17L)
        return -1;
      x17 = XVECEXP (x3, 0, 19);
      if (XWINT (x17, 0) != 49L)
        return -1;
      x18 = XVECEXP (x3, 0, 20);
      if (XWINT (x18, 0) != 18L)
        return -1;
      x19 = XVECEXP (x3, 0, 21);
      if (XWINT (x19, 0) != 50L)
        return -1;
      x20 = XVECEXP (x3, 0, 22);
      if (XWINT (x20, 0) != 19L)
        return -1;
      x21 = XVECEXP (x3, 0, 23);
      if (XWINT (x21, 0) != 51L)
        return -1;
      x22 = XVECEXP (x3, 0, 8);
      switch (XWINT (x22, 0))
        {
        case 4L:
          x23 = XVECEXP (x3, 0, 9);
          if (XWINT (x23, 0) != 36L)
            return -1;
          x24 = XVECEXP (x3, 0, 10);
          if (XWINT (x24, 0) != 5L)
            return -1;
          x25 = XVECEXP (x3, 0, 11);
          if (XWINT (x25, 0) != 37L)
            return -1;
          x26 = XVECEXP (x3, 0, 12);
          if (XWINT (x26, 0) != 6L)
            return -1;
          x27 = XVECEXP (x3, 0, 13);
          if (XWINT (x27, 0) != 38L)
            return -1;
          x28 = XVECEXP (x3, 0, 14);
          if (XWINT (x28, 0) != 7L)
            return -1;
          x29 = XVECEXP (x3, 0, 15);
          if (XWINT (x29, 0) != 39L)
            return -1;
          x30 = XVECEXP (x3, 0, 24);
          if (XWINT (x30, 0) != 20L)
            return -1;
          x31 = XVECEXP (x3, 0, 25);
          if (XWINT (x31, 0) != 52L)
            return -1;
          x32 = XVECEXP (x3, 0, 26);
          if (XWINT (x32, 0) != 21L)
            return -1;
          x33 = XVECEXP (x3, 0, 27);
          if (XWINT (x33, 0) != 53L)
            return -1;
          x34 = XVECEXP (x3, 0, 28);
          if (XWINT (x34, 0) != 22L)
            return -1;
          x35 = XVECEXP (x3, 0, 29);
          if (XWINT (x35, 0) != 54L)
            return -1;
          x36 = XVECEXP (x3, 0, 30);
          if (XWINT (x36, 0) != 23L)
            return -1;
          x37 = XVECEXP (x3, 0, 31);
          if (XWINT (x37, 0) != 55L
              || pattern1411 (x2, 
E_V32QImode, 
E_V64QImode) != 0
              || !
#line 19561 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
            return -1;
          return 8325; /* avx2_interleave_lowv32qi */

        case 8L:
          x23 = XVECEXP (x3, 0, 9);
          if (XWINT (x23, 0) != 40L)
            return -1;
          x24 = XVECEXP (x3, 0, 10);
          if (XWINT (x24, 0) != 9L)
            return -1;
          x25 = XVECEXP (x3, 0, 11);
          if (XWINT (x25, 0) != 41L)
            return -1;
          x26 = XVECEXP (x3, 0, 12);
          if (XWINT (x26, 0) != 10L)
            return -1;
          x27 = XVECEXP (x3, 0, 13);
          if (XWINT (x27, 0) != 42L)
            return -1;
          x28 = XVECEXP (x3, 0, 14);
          if (XWINT (x28, 0) != 11L)
            return -1;
          x29 = XVECEXP (x3, 0, 15);
          if (XWINT (x29, 0) != 43L)
            return -1;
          x30 = XVECEXP (x3, 0, 24);
          if (XWINT (x30, 0) != 24L)
            return -1;
          x31 = XVECEXP (x3, 0, 25);
          if (XWINT (x31, 0) != 56L)
            return -1;
          x32 = XVECEXP (x3, 0, 26);
          if (XWINT (x32, 0) != 25L)
            return -1;
          x33 = XVECEXP (x3, 0, 27);
          if (XWINT (x33, 0) != 57L)
            return -1;
          x34 = XVECEXP (x3, 0, 28);
          if (XWINT (x34, 0) != 26L)
            return -1;
          x35 = XVECEXP (x3, 0, 29);
          if (XWINT (x35, 0) != 58L)
            return -1;
          x36 = XVECEXP (x3, 0, 30);
          if (XWINT (x36, 0) != 27L)
            return -1;
          x37 = XVECEXP (x3, 0, 31);
          if (XWINT (x37, 0) != 59L)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V32HImode:
              if (pattern1411 (x2, 
E_V32HImode, 
E_V64HImode) != 0
                  || !(
#line 19681 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8347; /* *avx512bw_interleave_lowv32hi */

            case E_V32HFmode:
              if (pattern1411 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
                  || !(
#line 19681 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8349; /* *avx512bw_interleave_lowv32hf */

            case E_V32BFmode:
              if (pattern1411 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
                  || !(
#line 19681 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 8351; /* *avx512bw_interleave_lowv32bf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4L:
      x7 = XVECEXP (x3, 0, 1);
      if (XWINT (x7, 0) != 36L)
        return -1;
      x8 = XVECEXP (x3, 0, 2);
      if (XWINT (x8, 0) != 5L)
        return -1;
      x9 = XVECEXP (x3, 0, 3);
      if (XWINT (x9, 0) != 37L)
        return -1;
      x10 = XVECEXP (x3, 0, 4);
      if (XWINT (x10, 0) != 6L)
        return -1;
      x11 = XVECEXP (x3, 0, 5);
      if (XWINT (x11, 0) != 38L)
        return -1;
      x12 = XVECEXP (x3, 0, 6);
      if (XWINT (x12, 0) != 7L)
        return -1;
      x13 = XVECEXP (x3, 0, 7);
      if (XWINT (x13, 0) != 39L
          || pattern1875 (x3) != 0)
        return -1;
      x14 = XVECEXP (x3, 0, 16);
      if (XWINT (x14, 0) != 20L)
        return -1;
      x15 = XVECEXP (x3, 0, 17);
      if (XWINT (x15, 0) != 52L)
        return -1;
      x16 = XVECEXP (x3, 0, 18);
      if (XWINT (x16, 0) != 21L)
        return -1;
      x17 = XVECEXP (x3, 0, 19);
      if (XWINT (x17, 0) != 53L)
        return -1;
      x18 = XVECEXP (x3, 0, 20);
      if (XWINT (x18, 0) != 22L)
        return -1;
      x19 = XVECEXP (x3, 0, 21);
      if (XWINT (x19, 0) != 54L)
        return -1;
      x20 = XVECEXP (x3, 0, 22);
      if (XWINT (x20, 0) != 23L)
        return -1;
      x21 = XVECEXP (x3, 0, 23);
      if (XWINT (x21, 0) != 55L
          || pattern1881 (x3) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V32HImode:
          if (pattern1411 (x2, 
E_V32HImode, 
E_V64HImode) != 0
              || !(
#line 19613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8329; /* avx512bw_interleave_highv32hi */

        case E_V32HFmode:
          if (pattern1411 (x2, 
E_V32HFmode, 
E_V64HFmode) != 0
              || !(
#line 19613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8331; /* avx512bw_interleave_highv32hf */

        case E_V32BFmode:
          if (pattern1411 (x2, 
E_V32BFmode, 
E_V64BFmode) != 0
              || !(
#line 19613 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 1032 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8333; /* avx512bw_interleave_highv32bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_299 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x6 = XVECEXP (x4, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8SFmode:
          if (!register_operand (operands[0], E_V8SFmode)
              || GET_MODE (x2) != E_V8SFmode
              || GET_MODE (x3) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SFmode:
              if (register_operand (operands[1], E_V4SFmode)
                  && (
#line 11726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 440 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 5280; /* avx2_vec_dupv8sf */
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 27726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9197; /* avx512vl_vec_dupv8sf */

            case E_V8SFmode:
              if (!register_operand (operands[1], E_V8SFmode)
                  || !
#line 11738 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 5282; /* avx2_vec_dupv8sf_1 */

            default:
              return -1;
            }

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode
              || GET_MODE (x3) != E_SFmode)
            return -1;
          if (register_operand (operands[1], E_V4SFmode)
              && 
#line 11726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 5281; /* avx2_vec_dupv4sf */
          if (!nonimmediate_operand (operands[1], E_V4SFmode)
              || !(
#line 27726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9199; /* avx512vl_vec_dupv4sf */

        case E_V16SFmode:
          if (!register_operand (operands[0], E_V16SFmode)
              || GET_MODE (x2) != E_V16SFmode
              || GET_MODE (x3) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16SFmode:
              if (!register_operand (operands[1], E_V16SFmode)
                  || !(
#line 11750 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 487 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 5283; /* avx512f_vec_dupv16sf_1 */

            case E_V4SFmode:
              if (!nonimmediate_operand (operands[1], E_V4SFmode)
                  || !(
#line 27726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 296 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9195; /* avx512f_vec_dupv16sf */

            default:
              return -1;
            }

        case E_V8DFmode:
          if (!register_operand (operands[0], E_V8DFmode)
              || GET_MODE (x2) != E_V8DFmode
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DFmode:
              if (!register_operand (operands[1], E_V8DFmode)
                  || !(
#line 11750 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 487 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 5284; /* avx512f_vec_dupv8df_1 */

            case E_V2DFmode:
              if (!nonimmediate_operand (operands[1], E_V2DFmode)
                  || !(
#line 27726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9201; /* avx512f_vec_dupv8df */

            default:
              return -1;
            }

        case E_V16SImode:
          if (!register_operand (operands[0], E_V16SImode)
              || GET_MODE (x2) != E_V16SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode))
                return -1;
              if ((
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 577 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 9088; /* avx2_pbroadcastv16si */
              if (!(
#line 27726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9183; /* avx512f_vec_dupv16si */

            case E_V16SImode:
              if (!nonimmediate_operand (operands[1], E_V16SImode)
                  || !(
#line 27712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 976 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9177; /* avx512f_vec_dupv16si_1 */

            default:
              return -1;
            }

        case E_V8DImode:
          if (!register_operand (operands[0], E_V8DImode)
              || GET_MODE (x2) != E_V8DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode))
                return -1;
              if ((
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 578 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
                return 9089; /* avx2_pbroadcastv8di */
              if (!(
#line 27726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9189; /* avx512f_vec_dupv8di */

            case E_V8DImode:
              if (!nonimmediate_operand (operands[1], E_V8DImode)
                  || !(
#line 27712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 976 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9178; /* avx512f_vec_dupv8di_1 */

            default:
              return -1;
            }

        case E_V64QImode:
          if (!register_operand (operands[0], E_V64QImode)
              || GET_MODE (x2) != E_V64QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!nonimmediate_operand (operands[1], E_V16QImode))
                return -1;
              if ((
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 579 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9090; /* avx2_pbroadcastv64qi */
              if (!(
#line 27745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9207; /* avx512bw_vec_dupv64qi */

            case E_V64QImode:
              if (!nonimmediate_operand (operands[1], E_V64QImode)
                  || !(
#line 27712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 978 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 9180; /* avx512bw_vec_dupv64qi_1 */

            default:
              return -1;
            }

        case E_V32QImode:
          if (!register_operand (operands[0], E_V32QImode)
              || GET_MODE (x2) != E_V32QImode
              || GET_MODE (x3) != E_QImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V16QImode:
              if (!nonimmediate_operand (operands[1], E_V16QImode))
                return -1;
              if ((
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 579 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9091; /* avx2_pbroadcastv32qi */
              if (!(
#line 27745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9211; /* avx512vl_vec_dupv32qi */

            case E_V32QImode:
              if (!nonimmediate_operand (operands[1], E_V32QImode)
                  || !
#line 27309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9106; /* avx2_pbroadcastv32qi_1 */

            default:
              return -1;
            }

        case E_V16QImode:
          if (pattern930 (x2, 
E_V16QImode, 
E_QImode) != 0)
            return -1;
          if (
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9092; /* avx2_pbroadcastv16qi */
          if (!(
#line 27745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 321 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9209; /* avx512vl_vec_dupv16qi */

        case E_V32HImode:
          if (!register_operand (operands[0], E_V32HImode)
              || GET_MODE (x2) != E_V32HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              if ((
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 580 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9093; /* avx2_pbroadcastv32hi */
              if (!(
#line 27745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9213; /* avx512bw_vec_dupv32hi */

            case E_V32HImode:
              if (!nonimmediate_operand (operands[1], E_V32HImode)
                  || !(
#line 27712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 977 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 9179; /* avx512bw_vec_dupv32hi_1 */

            default:
              return -1;
            }

        case E_V16HImode:
          if (!register_operand (operands[0], E_V16HImode)
              || GET_MODE (x2) != E_V16HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HImode:
              if (!nonimmediate_operand (operands[1], E_V8HImode))
                return -1;
              if ((
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 580 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9094; /* avx2_pbroadcastv16hi */
              if (!(
#line 27745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9215; /* avx512vl_vec_dupv16hi */

            case E_V16HImode:
              if (!nonimmediate_operand (operands[1], E_V16HImode)
                  || !
#line 27309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9107; /* avx2_pbroadcastv16hi_1 */

            default:
              return -1;
            }

        case E_V8HImode:
          if (pattern930 (x2, 
E_V8HImode, 
E_HImode) != 0)
            return -1;
          if (
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9095; /* avx2_pbroadcastv8hi */
          if (!(
#line 27745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 322 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9217; /* avx512vl_vec_dupv8hi */

        case E_V8SImode:
          if (!register_operand (operands[0], E_V8SImode)
              || GET_MODE (x2) != E_V8SImode
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V4SImode:
              if (!nonimmediate_operand (operands[1], E_V4SImode))
                return -1;
              if ((
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9096; /* avx2_pbroadcastv8si */
              if (!(
#line 27726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9185; /* avx512vl_vec_dupv8si */

            case E_V8SImode:
              if (!nonimmediate_operand (operands[1], E_V8SImode)
                  || !
#line 27309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9108; /* avx2_pbroadcastv8si_1 */

            default:
              return -1;
            }

        case E_V4SImode:
          if (pattern930 (x2, 
E_V4SImode, 
E_SImode) != 0)
            return -1;
          if (
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9097; /* avx2_pbroadcastv4si */
          if (!(
#line 27726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 294 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9187; /* avx512vl_vec_dupv4si */

        case E_V4DImode:
          if (!register_operand (operands[0], E_V4DImode)
              || GET_MODE (x2) != E_V4DImode
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2DImode:
              if (!nonimmediate_operand (operands[1], E_V2DImode))
                return -1;
              if ((
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 582 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9098; /* avx2_pbroadcastv4di */
              if (!(
#line 27726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9191; /* avx512vl_vec_dupv4di */

            case E_V4DImode:
              if (!nonimmediate_operand (operands[1], E_V4DImode)
                  || !
#line 27309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9109; /* avx2_pbroadcastv4di_1 */

            default:
              return -1;
            }

        case E_V2DImode:
          if (pattern930 (x2, 
E_V2DImode, 
E_DImode) != 0)
            return -1;
          if (
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9099; /* avx2_pbroadcastv2di */
          if (!(
#line 27726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9193; /* avx512vl_vec_dupv2di */

        case E_V32HFmode:
          if (!register_operand (operands[0], E_V32HFmode)
              || GET_MODE (x2) != E_V32HFmode
              || GET_MODE (x3) != E_HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!nonimmediate_operand (operands[1], E_V8HFmode))
                return -1;
              if ((
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 583 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9100; /* avx2_pbroadcastv32hf */
              if (!(
#line 27745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9219; /* avx512bw_vec_dupv32hf */

            case E_V32HFmode:
              if (!nonimmediate_operand (operands[1], E_V32HFmode)
                  || !(
#line 27712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 979 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 9181; /* avx512bw_vec_dupv32hf_1 */

            default:
              return -1;
            }

        case E_V16HFmode:
          if (!register_operand (operands[0], E_V16HFmode)
              || GET_MODE (x2) != E_V16HFmode
              || GET_MODE (x3) != E_HFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8HFmode:
              if (!nonimmediate_operand (operands[1], E_V8HFmode))
                return -1;
              if ((
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 583 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9101; /* avx2_pbroadcastv16hf */
              if (!(
#line 27745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9221; /* avx512vl_vec_dupv16hf */

            case E_V16HFmode:
              if (!nonimmediate_operand (operands[1], E_V16HFmode)
                  || !
#line 27309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9110; /* avx2_pbroadcastv16hf_1 */

            default:
              return -1;
            }

        case E_V8HFmode:
          if (pattern930 (x2, 
E_V8HFmode, 
E_HFmode) != 0)
            return -1;
          if (
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9102; /* avx2_pbroadcastv8hf */
          if (!(
#line 27745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 323 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9223; /* avx512fp16_vec_dupv8hf */

        case E_V32BFmode:
          if (!register_operand (operands[0], E_V32BFmode)
              || GET_MODE (x2) != E_V32BFmode
              || GET_MODE (x3) != E_BFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8BFmode:
              if (!nonimmediate_operand (operands[1], E_V8BFmode))
                return -1;
              if ((
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 584 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return 9103; /* avx2_pbroadcastv32bf */
              if (!(
#line 27745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
                return -1;
              return 9225; /* avx512bw_vec_dupv32bf */

            case E_V32BFmode:
              if (!nonimmediate_operand (operands[1], E_V32BFmode)
                  || !(
#line 27712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 980 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512)))
                return -1;
              return 9182; /* avx512bw_vec_dupv32bf_1 */

            default:
              return -1;
            }

        case E_V16BFmode:
          if (!register_operand (operands[0], E_V16BFmode)
              || GET_MODE (x2) != E_V16BFmode
              || GET_MODE (x3) != E_BFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8BFmode:
              if (!nonimmediate_operand (operands[1], E_V8BFmode))
                return -1;
              if ((
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 584 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
                return 9104; /* avx2_pbroadcastv16bf */
              if (!(
#line 27745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
                return -1;
              return 9227; /* avx512vl_vec_dupv16bf */

            case E_V16BFmode:
              if (!nonimmediate_operand (operands[1], E_V16BFmode)
                  || !
#line 27309 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
                return -1;
              return 9111; /* avx2_pbroadcastv16bf_1 */

            default:
              return -1;
            }

        case E_V8BFmode:
          if (pattern930 (x2, 
E_V8BFmode, 
E_BFmode) != 0)
            return -1;
          if (
#line 27295 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9105; /* avx2_pbroadcastv8bf */
          if (!(
#line 27745 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 324 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9229; /* avx512vl_vec_dupv8bf */

        case E_V4DFmode:
          if (!register_operand (operands[0], E_V4DFmode)
              || GET_MODE (x2) != E_V4DFmode
              || GET_MODE (x3) != E_DFmode)
            return -1;
          if (register_operand (operands[1], E_V2DFmode)
              && 
#line 27700 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))
            return 9176; /* avx2_vec_dupv4df */
          if (!nonimmediate_operand (operands[1], E_V2DFmode)
              || !(
#line 27726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9203; /* avx512vl_vec_dupv4df */

        case E_V2DFmode:
          if (pattern930 (x2, 
E_V2DFmode, 
E_DFmode) != 0
              || !(
#line 27726 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 297 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9205; /* avx512vl_vec_dupv2df */

        default:
          return -1;
        }

    case 2:
      x6 = XVECEXP (x4, 0, 0);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x4, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern926 (x2, 
E_V4SImode, 
E_V2SImode, 
E_V16SImode) != 0
              || !(
#line 28051 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28035 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9317; /* *avx512dq_broadcastv16si */

        case E_V8SImode:
          if (pattern926 (x2, 
E_V4SImode, 
E_V2SImode, 
E_V8SImode) != 0
              || !(
#line 28051 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28035 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9319; /* *avx512dq_broadcastv8si */

        case E_V4SImode:
          if (pattern930 (x2, 
E_V4SImode, 
E_V2SImode) != 0
              || !(
#line 28051 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28035 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9321; /* *avx512dq_broadcastv4si */

        case E_V16SFmode:
          if (pattern926 (x2, 
E_V4SFmode, 
E_V2SFmode, 
E_V16SFmode) != 0
              || !(
#line 28051 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28036 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 9323; /* *avx512dq_broadcastv16sf */

        case E_V8SFmode:
          if (pattern926 (x2, 
E_V4SFmode, 
E_V2SFmode, 
E_V8SFmode) != 0
              || !(
#line 28051 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 28036 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 9325; /* *avx512dq_broadcastv8sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern535 (x2))
        {
        case 0:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5860; /* *avx512bw_vpternlogv32hf_1 */

        case 1:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5887; /* *avx512vl_vpternlogv16hf_1 */

        case 2:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5914; /* *avx512fp16_vpternlogv8hf_1 */

        case 3:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5941; /* *avx512bw_vpternlogv32bf_1 */

        case 4:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5968; /* *avx512vl_vpternlogv16bf_1 */

        case 5:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5995; /* *avx512vl_vpternlogv8bf_1 */

        case 6:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6022; /* *avx512f_vpternlogv16sf_1 */

        case 7:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6049; /* *avx512vl_vpternlogv8sf_1 */

        case 8:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6076; /* *avx512vl_vpternlogv4sf_1 */

        case 9:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6103; /* *avx512f_vpternlogv8df_1 */

        case 10:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6130; /* *avx512vl_vpternlogv4df_1 */

        case 11:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6157; /* *avx512vl_vpternlogv2df_1 */

        case 12:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5863; /* *avx512bw_vpternlogv32hf_1 */

        case 13:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5890; /* *avx512vl_vpternlogv16hf_1 */

        case 14:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5917; /* *avx512fp16_vpternlogv8hf_1 */

        case 15:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5944; /* *avx512bw_vpternlogv32bf_1 */

        case 16:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5971; /* *avx512vl_vpternlogv16bf_1 */

        case 17:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5998; /* *avx512vl_vpternlogv8bf_1 */

        case 18:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6025; /* *avx512f_vpternlogv16sf_1 */

        case 19:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6052; /* *avx512vl_vpternlogv8sf_1 */

        case 20:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6079; /* *avx512vl_vpternlogv4sf_1 */

        case 21:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6106; /* *avx512f_vpternlogv8df_1 */

        case 22:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6133; /* *avx512vl_vpternlogv4df_1 */

        case 23:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6160; /* *avx512vl_vpternlogv2df_1 */

        case 24:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5866; /* *avx512bw_vpternlogv32hf_1 */

        case 25:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5893; /* *avx512vl_vpternlogv16hf_1 */

        case 26:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 5920; /* *avx512fp16_vpternlogv8hf_1 */

        case 27:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5947; /* *avx512bw_vpternlogv32bf_1 */

        case 28:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 5974; /* *avx512vl_vpternlogv16bf_1 */

        case 29:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6001; /* *avx512vl_vpternlogv8bf_1 */

        case 30:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6028; /* *avx512f_vpternlogv16sf_1 */

        case 31:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6055; /* *avx512vl_vpternlogv8sf_1 */

        case 32:
          if (!
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6082; /* *avx512vl_vpternlogv4sf_1 */

        case 33:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6109; /* *avx512f_vpternlogv8df_1 */

        case 34:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6136; /* *avx512vl_vpternlogv4df_1 */

        case 35:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6163; /* *avx512vl_vpternlogv2df_1 */

        case 36:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6928; /* *avx512bw_vpternlogv32hf_3 */

        case 37:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6937; /* *avx512vl_vpternlogv16hf_3 */

        case 38:
          if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6946; /* *avx512fp16_vpternlogv8hf_3 */

        case 39:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6955; /* *avx512bw_vpternlogv32bf_3 */

        case 40:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6964; /* *avx512vl_vpternlogv16bf_3 */

        case 41:
          if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 6973; /* *avx512vl_vpternlogv8bf_3 */

        case 42:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6982; /* *avx512f_vpternlogv16sf_3 */

        case 43:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6991; /* *avx512vl_vpternlogv8sf_3 */

        case 44:
          if (!
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()))
            return -1;
          return 7000; /* *avx512vl_vpternlogv4sf_3 */

        case 45:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 7009; /* *avx512f_vpternlogv8df_3 */

        case 46:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 7018; /* *avx512vl_vpternlogv4df_3 */

        case 47:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 7027; /* *avx512vl_vpternlogv2df_3 */

        default:
          return -1;
        }

    case AND:
      switch (pattern536 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6508; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6535; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6562; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6589; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6616; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6643; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6670; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6697; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6724; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6751; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6778; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6805; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern536 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6511; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6538; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6565; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6592; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6619; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6646; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6673; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6700; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6727; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6754; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6781; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6808; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    case XOR:
      switch (pattern536 (x2))
        {
        case 0:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6514; /* *avx512bw_vpternlogv32hf_2 */

        case 1:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6541; /* *avx512vl_vpternlogv16hf_2 */

        case 2:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6568; /* *avx512fp16_vpternlogv8hf_2 */

        case 3:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6595; /* *avx512bw_vpternlogv32bf_2 */

        case 4:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6622; /* *avx512vl_vpternlogv16bf_2 */

        case 5:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6649; /* *avx512vl_vpternlogv8bf_2 */

        case 6:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6676; /* *avx512f_vpternlogv16sf_2 */

        case 7:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6703; /* *avx512vl_vpternlogv8sf_2 */

        case 8:
          if (!
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))))
            return -1;
          return 6730; /* *avx512vl_vpternlogv4sf_2 */

        case 9:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 6757; /* *avx512f_vpternlogv8df_2 */

        case 10:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
            return -1;
          return 6784; /* *avx512vl_vpternlogv4df_2 */

        case 11:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 6811; /* *avx512vl_vpternlogv2df_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_321 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case UNSPEC:
      return recog_184 (x1, insn, pnum_clobbers);

    case VEC_MERGE:
      return recog_181 (x1, insn, pnum_clobbers);

    case PLUS:
      return recog_204 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_192 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_179 (x1, insn, pnum_clobbers);

    case MULT:
      return recog_186 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_203 (x1, insn, pnum_clobbers);

    case SQRT:
      return recog_200 (x1, insn, pnum_clobbers);

    case SMAX:
      return recog_197 (x1, insn, pnum_clobbers);

    case SMIN:
      return recog_198 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case REG:
    case SUBREG:
    case MEM:
      return recog_178 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[3] = x4;
      x5 = XEXP (x3, 2);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XEXP (x3, 1);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SFmode:
          if (pattern1011 (x3, 
E_V4SFmode) != 0
              || !
#line 4365 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
            return -1;
          return 3273; /* sse_vmmaskcmpv4sf3 */

        case E_V2DFmode:
          if (pattern1011 (x3, 
E_V2DFmode) != 0
              || !(
#line 4365 "../../../gcc/config/i386/sse.md"
(TARGET_SSE) && 
#line 474 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
            return -1;
          return 3274; /* sse2_vmmaskcmpv2df3 */

        default:
          return -1;
        }

    case AND:
      return recog_191 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_205 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_196 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_182 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_202 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_201 (x1, insn, pnum_clobbers);

    case FIX:
      return recog_195 (x1, insn, pnum_clobbers);

    case UNSIGNED_FIX:
      return recog_199 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_189 (x1, insn, pnum_clobbers);

    case FLOAT_TRUNCATE:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern771 (x3, 
E_V8HFmode, 
E_QImode) != 0)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V8DFmode:
              if (!vector_operand (operands[1], E_V8DFmode)
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
                return -1;
              return 4736; /* avx512fp16_vcvtpd2ph_v8df_mask */

            case E_V8SFmode:
              if (!vector_operand (operands[1], E_V8SFmode)
                  || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
                return -1;
              return 4744; /* avx512fp16_vcvtps2ph_v8sf_mask */

            default:
              return -1;
            }

        case E_V16HFmode:
          if (pattern772 (x3, 
E_V16HFmode, 
E_HImode, 
E_V16SFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 8125 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 1003 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 4740; /* avx512fp16_vcvtps2ph_v16sf_mask */

        case E_V8SFmode:
          if (pattern772 (x3, 
E_V8SFmode, 
E_QImode, 
E_V8DFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10099 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
            return -1;
          return 5174; /* avx512f_cvtpd2ps512_mask */

        case E_V4SFmode:
          if (pattern772 (x3, 
E_V4SFmode, 
E_QImode, 
E_V4DFmode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 10109 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && TARGET_AVX512VL
   && (!false || TARGET_AVX10_2_256))))
            return -1;
          return 5178; /* avx_cvtpd2ps256_mask */

        case E_V16BFmode:
          if (pattern147 (x3, 
E_V16BFmode, 
E_V16SFmode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31180 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 31108 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10345; /* avx512f_cvtneps2bf16_v16sf_mask */

        case E_V8BFmode:
          if (pattern147 (x3, 
E_V8BFmode, 
E_V8SFmode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 31180 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BF16) && 
#line 31108 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10347; /* avx512f_cvtneps2bf16_v8sf_mask */

        default:
          return -1;
        }

    case VEC_SELECT:
      return recog_180 (x1, insn, pnum_clobbers);

    case SS_TRUNCATE:
      switch (pattern138 (x3))
        {
        case 0:
          if (!
#line 15148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7238; /* avx512f_ss_truncatev16siv16qi2_mask */

        case 1:
          if (!(
#line 15320 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7274; /* avx512vl_ss_truncatev16hiv16qi2_mask */

        case 2:
          if (!
#line 15148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7241; /* avx512f_ss_truncatev16siv16hi2_mask */

        case 3:
          if (!
#line 15148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7244; /* avx512f_ss_truncatev8div8si2_mask */

        case 4:
          if (!
#line 15148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7247; /* avx512f_ss_truncatev8div8hi2_mask */

        case 5:
          if (!
#line 15320 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7271; /* avx512vl_ss_truncatev8siv8hi2_mask */

        case 6:
          if (!
#line 15220 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 7254; /* avx512bw_ss_truncatev32hiv32qi2_mask */

        case 7:
          if (!
#line 15320 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7268; /* avx512vl_ss_truncatev4div4si2_mask */

        default:
          return -1;
        }

    case TRUNCATE:
      return recog_190 (x1, insn, pnum_clobbers);

    case US_TRUNCATE:
      switch (pattern138 (x3))
        {
        case 0:
          if (!
#line 15148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7240; /* avx512f_us_truncatev16siv16qi2_mask */

        case 1:
          if (!(
#line 15320 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL) && 
#line 15237 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)))
            return -1;
          return 7276; /* avx512vl_us_truncatev16hiv16qi2_mask */

        case 2:
          if (!
#line 15148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7243; /* avx512f_us_truncatev16siv16hi2_mask */

        case 3:
          if (!
#line 15148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7246; /* avx512f_us_truncatev8div8si2_mask */

        case 4:
          if (!
#line 15148 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 7249; /* avx512f_us_truncatev8div8hi2_mask */

        case 5:
          if (!
#line 15320 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7273; /* avx512vl_us_truncatev8siv8hi2_mask */

        case 6:
          if (!
#line 15220 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
            return -1;
          return 7256; /* avx512bw_us_truncatev32hiv32qi2_mask */

        case 7:
          if (!
#line 15320 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))
            return -1;
          return 7270; /* avx512vl_us_truncatev4div4si2_mask */

        default:
          return -1;
        }

    case SS_PLUS:
      switch (pattern139 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V64QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7509; /* *avx512bw_ssaddv64qi3_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V32QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7517; /* *avx2_ssaddv32qi3_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V16QImode, operands))))
            return -1;
          return 7525; /* *sse2_ssaddv16qi3_mask */

        case 3:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V32HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7533; /* *avx512bw_ssaddv32hi3_mask */

        case 4:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V16HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7541; /* *avx2_ssaddv16hi3_mask */

        case 5:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_PLUS, V8HImode, operands))))
            return -1;
          return 7549; /* *sse2_ssaddv8hi3_mask */

        default:
          return -1;
        }

    case US_PLUS:
      switch (pattern139 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V64QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7511; /* *avx512bw_usaddv64qi3_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V32QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7519; /* *avx2_usaddv32qi3_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V16QImode, operands))))
            return -1;
          return 7527; /* *sse2_usaddv16qi3_mask */

        case 3:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V32HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7535; /* *avx512bw_usaddv32hi3_mask */

        case 4:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V16HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7543; /* *avx2_usaddv16hi3_mask */

        case 5:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_PLUS, V8HImode, operands))))
            return -1;
          return 7551; /* *sse2_usaddv8hi3_mask */

        default:
          return -1;
        }

    case SS_MINUS:
      switch (pattern139 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V64QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7513; /* *avx512bw_sssubv64qi3_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V32QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7521; /* *avx2_sssubv32qi3_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V16QImode, operands))))
            return -1;
          return 7529; /* *sse2_sssubv16qi3_mask */

        case 3:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V32HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7537; /* *avx512bw_sssubv32hi3_mask */

        case 4:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V16HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7545; /* *avx2_sssubv16hi3_mask */

        case 5:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (SS_MINUS, V8HImode, operands))))
            return -1;
          return 7553; /* *sse2_sssubv8hi3_mask */

        default:
          return -1;
        }

    case US_MINUS:
      switch (pattern139 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V64QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7515; /* *avx512bw_ussubv64qi3_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V32QImode, operands)) && 
#line 739 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7523; /* *avx2_ussubv32qi3_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V16QImode, operands))))
            return -1;
          return 7531; /* *sse2_ussubv16qi3_mask */

        case 3:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (64 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V32HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))))
            return -1;
          return 7539; /* *avx512bw_ussubv32hi3_mask */

        case 4:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (32 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V16HImode, operands)) && 
#line 740 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2))))
            return -1;
          return 7547; /* *avx2_ussubv16hi3_mask */

        case 5:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 16331 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && (16 == 64 || TARGET_AVX512VL) && TARGET_AVX512BW
   && ix86_binary_operator_ok (US_MINUS, V8HImode, operands))))
            return -1;
          return 7555; /* *sse2_ussubv8hi3_mask */

        default:
          return -1;
        }

    case ASHIFTRT:
      return recog_185 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_188 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_187 (x1, insn, pnum_clobbers);

    case ROTATE:
      switch (pattern142 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7709; /* avx512f_rolvv16si_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7713; /* avx512vl_rolvv8si_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7717; /* avx512vl_rolvv4si_mask */

        case 3:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7721; /* avx512f_rolvv8di_mask */

        case 4:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7725; /* avx512vl_rolvv4di_mask */

        case 5:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7729; /* avx512vl_rolvv2di_mask */

        case 6:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7733; /* avx512f_rolv16si_mask */

        case 7:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7737; /* avx512vl_rolv8si_mask */

        case 8:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7741; /* avx512vl_rolv4si_mask */

        case 9:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7745; /* avx512f_rolv8di_mask */

        case 10:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7749; /* avx512vl_rolv4di_mask */

        case 11:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7753; /* avx512vl_rolv2di_mask */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern142 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7711; /* avx512f_rorvv16si_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7715; /* avx512vl_rorvv8si_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7719; /* avx512vl_rorvv4si_mask */

        case 3:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7723; /* avx512f_rorvv8di_mask */

        case 4:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7727; /* avx512vl_rorvv4di_mask */

        case 5:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17652 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7731; /* avx512vl_rorvv2di_mask */

        case 6:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7735; /* avx512f_rorv16si_mask */

        case 7:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7739; /* avx512vl_rorv8si_mask */

        case 8:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7743; /* avx512vl_rorv4si_mask */

        case 9:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7747; /* avx512f_rorv8di_mask */

        case 10:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7751; /* avx512vl_rorv4di_mask */

        case 11:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17662 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7755; /* avx512vl_rorv2di_mask */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern143 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7773; /* *avx512f_umaxv16si3_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7781; /* *avx512f_umaxv8si3_mask */

        case 2:
          if (nonimmediate_operand (operands[1], E_V4SImode)
              && nonimmediate_operand (operands[2], E_V4SImode)
              && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 7789; /* *avx512f_umaxv4si3_mask */
          if (!vector_operand (operands[1], E_V4SImode)
              || !vector_operand (operands[2], E_V4SImode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17908 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7879; /* *sse4_1_umaxv4si3_mask */

        case 3:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7797; /* *avx512f_umaxv8di3_mask */

        case 4:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7805; /* *avx512f_umaxv4di3_mask */

        case 5:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7813; /* *avx512f_umaxv2di3_mask */

        case 6:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7821; /* *avx512bw_umaxv64qi3_mask */

        case 7:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7829; /* *avx512bw_umaxv16qi3_mask */

        case 8:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7837; /* *avx512bw_umaxv32qi3_mask */

        case 9:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7845; /* *avx512bw_umaxv32hi3_mask */

        case 10:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7853; /* *avx512bw_umaxv16hi3_mask */

        case 11:
          if (nonimmediate_operand (operands[1], E_V8HImode)
              && nonimmediate_operand (operands[2], E_V8HImode)
              && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 7861; /* *avx512bw_umaxv8hi3_mask */
          if (!vector_operand (operands[1], E_V8HImode)
              || !vector_operand (operands[2], E_V8HImode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17908 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7875; /* *sse4_1_umaxv8hi3_mask */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern143 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7775; /* *avx512f_uminv16si3_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7783; /* *avx512f_uminv8si3_mask */

        case 2:
          if (nonimmediate_operand (operands[1], E_V4SImode)
              && nonimmediate_operand (operands[2], E_V4SImode)
              && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 7791; /* *avx512f_uminv4si3_mask */
          if (!vector_operand (operands[1], E_V4SImode)
              || !vector_operand (operands[2], E_V4SImode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17908 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7881; /* *sse4_1_uminv4si3_mask */

        case 3:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7799; /* *avx512f_uminv8di3_mask */

        case 4:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7807; /* *avx512f_uminv4di3_mask */

        case 5:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17721 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7815; /* *avx512f_uminv2di3_mask */

        case 6:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7823; /* *avx512bw_uminv64qi3_mask */

        case 7:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7831; /* *avx512bw_uminv16qi3_mask */

        case 8:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7839; /* *avx512bw_uminv32qi3_mask */

        case 9:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 7847; /* *avx512bw_uminv32hi3_mask */

        case 10:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 7855; /* *avx512bw_uminv16hi3_mask */

        case 11:
          if (nonimmediate_operand (operands[1], E_V8HImode)
              && nonimmediate_operand (operands[2], E_V8HImode)
              && (
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 17732 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && !(MEM_P (operands[1]) && MEM_P (operands[2]))) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return 7863; /* *avx512bw_uminv8hi3_mask */
          if (!vector_operand (operands[1], E_V8HImode)
              || !vector_operand (operands[2], E_V8HImode)
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && 
#line 17908 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1
   && (16 == 64 || TARGET_AVX512VL)
   && !(MEM_P (operands[1]) && MEM_P (operands[2])))))
            return -1;
          return 7877; /* *sse4_1_uminv8hi3_mask */

        default:
          return -1;
        }

    case VEC_CONCAT:
      return recog_183 (x1, insn, pnum_clobbers);

    case ABS:
      switch (pattern146 (x3))
        {
        case 0:
          if (!(
#line 23380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8657; /* absv16si2_mask */

        case 1:
          if (!(
#line 23380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8658; /* absv8si2_mask */

        case 2:
          if (!(
#line 23380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8659; /* absv4si2_mask */

        case 3:
          if (!(
#line 23380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8660; /* absv8di2_mask */

        case 4:
          if (!(
#line 23380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8661; /* absv4di2_mask */

        case 5:
          if (!(
#line 23380 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8662; /* absv2di2_mask */

        case 6:
          if (!(
#line 23393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8663; /* absv64qi2_mask */

        case 7:
          if (!(
#line 23393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8664; /* absv16qi2_mask */

        case 8:
          if (!(
#line 23393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8665; /* absv32qi2_mask */

        case 9:
          if (!(
#line 23393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 8666; /* absv32hi2_mask */

        case 10:
          if (!(
#line 23393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8667; /* absv16hi2_mask */

        case 11:
          if (!(
#line 23393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 8668; /* absv8hi2_mask */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_194 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_193 (x1, insn, pnum_clobbers);

    case CLZ:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x8 = XEXP (x3, 1);
      operands[2] = x8;
      x5 = XEXP (x3, 2);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16SImode:
          if (pattern144 (x3, 
E_V16SImode, 
E_HImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29948 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10058; /* clzv16si2_mask */

        case E_V8SImode:
          if (pattern144 (x3, 
E_V8SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29948 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10060; /* clzv8si2_mask */

        case E_V4SImode:
          if (pattern144 (x3, 
E_V4SImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29948 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10062; /* clzv4si2_mask */

        case E_V8DImode:
          if (pattern144 (x3, 
E_V8DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29948 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10064; /* clzv8di2_mask */

        case E_V4DImode:
          if (pattern144 (x3, 
E_V4DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29948 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10066; /* clzv4di2_mask */

        case E_V2DImode:
          if (pattern144 (x3, 
E_V2DImode, 
E_QImode) != 0
              || !(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 29948 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512CD) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10068; /* clzv2di2_mask */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern146 (x3))
        {
        case 0:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30299 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10131; /* vpopcountv16si_mask */

        case 1:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30299 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10133; /* vpopcountv8si_mask */

        case 2:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30299 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 500 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10135; /* vpopcountv4si_mask */

        case 3:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30299 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10137; /* vpopcountv8di_mask */

        case 4:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30299 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10139; /* vpopcountv4di_mask */

        case 5:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30299 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VPOPCNTDQ) && 
#line 501 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10141; /* vpopcountv2di_mask */

        case 6:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30349 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10151; /* vpopcountv64qi_mask */

        case 7:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30349 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10153; /* vpopcountv16qi_mask */

        case 8:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30349 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 317 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10155; /* vpopcountv32qi_mask */

        case 9:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30349 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512))))
            return -1;
          return 10157; /* vpopcountv32hi_mask */

        case 10:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30349 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10159; /* vpopcountv16hi_mask */

        case 11:
          if (!(
#line 84 "../../../gcc/config/i386/subst.md"
(TARGET_AVX512F) && (
#line 30349 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BITALG) && 
#line 318 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL))))
            return -1;
          return 10161; /* vpopcountv8hi_mask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_336 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !vector_operand (operands[1], E_V8HFmode)
          || !(
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4604; /* avx512fp16_fix_truncv8hi2 */

    case 1:
      if (!register_operand (operands[0], E_V16HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16HImode
          || !vector_operand (operands[1], E_V16HFmode)
          || !(
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
        return -1;
      return 4608; /* avx512fp16_fix_truncv16hi2 */

    case 2:
      if (!register_operand (operands[0], E_V32HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V32HImode
          || !vector_operand (operands[1], E_V32HFmode)
          || !(
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 693 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return -1;
      return 4616; /* avx512fp16_fix_truncv32hi2 */

    case 3:
      if (!register_operand (operands[0], E_V8SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!vector_operand (operands[1], E_V8HFmode)
              || !(
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 4624; /* avx512fp16_fix_truncv8si2 */

        case E_V8SFmode:
          if (!nonimmediate_operand (operands[1], E_V8SFmode)
              || !
#line 8806 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && 1))
            return -1;
          return 4889; /* fix_truncv8sfv8si2 */

        case E_V8DFmode:
          if (!vector_operand (operands[1], E_V8DFmode)
              || !
#line 9581 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 5030; /* fix_truncv8dfv8si2 */

        default:
          return -1;
        }

    case 4:
      x2 = XEXP (x1, 1);
      switch (pattern518 (x2))
        {
        case 0:
          if (!(
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 694 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4632; /* avx512fp16_fix_truncv16si2 */

        case 1:
          if (!
#line 8786 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return -1;
          return 4877; /* fix_truncv16sfv16si2 */

        default:
          return -1;
        }

    case 5:
      x2 = XEXP (x1, 1);
      switch (pattern519 (x2, 
E_V8DImode))
        {
        case 0:
          if (!(
#line 7878 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && 1) && 
#line 695 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 4640; /* avx512fp16_fix_truncv8di2 */

        case 1:
          if (!(
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5075; /* fix_truncv8dfv8di2 */

        case 2:
          if (!(
#line 9755 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return -1;
          return 5131; /* fix_truncv8sfv8di2 */

        default:
          return -1;
        }

    case 6:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HFmode:
          if (!memory_operand (operands[1], E_V4HFmode)
              || !
#line 7928 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4668; /* *avx512fp16_fix_truncv4si2_load */

        case E_V4SFmode:
          if (!vector_operand (operands[1], E_V4SFmode)
              || !
#line 8836 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2 && 1))
            return -1;
          return 4893; /* fix_truncv4sfv4si2 */

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 9671 "../../../gcc/config/i386/sse.md"
(TARGET_AVX || (TARGET_AVX512VL && TARGET_AVX512F)))
            return -1;
          return 5047; /* fix_truncv4dfv4si2 */

        default:
          return -1;
        }

    case 7:
      x2 = XEXP (x1, 1);
      switch (pattern520 (x2))
        {
        case 0:
          if (!
#line 7928 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4672; /* *avx512fp16_fix_truncv4di2_load */

        case 1:
          if (!(
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5083; /* fix_truncv4dfv4di2 */

        case 2:
          if (!(
#line 9755 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ) && 
#line 626 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5135; /* fix_truncv4sfv4di2 */

        default:
          return -1;
        }

    case 8:
      x2 = XEXP (x1, 1);
      switch (pattern521 (x2))
        {
        case 0:
          if (!
#line 7978 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
            return -1;
          return 4684; /* *avx512fp16_fix_truncv2di2_load */

        case 1:
          if (!(
#line 9712 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && 1) && 
#line 536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL)))
            return -1;
          return 5091; /* fix_truncv2dfv2di2 */

        default:
          return -1;
        }

    case 9:
      if (!
#line 7918 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4660; /* avx512fp16_fix_truncv4si2 */

    case 10:
      if (!
#line 7918 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4664; /* avx512fp16_fix_truncv4di2 */

    case 11:
      if (!
#line 7968 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL))
        return -1;
      return 4680; /* avx512fp16_fix_truncv2di2 */

    case 12:
      if (!
#line 9778 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ && TARGET_AVX512VL))
        return -1;
      return 5143; /* avx512dq_fix_truncv2sfv2di2 */

    default:
      return -1;
    }
}

 int
recog_343 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern34 (x1))
    {
    case 0:
      if (!
#line 24130 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1 && 1))
        return -1;
      return 8751; /* avx2_sign_extendv16qiv16hi2 */

    case 1:
      if (!
#line 24184 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW && TARGET_EVEX512))
        return -1;
      return 8759; /* avx512bw_sign_extendv32qiv32hi2 */

    case 2:
      if (!
#line 24254 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
        return -1;
      return 8771; /* *sse4_1_sign_extendv8qiv8hi2_1 */

    case 3:
      if (!
#line 24379 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8783; /* *avx512f_sign_extendv16qiv16si2 */

    case 4:
      if (!
#line 24522 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8811; /* avx512f_sign_extendv16hiv16si2 */

    case 5:
      if (!
#line 24411 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8791; /* *avx2_sign_extendv8qiv8si2_1 */

    case 6:
      if (!
#line 24575 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8819; /* avx2_sign_extendv8hiv8si2 */

    case 7:
      if (!
#line 24472 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8803; /* *sse4_1_sign_extendv4qiv4si2_1 */

    case 8:
      if (!
#line 24645 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8831; /* *sse4_1_sign_extendv4hiv4si2_1 */

    case 9:
      if (!
#line 24776 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8847; /* *avx512f_sign_extendv8qiv8di2_1 */

    case 10:
      if (!
#line 24947 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8878; /* avx512f_sign_extendv8hiv8di2 */

    case 11:
      if (!
#line 25084 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
        return -1;
      return 8906; /* avx512f_sign_extendv8siv8di2 */

    case 12:
      if (!
#line 24834 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8859; /* *avx2_sign_extendv4qiv4di2_1 */

    case 13:
      if (!
#line 24977 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8886; /* *avx2_sign_extendv4hiv4di2_1 */

    case 14:
      if (!
#line 25135 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
        return -1;
      return 8912; /* avx2_sign_extendv4siv4di2 */

    case 15:
      if (!
#line 24896 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8871; /* *sse4_1_sign_extendv2qiv2di2_1 */

    case 16:
      if (!
#line 25035 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8898; /* *sse4_1_sign_extendv2hiv2di2_1 */

    case 17:
      if (!
#line 25201 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
        return -1;
      return 8922; /* *sse4_1_sign_extendv2siv2di2_1 */

    case 18:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      switch (pattern539 (x2))
        {
        case 0:
          if (
#line 24242 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1))
            return 8767; /* sse4_1_sign_extendv8qiv8hi2 */
          break;

        case 1:
          if (
#line 24400 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8787; /* avx2_sign_extendv8qiv8si2 */
          break;

        case 2:
          if (
#line 24766 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512))
            return 8843; /* avx512f_sign_extendv8qiv8di2 */
          break;

        case 3:
          if (
#line 24460 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8799; /* sse4_1_sign_extendv4qiv4si2 */
          break;

        case 4:
          if (
#line 24633 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8827; /* sse4_1_sign_extendv4hiv4si2 */
          break;

        case 5:
          if (
#line 24823 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8855; /* avx2_sign_extendv4qiv4di2 */
          break;

        case 6:
          if (
#line 24966 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1))
            return 8882; /* avx2_sign_extendv4hiv4di2 */
          break;

        case 7:
          if (
#line 24884 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8867; /* sse4_1_sign_extendv2qiv2di2 */
          break;

        case 8:
          if (
#line 25023 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8894; /* sse4_1_sign_extendv2hiv2di2 */
          break;

        case 9:
          if (
#line 25189 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1))
            return 8918; /* sse4_1_sign_extendv2siv2di2 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG
          || maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      switch (pattern679 (x2))
        {
        case 0:
          if (!
#line 24278 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8775; /* *sse4_1_sign_extendv8qiv8hi2_2 */

        case 1:
          if (!
#line 24430 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8795; /* *avx2_sign_extendv8qiv8si2_2 */

        case 2:
          if (!
#line 24794 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()))
            return -1;
          return 8851; /* *avx512f_sign_extendv8qiv8di2_2 */

        case 3:
          if (!
#line 24664 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8835; /* *sse4_1_sign_extendv4hiv4si2_2 */

        case 4:
          if (!
#line 24994 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8890; /* *avx2_sign_extendv4hiv4di2_2 */

        case 5:
          if (!
#line 25219 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8926; /* *sse4_1_sign_extendv2siv2di2_2 */

        case 6:
          if (!
#line 24495 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8807; /* *sse4_1_sign_extendv4qiv4si2_2 */

        case 7:
          if (!
#line 24855 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8863; /* *avx2_sign_extendv4qiv4di2_2 */

        case 8:
          if (!
#line 25057 "../../../gcc/config/i386/sse.md"
(TARGET_SSE4_1 && 1
   && ix86_pre_reload_split ()))
            return -1;
          return 8902; /* *sse4_1_sign_extendv2hiv2di2_2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_350 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V32HFmode:
      if (pattern512 (x3, 
E_V32HFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 389 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_EVEX512)))
        return -1;
      return 2845; /* avx512fp16_divv32hf3 */

    case E_V16HFmode:
      if (pattern512 (x3, 
E_V16HFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 390 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2849; /* avx512fp16_divv16hf3 */

    case E_V8HFmode:
      if (pattern512 (x3, 
E_V8HFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 391 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512FP16 && TARGET_AVX512VL)))
        return -1;
      return 2853; /* avx512fp16_divv8hf3 */

    case E_V16SFmode:
      if (pattern512 (x3, 
E_V16SFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2855; /* avx512f_divv16sf3 */

    case E_V8SFmode:
      if (pattern512 (x3, 
E_V8SFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 392 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2859; /* avx_divv8sf3 */

    case E_V4SFmode:
      if (pattern512 (x3, 
E_V4SFmode) != 0
          || !
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1))
        return -1;
      return 2863; /* sse_divv4sf3 */

    case E_V8DFmode:
      if (pattern512 (x3, 
E_V8DFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)))
        return -1;
      return 2865; /* avx512f_divv8df3 */

    case E_V4DFmode:
      if (pattern512 (x3, 
E_V4DFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 393 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)))
        return -1;
      return 2869; /* avx_divv4df3 */

    case E_V2DFmode:
      if (pattern512 (x3, 
E_V2DFmode) != 0
          || !(
#line 2898 "../../../gcc/config/i386/sse.md"
(TARGET_SSE && 1 && 1) && 
#line 394 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)))
        return -1;
      return 2873; /* sse2_divv2df3 */

    case E_V32BFmode:
      if (pattern14 (x3, 
E_V32BFmode) != 0
          || !(
#line 32123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256) && 
#line 564 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_512)))
        return -1;
      return 10609; /* avx10_2_divbf16_v32bf */

    case E_V16BFmode:
      if (pattern14 (x3, 
E_V16BFmode) != 0
          || !
#line 32123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10617; /* avx10_2_divbf16_v16bf */

    case E_V8BFmode:
      if (pattern14 (x3, 
E_V8BFmode) != 0
          || !
#line 32123 "../../../gcc/config/i386/sse.md"
(TARGET_AVX10_2_256))
        return -1;
      return 10625; /* avx10_2_divbf16_v8bf */

    default:
      return -1;
    }
}

 int
recog_356 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x4))
    {
    case CLOBBER:
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case MEM:
          if (GET_MODE (x6) != E_BLKmode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != SCRATCH)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (push_operand (operands[0], E_SImode)
                  && general_no_elim_operand (operands[1], E_SImode)
                  && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode))
                return 74; /* *pushsi2_prologue */
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || !pop_operand (operands[1], E_SImode)
                  || !
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == SImode))
                return -1;
              return 78; /* *popsi1_epilogue */

            case E_DImode:
              if (push_operand (operands[0], E_DImode)
                  && general_no_elim_operand (operands[1], E_DImode)
                  && 
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode))
                return 75; /* *pushdi2_prologue */
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || !pop_operand (operands[1], E_DImode)
                  || !
#line 1403 "../../../gcc/config/i386/i386.md"
(word_mode == DImode))
                return -1;
              return 79; /* *popdi1_epilogue */

            default:
              return -1;
            }

        case REG:
          if (REGNO (x6) != 17
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (const0_operand (operands[1], E_SImode))
                {
                  if (register_operand (operands[0], E_SImode)
                      && 
#line 2424 "../../../gcc/config/i386/i386.md"
(reload_completed))
                    return 84; /* *movsi_xor */
                  if (memory_operand (operands[0], E_SImode)
                      && 
#line 2434 "../../../gcc/config/i386/i386.md"
(reload_completed))
                    return 87; /* *movsi_and */
                }
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || !constm1_operand (operands[1], E_SImode)
                  || !
#line 2444 "../../../gcc/config/i386/i386.md"
(reload_completed))
                return -1;
              return 90; /* *movsi_or */

            case E_DImode:
              if (const0_operand (operands[1], E_DImode))
                {
                  if (register_operand (operands[0], E_DImode)
                      && (
#line 2424 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 85; /* *movdi_xor */
                  if (memory_operand (operands[0], E_DImode)
                      && (
#line 2434 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 88; /* *movdi_and */
                }
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || !constm1_operand (operands[1], E_DImode)
                  || !(
#line 2444 "../../../gcc/config/i386/i386.md"
(reload_completed) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 91; /* *movdi_or */

            case E_HImode:
              if (memory_operand (operands[0], E_HImode)
                  && const0_operand (operands[1], E_HImode)
                  && 
#line 2434 "../../../gcc/config/i386/i386.md"
(reload_completed))
                return 86; /* *movhi_and */
              if (!nonimmediate_operand (operands[0], E_HImode)
                  || !constm1_operand (operands[1], E_HImode)
                  || !
#line 2444 "../../../gcc/config/i386/i386.md"
(reload_completed))
                return -1;
              return 89; /* *movhi_or */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x8 = XEXP (x4, 1);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          x6 = XEXP (x4, 0);
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode))
                return -1;
              return 107; /* swapsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 108; /* swapdi */

            case E_QImode:
              if (!register_operand (operands[0], E_QImode)
                  || !register_operand (operands[1], E_QImode))
                return -1;
              return 109; /* *swapqi */

            case E_HImode:
              if (!register_operand (operands[0], E_HImode)
                  || !register_operand (operands[1], E_HImode))
                return -1;
              return 110; /* *swaphi */

            case E_XFmode:
              if (!register_operand (operands[0], E_XFmode)
                  || !register_operand (operands[1], E_XFmode)
                  || !
#line 4644 "../../../gcc/config/i386/i386.md"
(TARGET_80387))
                return -1;
              return 173; /* *swapxf */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 72
              || GET_MODE (x8) != E_XFmode
              || !register_operand (operands[0], E_SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[3] = x5;
          if (!const1_operand (operands[3], E_SFmode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_XFmode))
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_XFmode)
              || !
#line 23937 "../../../gcc/config/i386/i386.md"
(TARGET_USE_FANCY_MATH_387
   && flag_unsafe_math_optimizations))
            return -1;
          return 1714; /* fptanxf4_i387 */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 108
          || GET_MODE (x4) != E_DImode)
        return -1;
      x10 = XVECEXP (x4, 0, 0);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      if (register_operand (operands[1], E_DImode)
          && push_operand (operands[0], E_DImode)
          && 
#line 3910 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
        return 161; /* pushp_di */
      if (!pop_operand (operands[1], E_DImode)
          || !register_operand (operands[0], E_DImode)
          || !
#line 3918 "../../../gcc/config/i386/i386.md"
(TARGET_APX_PPX))
        return -1;
      return 162; /* popp_di */

    default:
      return -1;
    }
}

 int
recog_368 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pattern337 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode
              || !nonimmediate_operand (operands[1], E_QImode)
              || !general_operand (operands[2], E_QImode)
              || !
#line 6677 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 287; /* *addqi_1_zexthi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !general_operand (operands[2], E_QImode)
                  || !
#line 6677 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 289; /* *addqi_1_zextsi */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !general_operand (operands[2], E_HImode)
                  || !
#line 6715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 293; /* *addhi_1_zextsi */

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !general_operand (operands[2], E_QImode)
                  || !
#line 6677 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 291; /* *addqi_1_zextdi */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !general_operand (operands[2], E_HImode)
                  || !
#line 6715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 295; /* *addhi_1_zextdi */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !x86_64_general_operand (operands[2], E_SImode)
                  || !
#line 6760 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 296; /* addsi_1_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case LTU:
        case UNLT:
          operands[3] = x7;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 17)
            return -1;
          x9 = XEXP (x7, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x10 = XEXP (x5, 1);
          operands[1] = x10;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          switch (pattern1149 (x3))
            {
            case 0:
              if (pattern1743 (x5, 
E_QImode) != 0
                  || !
#line 8895 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 465; /* *addqi3_carry_zexthi */

            case 1:
              if (pattern1743 (x5, 
E_QImode) != 0
                  || !
#line 8895 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 466; /* *addqi3_carry_zextsi */

            case 2:
              if (pattern1743 (x5, 
E_HImode) != 0
                  || !
#line 8914 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 468; /* *addhi3_carry_zextsi */

            case 3:
              if (pattern1743 (x5, 
E_QImode) != 0
                  || !
#line 8895 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 467; /* *addqi3_carry_zextdi */

            case 4:
              if (pattern1743 (x5, 
E_HImode) != 0
                  || !
#line 8914 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 469; /* *addhi3_carry_zextdi */

            case 5:
              if (pattern1743 (x5, 
E_SImode) != 0
                  || !
#line 8933 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (PLUS, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 470; /* *addsi3_carry_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LTU:
    case UNLT:
      switch (pattern1150 (x3))
        {
        case 0:
          if (!ix86_carry_flag_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8952 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 471; /* *addqi3_carry_zexthi_0 */

        case 1:
          if (!ix86_carry_flag_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8952 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 472; /* *addqi3_carry_zextsi_0 */

        case 2:
          if (!ix86_carry_flag_operator (operands[2], E_HImode)
              || !nonimmediate_operand (operands[1], E_HImode)
              || !
#line 8966 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 474; /* *addhi3_carry_zextsi_0 */

        case 3:
          if (!ix86_carry_flag_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8952 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 473; /* *addqi3_carry_zextdi_0 */

        case 4:
          if (!ix86_carry_flag_operator (operands[2], E_HImode)
              || !nonimmediate_operand (operands[1], E_HImode)
              || !
#line 8966 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 475; /* *addhi3_carry_zextdi_0 */

        case 5:
          if (!ix86_carry_flag_operator (operands[2], E_SImode)
              || !nonimmediate_operand (operands[1], E_SImode)
              || !
#line 8980 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 476; /* *addsi3_carry_zext_0 */

        default:
          return -1;
        }

    case GE:
    case GEU:
      switch (pattern1150 (x3))
        {
        case 0:
          if (!ix86_carry_flag_unset_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8997 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 477; /* *addqi3_carry_zexthi_0r */

        case 1:
          if (!ix86_carry_flag_unset_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8997 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 478; /* *addqi3_carry_zextsi_0r */

        case 2:
          if (!ix86_carry_flag_unset_operator (operands[2], E_HImode)
              || !nonimmediate_operand (operands[1], E_HImode)
              || !
#line 9011 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 480; /* *addhi3_carry_zextsi_0r */

        case 3:
          if (!ix86_carry_flag_unset_operator (operands[2], E_QImode)
              || !nonimmediate_operand (operands[1], E_QImode)
              || !
#line 8997 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 479; /* *addqi3_carry_zextdi_0r */

        case 4:
          if (!ix86_carry_flag_unset_operator (operands[2], E_HImode)
              || !nonimmediate_operand (operands[1], E_HImode)
              || !
#line 9011 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD))
            return -1;
          return 481; /* *addhi3_carry_zextdi_0r */

        case 5:
          if (!ix86_carry_flag_unset_operator (operands[2], E_SImode)
              || !nonimmediate_operand (operands[1], E_SImode)
              || !
#line 9025 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 482; /* *addsi3_carry_zext_0r */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern1151 (x5) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 23083 "../../../gcc/config/i386/i386.md"
(TARGET_X32))
        return -1;
      return 1657; /* *add_tp_x32_zext */

    default:
      return -1;
    }
}

 int
recog_370 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      if (pattern337 (x1) != 0)
        return -1;
      switch (pattern1148 (x3))
        {
        case 0:
          if (!
#line 4839 "../../../gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
            return -1;
          return 178; /* zero_extendqisi2_and */

        case 1:
          if (!
#line 4839 "../../../gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
            return -1;
          return 179; /* zero_extendhisi2_and */

        case 2:
          if (!
#line 4893 "../../../gcc/config/i386/i386.md"
(TARGET_ZERO_EXTEND_WITH_AND && optimize_function_for_speed_p (cfun)))
            return -1;
          return 182; /* zero_extendqihi2_and */

        default:
          return -1;
        }

    case PLUS:
      return recog_368 (x1, insn, pnum_clobbers);

    case MINUS:
      return recog_369 (x1, insn, pnum_clobbers);

    case MULT:
      if (pattern338 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode
              || !nonimmediate_operand (operands[1], E_HImode)
              || !immediate_operand (operands[2], E_HImode)
              || !
#line 10643 "../../../gcc/config/i386/i386.md"
(TARGET_APX_ZU && true))
            return -1;
          return 597; /* *imulhisizu */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !immediate_operand (operands[2], E_HImode)
                  || !
#line 10643 "../../../gcc/config/i386/i386.md"
(TARGET_APX_ZU && true))
                return -1;
              return 599; /* *imulhidizu */

            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !x86_64_general_operand (operands[2], E_SImode)
                  || !
#line 10655 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))
   && true))
                return -1;
              return 601; /* *mulsi3_1_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      if (pattern339 (x1, pnum_clobbers, 
MOD) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!nonimmediate_operand (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      x10 = XEXP (x9, 0);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      x11 = XEXP (x9, 1);
      if (!rtx_equal_p (x11, operands[3])
          || !
#line 11684 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 655; /* *divmodsi4_zext_1 */

    case UDIV:
      if (pattern339 (x1, pnum_clobbers, 
UMOD) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      switch (pattern1615 (x9))
        {
        case 0:
          if (!
#line 11719 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 656; /* *udivmodsi4_zext_1 */

        case 1:
          if (!
#line 11741 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)))
            return -1;
          *pnum_clobbers = 1;
          return 657; /* *udivmodsi4_pow2_zext_1 */

        default:
          return -1;
        }

    case MOD:
      if (pattern340 (x1, pnum_clobbers, 
DIV) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      if (!nonimmediate_operand (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      x10 = XEXP (x9, 0);
      if (!rtx_equal_p (x10, operands[2]))
        return -1;
      x11 = XEXP (x9, 1);
      if (!rtx_equal_p (x11, operands[3])
          || !
#line 11767 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
        return -1;
      *pnum_clobbers = 1;
      return 658; /* *divmodsi4_zext_2 */

    case UMOD:
      if (pattern340 (x1, pnum_clobbers, 
UDIV) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XVECEXP (x1, 0, 1);
      x8 = XEXP (x7, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      switch (pattern1615 (x9))
        {
        case 0:
          if (!
#line 11803 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 659; /* *udivmodsi4_zext_2 */

        case 1:
          if (!
#line 11825 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)))
            return -1;
          *pnum_clobbers = 1;
          return 660; /* *udivmodsi4_pow2_zext_2 */

        default:
          return -1;
        }

    case AND:
      if (pattern337 (x1) != 0)
        return -1;
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern342 (x3))
            {
            case 0:
              if (!
#line 12626 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 709; /* *andqi_1_zexthi */

            case 1:
              if (!
#line 12626 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 711; /* *andqi_1_zextsi */

            case 2:
              if (!
#line 12640 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 715; /* *andhi_1_zextsi */

            case 3:
              if (!
#line 12626 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 713; /* *andqi_1_zextdi */

            case 4:
              if (!
#line 12640 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 717; /* *andhi_1_zextdi */

            case 5:
              if (!
#line 12656 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (AND, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 718; /* *andsi_1_zext */

            default:
              return -1;
            }

        case PLUS:
          if (pattern691 (x5) != 0
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          x12 = XEXP (x5, 0);
          x13 = XEXP (x12, 1);
          operands[2] = x13;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 21952 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && TARGET_BMI2))
            return -1;
          return 1592; /* *bmi2_bzhi_zero_extendsidi_4 */

        default:
          return -1;
        }

    case IOR:
      switch (pattern343 (x1))
        {
        case 0:
          if (!
#line 13715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 844; /* *iorqi_1_zexthi */

        case 1:
          if (!
#line 13715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 848; /* *iorqi_1_zextsi */

        case 2:
          if (!
#line 13729 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 856; /* *iorhi_1_zextsi */

        case 3:
          if (!
#line 13715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 852; /* *iorqi_1_zextdi */

        case 4:
          if (!
#line 13729 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 860; /* *iorhi_1_zextdi */

        case 5:
          if (!
#line 13745 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (IOR, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 863; /* *iorsi_1_zext */

        default:
          return -1;
        }

    case XOR:
      switch (pattern343 (x1))
        {
        case 0:
          if (!
#line 13715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 846; /* *xorqi_1_zexthi */

        case 1:
          if (!
#line 13715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 850; /* *xorqi_1_zextsi */

        case 2:
          if (!
#line 13729 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 858; /* *xorhi_1_zextsi */

        case 3:
          if (!
#line 13715 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 854; /* *xorqi_1_zextdi */

        case 4:
          if (!
#line 13729 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
            return -1;
          return 862; /* *xorhi_1_zextdi */

        case 5:
          if (!
#line 13745 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (XOR, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 864; /* *xorsi_1_zext */

        default:
          return -1;
        }

    case NEG:
      if (pattern344 (x1) != 0)
        return -1;
      switch (pattern346 (x3))
        {
        case 0:
          if (!
#line 14360 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 963; /* *negqi_1_zexthi */

        case 1:
          if (!
#line 14360 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 965; /* *negqi_1_zextsi */

        case 2:
          if (!
#line 14370 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 969; /* *neghi_1_zextsi */

        case 3:
          if (!
#line 14360 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 967; /* *negqi_1_zextdi */

        case 4:
          if (!
#line 14370 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 971; /* *neghi_1_zextdi */

        case 5:
          if (!
#line 14381 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_unary_operator_ok (NEG, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 972; /* *negsi_1_zext */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern348 (x1))
        {
        case 0:
          if (!
#line 16008 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1094; /* *ashlqi3_1_zexthi */

        case 1:
          if (!
#line 16008 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1096; /* *ashlqi3_1_zextsi */

        case 2:
          if (!
#line 16019 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1100; /* *ashlhi3_1_zextsi */

        case 3:
          if (!
#line 16008 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1098; /* *ashlqi3_1_zextdi */

        case 4:
          if (!
#line 16019 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1102; /* *ashlhi3_1_zextdi */

        case 5:
          if (!
#line 16031 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (ASHIFT, SImode, operands, TARGET_APX_NDD)))
            return -1;
          return 1103; /* *ashlsi3_1_zext */

        default:
          return -1;
        }

    case ASHIFTRT:
      if (pattern338 (x1) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode))
                return -1;
              if (const_int_operand (operands[2], E_QImode)
                  && 
#line 17266 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && INTVAL (operands[2]) == 31
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)))
                return 1170; /* *ashrsi3_cvt_zext */
              if (!nonmemory_operand (operands[2], E_QImode)
                  || !
#line 17478 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1207; /* *ashrsi3_1_zext */

            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !nonmemory_operand (operands[2], E_QImode)
                  || !
#line 17455 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1197; /* *ashrqi3_1_zextdi */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !nonmemory_operand (operands[2], E_QImode)
                  || !
#line 17466 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1205; /* *ashrhi3_1_zextdi */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode
              || !nonimmediate_operand (operands[1], E_QImode)
              || !nonmemory_operand (operands[2], E_QImode)
              || !
#line 17455 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1189; /* *ashrqi3_1_zexthi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !nonmemory_operand (operands[2], E_QImode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!nonimmediate_operand (operands[1], E_QImode)
                  || !
#line 17455 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1193; /* *ashrqi3_1_zextsi */

            case E_HImode:
              if (!nonimmediate_operand (operands[1], E_HImode)
                  || !
#line 17466 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1201; /* *ashrhi3_1_zextsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      x14 = XEXP (x2, 0);
      operands[0] = x14;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x7))
        {
        case CLOBBER:
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 17
              || GET_MODE (x8) != E_CCmode)
            return -1;
          switch (pattern347 (x3))
            {
            case 0:
              if (!
#line 17455 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1187; /* *lshrqi3_1_zexthi */

            case 1:
              if (!
#line 17455 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1191; /* *lshrqi3_1_zextsi */

            case 2:
              if (!
#line 17466 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1199; /* *lshrhi3_1_zextsi */

            case 3:
              if (!
#line 17455 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1195; /* *lshrqi3_1_zextdi */

            case 4:
              if (!
#line 17466 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
                return -1;
              return 1203; /* *lshrhi3_1_zextdi */

            case 5:
              if (!
#line 17478 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && ix86_binary_operator_ok (LSHIFTRT, SImode, operands, TARGET_APX_NDD)))
                return -1;
              return 1206; /* *lshrsi3_1_zext */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x7, 0) != 1
              || XINT (x7, 1) != 174)
            return -1;
          x15 = XVECEXP (x7, 0, 0);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern1230 (x3, 
E_SImode, 
E_DImode) != 0
              || !const_0_to_31_operand (operands[2], E_VOIDmode)
              || !
#line 2306 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW))
            return -1;
          return 2603; /* *klshrsi3_1_zext */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern348 (x1))
        {
        case 0:
          if (!
#line 18570 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1352; /* *rotlqi3_1_zexthi */

        case 1:
          if (!
#line 18570 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1356; /* *rotlqi3_1_zextsi */

        case 2:
          if (!
#line 18581 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1364; /* *rotlhi3_1_zextsi */

        case 3:
          if (!
#line 18570 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1360; /* *rotlqi3_1_zextdi */

        case 4:
          if (!
#line 18581 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1368; /* *rotlhi3_1_zextdi */

        case 5:
          if (!
#line 18593 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_binary_operator_ok (ROTATE, SImode, operands)))
            return -1;
          return 1371; /* *rotlsi3_1_zext */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern348 (x1))
        {
        case 0:
          if (!
#line 18570 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1354; /* *rotrqi3_1_zexthi */

        case 1:
          if (!
#line 18570 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1358; /* *rotrqi3_1_zextsi */

        case 2:
          if (!
#line 18581 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1366; /* *rotrhi3_1_zextsi */

        case 3:
          if (!
#line 18570 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1362; /* *rotrqi3_1_zextdi */

        case 4:
          if (!
#line 18581 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1370; /* *rotrhi3_1_zextdi */

        case 5:
          if (!
#line 18593 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_binary_operator_ok (ROTATERT, SImode, operands)))
            return -1;
          return 1372; /* *rotrsi3_1_zext */

        default:
          return -1;
        }

    case CTZ:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x14 = XEXP (x2, 0);
      operands[0] = x14;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (pattern935 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 21158 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1521; /* *ctzsidi2_uext */

        case 1:
          if (!
#line 21197 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1523; /* *ctzsidi2_uext_falsedep */

        default:
          return -1;
        }

    case CLZ:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x14 = XEXP (x2, 0);
      operands[0] = x14;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (pattern552 (x1, pnum_clobbers))
        {
        case 0:
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 21592 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT && TARGET_64BIT))
            return -1;
          return 1543; /* *clzsi2_lzcnt_zext_2 */

        case 1:
          x7 = XVECEXP (x1, 0, 1);
          x15 = XVECEXP (x7, 0, 0);
          switch (pattern1419 (x15))
            {
            case 0:
              if (!
#line 21617 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
                return -1;
              *pnum_clobbers = 1;
              return 1544; /* *clzsi2_lzcnt_zext_2_falsedep */

            case 1:
              if (!(
#line 21617 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1545; /* *clzsi2_lzcnt_zext_2_falsedep */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case POPCOUNT:
      x14 = XEXP (x2, 0);
      operands[0] = x14;
      switch (pattern552 (x1, pnum_clobbers))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern345 (x3, 
E_SImode, 
E_DImode) != 0
                  || !
#line 22285 "../../../gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT))
                return -1;
              return 1628; /* *popcountsi2_zext_2 */

            case E_SImode:
              if (pattern345 (x3, 
E_HImode, 
E_SImode) != 0
                  || !
#line 22351 "../../../gcc/config/i386/i386.md"
(TARGET_POPCNT
   && ix86_pre_reload_split ()))
                return -1;
              return 1631; /* *popcounthi2_2 */

            default:
              return -1;
            }

        case 1:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode
              || !nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          x15 = XVECEXP (x7, 0, 0);
          operands[2] = x15;
          if (!register_operand (operands[2], E_DImode)
              || !
#line 22316 "../../../gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1629; /* *popcountsi2_zext_2_falsedep */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (pattern379 (x7, 
174, 
0) != 0)
        return -1;
      x14 = XEXP (x2, 0);
      operands[0] = x14;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 2229 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW))
        return -1;
      return 2590; /* *knotsi_1_zext */

    case UNSPEC:
      return recog_367 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_395 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case ZERO_EXTEND:
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XEXP (x4, 1);
      if (GET_CODE (x8) != ZERO_EXTEND)
        return -1;
      x9 = XEXP (x6, 0);
      switch (GET_CODE (x9))
        {
        case TRUNCATE:
          if (GET_MODE (x9) != E_QImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != MOD
              || GET_MODE (x10) != E_HImode
              || XWINT (x7, 0) != 8L)
            return -1;
          x11 = XEXP (x8, 0);
          if (GET_CODE (x11) != TRUNCATE
              || GET_MODE (x11) != E_QImode)
            return -1;
          x12 = XEXP (x11, 0);
          if (GET_CODE (x12) != DIV
              || GET_MODE (x12) != E_HImode)
            return -1;
          x13 = XVECEXP (x1, 0, 1);
          if (pattern228 (x13, 
E_CCmode, 
17) != 0
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || GET_MODE (x5) != E_HImode
              || GET_MODE (x6) != E_HImode)
            return -1;
          x14 = XEXP (x10, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_HImode))
            return -1;
          x15 = XEXP (x10, 1);
          if (GET_MODE (x15) != E_HImode
              || GET_MODE (x8) != E_HImode)
            return -1;
          x16 = XEXP (x12, 1);
          if (GET_MODE (x16) != E_HImode)
            return -1;
          x17 = XEXP (x12, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          switch (GET_CODE (x15))
            {
            case SIGN_EXTEND:
              if (GET_CODE (x16) != SIGN_EXTEND)
                return -1;
              x18 = XEXP (x15, 0);
              operands[2] = x18;
              if (!nonimmediate_operand (operands[2], E_QImode))
                return -1;
              x19 = XEXP (x16, 0);
              if (!rtx_equal_p (x19, operands[2])
                  || !
#line 12017 "../../../gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && true))
                return -1;
              return 679; /* divmodhiqi3 */

            case ZERO_EXTEND:
              if (GET_CODE (x16) != ZERO_EXTEND)
                return -1;
              x18 = XEXP (x15, 0);
              operands[2] = x18;
              if (!nonimmediate_operand (operands[2], E_QImode))
                return -1;
              x19 = XEXP (x16, 0);
              if (!rtx_equal_p (x19, operands[2])
                  || !
#line 12017 "../../../gcc/config/i386/i386.md"
(TARGET_QIMODE_MATH
   && true))
                return -1;
              return 681; /* udivmodhiqi3 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x9;
          x13 = XVECEXP (x1, 0, 1);
          if (pattern379 (x13, 
174, 
0) != 0)
            return -1;
          x11 = XEXP (x8, 0);
          operands[2] = x11;
          switch (XWINT (x7, 0))
            {
            case 8L:
              if (pattern1565 (x4, 
E_QImode, 
E_HImode) != 0
                  || !
#line 2536 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F))
                return -1;
              return 2644; /* kunpckhi */

            case 16L:
              if (pattern1565 (x4, 
E_HImode, 
E_SImode) != 0
                  || !
#line 2550 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW))
                return -1;
              return 2645; /* kunpcksi */

            case 32L:
              if (pattern1565 (x4, 
E_SImode, 
E_DImode) != 0
                  || !
#line 2562 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW))
                return -1;
              return 2646; /* kunpckdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x13 = XVECEXP (x1, 0, 1);
      if (pattern228 (x13, 
E_CCmode, 
17) != 0)
        return -1;
      switch (pattern1045 (x4, 
LSHIFTRT))
        {
        case 0:
          x8 = XEXP (x4, 1);
          x11 = XEXP (x8, 0);
          x12 = XEXP (x11, 0);
          x17 = XEXP (x12, 0);
          operands[1] = x17;
          if (nonimmediate_operand (operands[0], E_DImode))
            {
              x7 = XEXP (x5, 1);
              x20 = XEXP (x7, 0);
              operands[2] = x20;
              if (rtx_equal_p (x6, operands[0]))
                {
                  x21 = XEXP (x11, 1);
                  x22 = XEXP (x21, 1);
                  x23 = XEXP (x22, 0);
                  if (rtx_equal_p (x23, operands[2])
                      && 
#line 15401 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && true))
                    return 1063; /* x86_64_shld */
                }
            }
          operands[2] = x17;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x5, 1);
          x20 = XEXP (x7, 0);
          operands[3] = x20;
          x21 = XEXP (x11, 1);
          x22 = XEXP (x21, 1);
          x23 = XEXP (x22, 0);
          if (!rtx_equal_p (x23, operands[3])
              || !
#line 15422 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1065; /* x86_64_shld_ndd */

        case 1:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || pattern1044 (x4, 
E_SImode, 
E_DImode) != 0)
            return -1;
          x8 = XEXP (x4, 1);
          x11 = XEXP (x8, 0);
          x12 = XEXP (x11, 0);
          x17 = XEXP (x12, 0);
          operands[1] = x17;
          x7 = XEXP (x5, 1);
          x20 = XEXP (x7, 0);
          operands[2] = x20;
          if (rtx_equal_p (x6, operands[0]))
            {
              x21 = XEXP (x11, 1);
              x22 = XEXP (x21, 1);
              x23 = XEXP (x22, 0);
              if (rtx_equal_p (x23, operands[2]))
                return 1075; /* x86_shld */
            }
          operands[2] = x17;
          operands[1] = x6;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          operands[3] = x20;
          x21 = XEXP (x11, 1);
          x22 = XEXP (x21, 1);
          x23 = XEXP (x22, 0);
          if (!rtx_equal_p (x23, operands[3])
              || !
#line 15653 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD && true))
            return -1;
          return 1077; /* x86_shld_ndd */

        case 2:
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case SUBREG:
              switch (pattern1237 (x4, 
LSHIFTRT))
                {
                case 0:
                  x7 = XEXP (x5, 1);
                  operands[2] = x7;
                  if (pattern1671 (x4) == 0
                      && 
#line 15437 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && true))
                    return 1067; /* x86_64_shld_1 */
                  operands[3] = x7;
                  if (pattern1672 (x4) != 0
                      || !
#line 15459 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && INTVAL (operands[4]) == 64 - INTVAL (operands[3])
   && true))
                    return -1;
                  return 1069; /* x86_64_shld_ndd_1 */

                case 1:
                  x7 = XEXP (x5, 1);
                  operands[2] = x7;
                  if (pattern1673 (x4) == 0
                      && 
#line 15669 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
  && true))
                    return 1079; /* x86_shld_1 */
                  operands[3] = x7;
                  if (pattern1674 (x4) != 0
                      || !
#line 15691 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD 
   && INTVAL (operands[4]) == 32 - INTVAL (operands[3])
   && true))
                    return -1;
                  return 1081; /* x86_shld_ndd_1 */

                default:
                  return -1;
                }

            case LSHIFTRT:
              switch (pattern1239 (x4))
                {
                case 0:
                  if (!
#line 15531 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && INTVAL (operands[3]) == 64 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  return 1071; /* *x86_64_shld_shrd_1_nozext */

                case 1:
                  if (!
#line 15763 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[3]) == 32 - INTVAL (operands[2])
   && ix86_pre_reload_split ()))
                    return -1;
                  return 1083; /* *x86_shld_shrd_1_nozext */

                case 2:
                  x11 = XEXP (x8, 0);
                  operands[1] = x11;
                  if (nonimmediate_operand (operands[0], E_DImode))
                    {
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      if (rtx_equal_p (x6, operands[0]))
                        {
                          x24 = XEXP (x8, 1);
                          x25 = XEXP (x24, 1);
                          if (rtx_equal_p (x25, operands[2])
                              && 
#line 15584 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            return 1072; /* *x86_64_shld_2 */
                        }
                    }
                  operands[2] = x11;
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  operands[1] = x6;
                  if (!nonimmediate_operand (operands[1], E_DImode))
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[3] = x7;
                  x24 = XEXP (x8, 1);
                  x25 = XEXP (x24, 1);
                  if (!rtx_equal_p (x25, operands[3])
                      || !
#line 15605 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  return 1073; /* *x86_64_shld_ndd_2 */

                case 3:
                  x11 = XEXP (x8, 0);
                  operands[1] = x11;
                  if (nonimmediate_operand (operands[0], E_SImode))
                    {
                      x7 = XEXP (x5, 1);
                      operands[2] = x7;
                      if (rtx_equal_p (x6, operands[0]))
                        {
                          x24 = XEXP (x8, 1);
                          x25 = XEXP (x24, 1);
                          if (rtx_equal_p (x25, operands[2])
                              && 
#line 15815 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_pre_reload_split ()))
                            return 1084; /* *x86_shld_2 */
                        }
                    }
                  operands[2] = x11;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  operands[1] = x6;
                  if (!nonimmediate_operand (operands[1], E_SImode))
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[3] = x7;
                  x24 = XEXP (x8, 1);
                  x25 = XEXP (x24, 1);
                  if (!rtx_equal_p (x25, operands[3])
                      || !
#line 15836 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NDD
   && ix86_pre_reload_split ()))
                    return -1;
                  return 1085; /* *x86_shld_ndd_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x6, 0) != 1L)
        return -1;
      x13 = XVECEXP (x1, 0, 1);
      if (pattern228 (x13, 
E_CCmode, 
17) != 0)
        return -1;
      switch (pattern369 (x4))
        {
        case 0:
          x7 = XEXP (x5, 1);
          operands[2] = x7;
          if (register_operand (operands[2], E_QImode))
            {
              switch (pattern944 (x4))
                {
                case 0:
                  if (
#line 18805 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT))
                    return 1391; /* *btssi */
                  break;

                case 1:
                  if ((
#line 18805 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return 1393; /* *btsdi */
                  break;

                default:
                  break;
                }
            }
          if (GET_CODE (x7) != SUBREG)
            return -1;
          switch (pattern1326 (x4))
            {
            case 0:
              if (!
#line 18824 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
                return -1;
              return 1395; /* *btssi_mask */

            case 1:
              if (!(
#line 18824 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1397; /* *btsdi_mask */

            default:
              return -1;
            }

        case 1:
          if (!
#line 18852 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (SImode)-1))
      == GET_MODE_BITSIZE (SImode)-1
   && ix86_pre_reload_split ()))
            return -1;
          return 1399; /* *btssi_mask_1 */

        case 2:
          if (!(
#line 18852 "../../../gcc/config/i386/i386.md"
(TARGET_USE_BT
   && (INTVAL (operands[2]) & (GET_MODE_BITSIZE (DImode)-1))
      == GET_MODE_BITSIZE (DImode)-1
   && ix86_pre_reload_split ()) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1401; /* *btsdi_mask_1 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_406 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          x4 = XEXP (x2, 1);
          if (GET_MODE (x4) != E_DImode)
            return -1;
          if (register_operand (operands[0], E_DImode)
              && register_operand (operands[1], E_DImode)
              && nonmemory_operand (operands[2], E_QImode)
              && 
#line 1195 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return 1131; /* ashrdi3_doubleword */
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[1], E_DImode))
            return -1;
          if (const_int_operand (operands[2], E_QImode)
              && (
#line 17244 "../../../gcc/config/i386/i386.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)-1
   && (TARGET_USE_CLTD || optimize_function_for_size_p (cfun))
   && ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return 1169; /* ashrdi3_cvt */
          if (!nonmemory_operand (operands[2], E_QImode)
              || !(
#line 17323 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, DImode, operands, TARGET_APX_NDD)
   && true) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1178; /* *ashrdi3_1 */

        case E_TImode:
          x4 = XEXP (x2, 1);
          if (pattern1247 (x4, 
E_TImode) != 0
              || !
#line 1196 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1133; /* ashrti3_doubleword */

        case E_SImode:
          x4 = XEXP (x2, 1);
          if (pattern1494 (x4, 
E_SImode) != 0
              || !
#line 17323 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, SImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          return 1176; /* *ashrsi3_1 */

        case E_QImode:
          x4 = XEXP (x2, 1);
          if (pattern1494 (x4, 
E_QImode) != 0
              || !
#line 17532 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, QImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          return 1209; /* *ashrqi3_1 */

        case E_HImode:
          x4 = XEXP (x2, 1);
          if (pattern1494 (x4, 
E_HImode) != 0
              || !
#line 17532 "../../../gcc/config/i386/i386.md"
(ix86_binary_operator_ok (ASHIFTRT, HImode, operands, TARGET_APX_NDD)
   && true))
            return -1;
          return 1211; /* *ashrhi3_1 */

        case E_V2QImode:
          x4 = XEXP (x2, 1);
          if (pattern1247 (x4, 
E_V2QImode) != 0
              || !
#line 4007 "../../../gcc/config/i386/mmx.md"
(!TARGET_PARTIAL_REG_STALL || optimize_size))
            return -1;
          return 2210; /* ashrv2qi3 */

        default:
          return -1;
        }

    case STRICT_LOW_PART:
      switch (pattern1248 (x2))
        {
        case 0:
          if (!
#line 17638 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 1217; /* *ashrqi3_1_slp */

        case 1:
          if (!
#line 17638 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)))
            return -1;
          return 1219; /* *ashrhi3_1_slp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_409 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (pattern819 (x3) != 0)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 7
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x6, 1);
  operands[2] = x9;
  x10 = XEXP (x3, 1);
  operands[3] = x10;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  if (call_insn_operand (operands[1], E_SImode)
      && 
#line 20433 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && !SIBLING_CALL_P (insn)))
    return 1483; /* *call_value_pop */
  if (!sibcall_insn_operand (operands[1], E_SImode)
      || !
#line 20444 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && SIBLING_CALL_P (insn)))
    return -1;
  return 1484; /* *sibcall_value_pop */
}

 int
recog_410 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case UNSPEC:
      res = recog_408 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case SET:
      res = recog_409 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != PLUS
      || GET_MODE (x7) != E_DImode
      || GET_CODE (x6) != UNSPEC
      || GET_MODE (x3) != E_DImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (!register_operand (x8, E_DImode))
    return -1;
  x9 = XEXP (x7, 1);
  if (!immediate_operand (x9, E_DImode)
      || GET_MODE (x6) != E_DImode)
    return -1;
  switch (XVECLEN (x6, 0))
    {
    case 2:
      if (XINT (x6, 1) != 20)
        return -1;
      x10 = XVECEXP (x6, 0, 1);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 7
          || GET_MODE (x10) != E_DImode)
        return -1;
      operands[2] = x8;
      operands[3] = x9;
      x11 = XEXP (x3, 1);
      operands[4] = x11;
      x12 = XVECEXP (x6, 0, 0);
      operands[1] = x12;
      if (!tls_symbolic_operand (operands[1], E_VOIDmode)
          || !
#line 22869 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_cmodel == CM_LARGE_PIC && !TARGET_PECOFF
   && GET_CODE (operands[3]) == CONST
   && GET_CODE (XEXP (operands[3], 0)) == UNSPEC
   && XINT (XEXP (operands[3], 0), 1) == UNSPEC_PLTOFF))
        return -1;
      return 1646; /* *tls_global_dynamic_64_largepic */

    case 1:
      if (XINT (x6, 1) != 21)
        return -1;
      x12 = XVECEXP (x6, 0, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 7
          || GET_MODE (x12) != E_DImode)
        return -1;
      operands[1] = x8;
      operands[2] = x9;
      x11 = XEXP (x3, 1);
      operands[3] = x11;
      if (!
#line 22963 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT && ix86_cmodel == CM_LARGE_PIC && !TARGET_PECOFF
   && GET_CODE (operands[2]) == CONST
   && GET_CODE (XEXP (operands[2], 0)) == UNSPEC
   && XINT (XEXP (operands[2], 0), 1) == UNSPEC_PLTOFF))
        return -1;
      return 1650; /* *tls_local_dynamic_base_64_largepic */

    default:
      return -1;
    }
}

 int
recog_418 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 4
      || XINT (x4, 1) != 153)
    return -1;
  x5 = XVECEXP (x4, 0, 1);
  if (GET_CODE (x5) != MEM)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 3
      || XINT (x6, 1) != 154)
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_BLKmode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != SCRATCH)
    return -1;
  x9 = XEXP (x3, 1);
  if (GET_CODE (x9) != PARALLEL
      || XVECLEN (x9, 0) != 4)
    return -1;
  x10 = XVECEXP (x9, 0, 0);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x11 = XVECEXP (x9, 0, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x12 = XVECEXP (x9, 0, 2);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x13 = XVECEXP (x9, 0, 3);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x14 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x2, 0);
  operands[0] = x15;
  x16 = XVECEXP (x6, 0, 1);
  if (!register_operand (x16, E_V4DImode))
    return -1;
  x17 = XVECEXP (x6, 0, 2);
  if (!const1248_operand (x17, E_SImode))
    return -1;
  x18 = XEXP (x14, 0);
  operands[1] = x18;
  x19 = XVECEXP (x4, 0, 0);
  switch (GET_CODE (x19))
    {
    case REG:
    case SUBREG:
      operands[2] = x19;
      operands[7] = x5;
      x20 = XVECEXP (x6, 0, 0);
      operands[3] = x20;
      operands[4] = x16;
      operands[6] = x17;
      x21 = XVECEXP (x4, 0, 3);
      operands[5] = x21;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          switch (pattern1843 (x3, 
E_V8SImode, 
E_V4SImode, 
E_SImode))
            {
            case 0:
              if (!(
#line 29417 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9733; /* *avx2_gatherdiv8si_3 */

            case 1:
              if (!(
#line 29417 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9735; /* *avx2_gatherdiv8si_3 */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern1843 (x3, 
E_V8SFmode, 
E_V4SFmode, 
E_SFmode))
            {
            case 0:
              if (!(
#line 29417 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9734; /* *avx2_gatherdiv8sf_3 */

            case 1:
              if (!(
#line 29417 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9736; /* *avx2_gatherdiv8sf_3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PC:
      operands[6] = x5;
      x20 = XVECEXP (x6, 0, 0);
      operands[2] = x20;
      operands[3] = x16;
      operands[5] = x17;
      x21 = XVECEXP (x4, 0, 3);
      operands[4] = x21;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          switch (pattern1839 (x3, 
E_V8SImode, 
E_V4SImode, 
E_SImode))
            {
            case 0:
              if (!(
#line 29441 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9737; /* *avx2_gatherdiv8si_4 */

            case 1:
              if (!(
#line 29441 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9739; /* *avx2_gatherdiv8si_4 */

            default:
              return -1;
            }

        case E_V4SFmode:
          switch (pattern1839 (x3, 
E_V8SFmode, 
E_V4SFmode, 
E_SFmode))
            {
            case 0:
              if (!(
#line 29441 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 9738; /* *avx2_gatherdiv8sf_4 */

            case 1:
              if (!(
#line 29441 "../../../gcc/config/i386/sse.md"
(TARGET_AVX2) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 9740; /* *avx2_gatherdiv8sf_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_427 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case UNSPEC:
      return recog_422 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[1] = x6;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern228 (x7, 
E_CCmode, 
17) != 0)
            return -1;
          x8 = XEXP (x4, 0);
          operands[2] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern1438 (x3, 
E_SImode, 
E_DImode) != 0
                  || !
#line 4985 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
                return -1;
              return 185; /* extendsidi2_1 */

            case E_TImode:
              if (pattern1438 (x3, 
E_DImode, 
E_TImode) != 0
                  || !
#line 4993 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 186; /* extendditi2 */

            default:
              return -1;
            }

        case CTZ:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != UNSPEC
              || XVECLEN (x7, 0) != 1
              || XINT (x7, 1) != 38)
            return -1;
          x8 = XEXP (x4, 0);
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 17
              || GET_MODE (x8) != E_CCmode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x9 = XEXP (x6, 0);
          operands[1] = x9;
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          x10 = XVECEXP (x7, 0, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_DImode)
              || !
#line 21197 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1522; /* *ctzsidi2_sext_falsedep */

        default:
          return -1;
        }

    case FIX:
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != USE)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_VOIDmode))
        return -1;
      switch (pattern822 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 6021 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !(TARGET_64BIT && SSE_FLOAT_MODE_P (GET_MODE (operands[1])))))
            return -1;
          *pnum_clobbers = 1;
          return 235; /* fix_truncdi_i387 */

        case 1:
          if (!
#line 6034 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !SSE_FLOAT_MODE_P (GET_MODE (operands[1]))))
            return -1;
          return 236; /* fix_trunchi_i387 */

        case 2:
          if (!
#line 6034 "../../../gcc/config/i386/i386.md"
(X87_FLOAT_MODE_P (GET_MODE (operands[1]))
   && !TARGET_FISTTP
   && !SSE_FLOAT_MODE_P (GET_MODE (operands[1]))))
            return -1;
          return 237; /* fix_truncsi_i387 */

        default:
          return -1;
        }

    case UNSIGNED_FLOAT:
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      switch (pattern571 (x1))
        {
        case 0:
          if (!
#line 6297 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT
   && TARGET_80387 && X87_ENABLE_FLOAT (SFmode, DImode)
   && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC))
            return -1;
          return 261; /* floatunssisf2_i387_with_xmm */

        case 1:
          if (!
#line 6297 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT
   && TARGET_80387 && X87_ENABLE_FLOAT (DFmode, DImode)
   && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC))
            return -1;
          return 262; /* floatunssidf2_i387_with_xmm */

        case 2:
          if (!
#line 6297 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT
   && TARGET_80387 && X87_ENABLE_FLOAT (XFmode, DImode)
   && TARGET_SSE2 && TARGET_INTER_UNIT_MOVES_TO_VEC))
            return -1;
          return 263; /* floatunssixf2_i387_with_xmm */

        default:
          return -1;
        }

    case EQ:
      return recog_426 (x1, insn, pnum_clobbers);

    case SMUL_HIGHPART:
      switch (pattern216 (x1))
        {
        case 0:
          if (!
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 627; /* smulsi3_highpart */

        case 1:
          if (!
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 629; /* smuldi3_highpart */

        default:
          return -1;
        }

    case UMUL_HIGHPART:
      switch (pattern216 (x1))
        {
        case 0:
          if (!
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 628; /* umulsi3_highpart */

        case 1:
          if (!
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 630; /* umuldi3_highpart */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      return recog_423 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != LSHIFTRT)
        return -1;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != MULT)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER
          || pattern826 (x1) != 0)
        return -1;
      x12 = XEXP (x7, 0);
      operands[3] = x12;
      x13 = XEXP (x9, 0);
      switch (GET_CODE (x13))
        {
        case SIGN_EXTEND:
          switch (pattern1497 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 11174 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 633; /* *smuldi3_highpart_1 */

            case 1:
              if (!
#line 11223 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 637; /* *smulsi3_highpart_1 */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1497 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 11174 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 634; /* *umuldi3_highpart_1 */

            case 1:
              if (!
#line 11223 "../../../gcc/config/i386/i386.md"
(!(MEM_P (operands[1]) && MEM_P (operands[2]))))
                return -1;
              return 638; /* *umulsi3_highpart_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      switch (pattern217 (x1))
        {
        case 0:
          switch (pattern1333 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 639; /* divmodsi4_1 */

            case 1:
              if (!
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 640; /* divmoddi4_1 */

            case 2:
              if (!
#line 1191 "../../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH))
                return -1;
              return 647; /* *divmodhi4 */

            case 3:
              return 648; /* *divmodsi4 */

            case 4:
              if (!
#line 1192 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 649; /* *divmoddi4 */

            case 5:
              if ((
#line 11851 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 1191 "../../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH)))
                return 661; /* *divmodhi4_noext_nf */
              if (pnum_clobbers == NULL
                  || !
#line 1191 "../../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH))
                return -1;
              *pnum_clobbers = 1;
              return 667; /* *divmodhi4_noext */

            case 6:
              if (
#line 11851 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF))
                return 663; /* *divmodsi4_noext_nf */
              if (pnum_clobbers == NULL)
                return -1;
              *pnum_clobbers = 1;
              return 669; /* *divmodsi4_noext */

            case 7:
              if ((
#line 11851 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 1192 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 665; /* *divmoddi4_noext_nf */
              if (pnum_clobbers == NULL
                  || !
#line 1192 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 671; /* *divmoddi4_noext */

            default:
              return -1;
            }

        case 1:
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 2);
          if (pattern951 (x4, 
E_CCmode, 
17) != 0
              || pattern1492 (x1) != 0
              || !
#line 11907 "../../../gcc/config/i386/i386.md"
(!optimize_function_for_size_p (cfun)))
            return -1;
          return 677; /* *divmodsi4_const */

        default:
          return -1;
        }

    case UDIV:
      switch (pattern218 (x1))
        {
        case 0:
          switch (pattern1333 (x1, pnum_clobbers))
            {
            case 0:
              *pnum_clobbers = 1;
              return 641; /* udivmodsi4_1 */

            case 1:
              if (!
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 642; /* udivmoddi4_1 */

            case 2:
              if (!
#line 1191 "../../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH))
                return -1;
              return 650; /* *udivmodhi4 */

            case 3:
              return 651; /* *udivmodsi4 */

            case 4:
              if (!
#line 1192 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              return 652; /* *udivmoddi4 */

            case 5:
              if ((
#line 11851 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 1191 "../../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH)))
                return 662; /* *udivmodhi4_noext_nf */
              if (pnum_clobbers == NULL
                  || !
#line 1191 "../../../gcc/config/i386/i386.md"
(TARGET_HIMODE_MATH))
                return -1;
              *pnum_clobbers = 1;
              return 668; /* *udivmodhi4_noext */

            case 6:
              if (
#line 11851 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF))
                return 664; /* *udivmodsi4_noext_nf */
              if (pnum_clobbers == NULL)
                return -1;
              *pnum_clobbers = 1;
              return 670; /* *udivmodsi4_noext */

            case 7:
              if ((
#line 11851 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 1192 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return 666; /* *udivmoddi4_noext_nf */
              if (pnum_clobbers == NULL
                  || !
#line 1192 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return -1;
              *pnum_clobbers = 1;
              return 672; /* *udivmoddi4_noext */

            default:
              return -1;
            }

        case 1:
          x4 = XVECEXP (x1, 0, 2);
          if (pattern951 (x4, 
E_CCmode, 
17) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1493 (x1, 
E_SImode) != 0
                  || !
#line 11660 "../../../gcc/config/i386/i386.md"
(IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)))
                return -1;
              return 653; /* *udivmodsi4_pow2 */

            case E_DImode:
              if (pattern1493 (x1, 
E_DImode) != 0
                  || !(
#line 11660 "../../../gcc/config/i386/i386.md"
(IN_RANGE (exact_log2 (UINTVAL (operands[3])), 1, 31)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 654; /* *udivmoddi4_pow2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 14834 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1016; /* *abshf2_1 */

        case 1:
          if (!
#line 14850 "../../../gcc/config/i386/i386.md"
(TARGET_80387 || (SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
            return -1;
          return 1018; /* *abssf2_1 */

        case 2:
          if (!
#line 14850 "../../../gcc/config/i386/i386.md"
(TARGET_80387 || (SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
            return -1;
          return 1020; /* *absdf2_1 */

        default:
          return -1;
        }

    case NEG:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 14834 "../../../gcc/config/i386/i386.md"
(TARGET_AVX512FP16))
            return -1;
          return 1017; /* *neghf2_1 */

        case 1:
          if (!
#line 14850 "../../../gcc/config/i386/i386.md"
(TARGET_80387 || (SSE_FLOAT_MODE_P (SFmode) && TARGET_SSE_MATH)))
            return -1;
          return 1019; /* *negsf2_1 */

        case 2:
          if (!
#line 14850 "../../../gcc/config/i386/i386.md"
(TARGET_80387 || (SSE_FLOAT_MODE_P (DFmode) && TARGET_SSE_MATH)))
            return -1;
          return 1021; /* *negdf2_1 */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern222 (x1))
        {
        case 0:
          if (!
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 1332; /* ix86_rotldi3_doubleword */

        case 1:
          if (!
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1333; /* ix86_rotlti3_doubleword */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern222 (x1))
        {
        case 0:
          if (!
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
            return -1;
          return 1334; /* ix86_rotrdi3_doubleword */

        case 1:
          if (!
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1335; /* ix86_rotrti3_doubleword */

        default:
          return -1;
        }

    case CALL:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_QImode
          || pattern381 (x1) != 0)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      if (!memory_operand (operands[1], E_SImode))
        return -1;
      x14 = XEXP (x3, 1);
      operands[2] = x14;
      x7 = XVECEXP (x1, 0, 1);
      x15 = XEXP (x7, 1);
      x16 = XEXP (x15, 1);
      operands[3] = x16;
      if (!immediate_operand (operands[3], E_SImode)
          || !
#line 20456 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && !TARGET_INDIRECT_BRANCH_REGISTER))
        return -1;
      return 1485; /* *sibcall_value_pop_memory */

    case PLUS:
      x4 = XVECEXP (x1, 0, 2);
      if (pattern223 (x4) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) == REG
          && REGNO (x6) == 6)
        {
          x14 = XEXP (x3, 1);
          if (GET_CODE (x14) == CONST_INT)
            {
              x5 = XEXP (x2, 0);
              if (GET_CODE (x5) == REG
                  && REGNO (x5) == 7)
                {
                  x7 = XVECEXP (x1, 0, 1);
                  if (pattern710 (x7, 
6, 
MEM) == 0)
                    {
                      switch (XWINT (x14, 0))
                        {
                        case 4L:
                          if (pattern1675 (x1, 
E_SImode) == 0
                              && 
#line 20862 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT))
                            return 1504; /* *leave */
                          break;

                        case 8L:
                          if (pattern1675 (x1, 
E_DImode) == 0
                              && 
#line 20870 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                            return 1505; /* *leave_rex64 */
                          break;

                        default:
                          break;
                        }
                    }
                }
            }
        }
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x12 = XEXP (x7, 0);
      if (GET_CODE (x12) != REG
          || REGNO (x12) != 17
          || GET_MODE (x12) != E_CCmode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      operands[1] = x6;
      x14 = XEXP (x3, 1);
      operands[2] = x14;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1501 (x3, 
E_SImode) != 0
              || !
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))
            return -1;
          return 1849; /* pro_epilogue_adjust_stack_add_si */

        case E_DImode:
          if (pattern1501 (x3, 
E_DImode) != 0
              || !
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))
            return -1;
          return 1850; /* pro_epilogue_adjust_stack_add_di */

        default:
          return -1;
        }

    case FFS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != CLOBBER
          || pattern709 (x1) != 0
          || !
#line 20965 "../../../gcc/config/i386/i386.md"
(!TARGET_CMOVE))
        return -1;
      return 1507; /* ffssi2_no_cmove */

    case COMPARE:
      if (GET_MODE (x3) != E_CCCmode)
        return -1;
      x14 = XEXP (x3, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || pattern572 (x1, 
CTZ, 
E_CCCmode) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != 38)
        return -1;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x7 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x7, 0);
      operands[0] = x12;
      x17 = XVECEXP (x4, 0, 0);
      operands[2] = x17;
      x15 = XEXP (x7, 1);
      x18 = XEXP (x15, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (pattern1654 (x15, 
E_SImode) != 0
              || !
#line 21023 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))
            return -1;
          return 1510; /* *tzcntsi_1_falsedep */

        case E_DImode:
          if (pattern1654 (x15, 
E_DImode) != 0
              || !(
#line 21023 "../../../gcc/config/i386/i386.md"
(TARGET_BMI) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1511; /* *tzcntdi_1_falsedep */

        default:
          return -1;
        }

    case CTZ:
      switch (pattern226 (x1))
        {
        case 0:
          return 1516; /* *ctzsi2_falsedep */

        case 1:
          if (!
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
            return -1;
          return 1517; /* *ctzdi2_falsedep */

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != SUBREG
          || maybe_ne (SUBREG_BYTE (x6), 0)
          || GET_MODE (x6) != E_DImode)
        return -1;
      x14 = XEXP (x3, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 63])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 38
          || pattern826 (x1) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x9 = XEXP (x6, 0);
      if (GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XVECEXP (x7, 0, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      switch (GET_CODE (x9))
        {
        case CTZ:
          x13 = XEXP (x9, 0);
          operands[1] = x13;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 21145 "../../../gcc/config/i386/i386.md"
(TARGET_BMI && TARGET_64BIT))
            return -1;
          return 1519; /* *ctzsi2_zext_falsedep */

        case CLZ:
          x13 = XEXP (x9, 0);
          operands[1] = x13;
          switch (GET_MODE (operands[1]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 21581 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
                return -1;
              return 1541; /* *clzsi2_lzcnt_zext_falsedep */

            case E_DImode:
              if (!nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 21581 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return -1;
              return 1542; /* *clzsi2_lzcnt_zext_falsedep */

            default:
              return -1;
            }

        case POPCOUNT:
          x13 = XEXP (x9, 0);
          operands[1] = x13;
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !
#line 22268 "../../../gcc/config/i386/i386.md"
(TARGET_POPCNT && TARGET_64BIT))
            return -1;
          return 1627; /* *popcountsi2_zext_falsedep */

        default:
          return -1;
        }

    case CLZ:
      switch (pattern226 (x1))
        {
        case 0:
          if (!
#line 21538 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT))
            return -1;
          return 1538; /* *clzsi2_lzcnt_falsedep */

        case 1:
          if (!(
#line 21538 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1539; /* *clzdi2_lzcnt_falsedep */

        default:
          return -1;
        }

    case POPCOUNT:
      switch (pattern226 (x1))
        {
        case 0:
          if (!
#line 22213 "../../../gcc/config/i386/i386.md"
(TARGET_POPCNT))
            return -1;
          return 1624; /* *popcountsi2_falsedep */

        case 1:
          if (!(
#line 22213 "../../../gcc/config/i386/i386.md"
(TARGET_POPCNT) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return -1;
          return 1625; /* *popcountdi2_falsedep */

        default:
          return -1;
        }

    case MEM:
      return recog_425 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
      operands[2] = x3;
      if (pattern227 (x1) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (pattern380 (x4, 
36) != 0)
        return -1;
      x5 = XEXP (x2, 0);
      x19 = XEXP (x5, 0);
      operands[1] = x19;
      x7 = XVECEXP (x1, 0, 1);
      x12 = XEXP (x7, 0);
      operands[0] = x12;
      x15 = XEXP (x7, 1);
      x18 = XEXP (x15, 0);
      if (!rtx_equal_p (x18, operands[1]))
        return -1;
      x16 = XEXP (x15, 1);
      switch (XWINT (x16, 0))
        {
        case 8L:
          switch (pattern1569 (x1, 
E_DImode))
            {
            case 0:
              if (!(
#line 25677 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1769; /* *strsetdi_rex_1 */

            case 1:
              if (!(
#line 25677 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && !(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1770; /* *strsetdi_rex_1 */

            default:
              return -1;
            }

        case 4L:
          switch (pattern1569 (x1, 
E_SImode))
            {
            case 0:
              if (!(
#line 25692 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1771; /* *strsetsi_1 */

            case 1:
              if (!(
#line 25692 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1772; /* *strsetsi_1 */

            default:
              return -1;
            }

        case 2L:
          switch (pattern1569 (x1, 
E_HImode))
            {
            case 0:
              if (!(
#line 25706 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1773; /* *strsethi_1 */

            case 1:
              if (!(
#line 25706 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1774; /* *strsethi_1 */

            default:
              return -1;
            }

        case 1L:
          switch (pattern1569 (x1, 
E_QImode))
            {
            case 0:
              if (!(
#line 25720 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
                return -1;
              return 1775; /* *strsetqi_1 */

            case 1:
              if (!(
#line 25720 "../../../gcc/config/i386/i386.md"
(!(fixed_regs[AX_REG] || fixed_regs[DI_REG])
   && ix86_check_no_addr_space (insn)) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
                return -1;
              return 1776; /* *strsetqi_1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x7 = XVECEXP (x1, 0, 1);
      if (pattern228 (x7, 
E_CCmode, 
17) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (pattern223 (x4) != 0)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x3, 0);
      operands[1] = x6;
      x14 = XEXP (x3, 1);
      operands[2] = x14;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern566 (x3, 
E_SImode) != 0
              || !
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode))
            return -1;
          return 1851; /* pro_epilogue_adjust_stack_sub_si */

        case E_DImode:
          if (pattern566 (x3, 
E_DImode) != 0
              || !
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode))
            return -1;
          return 1852; /* pro_epilogue_adjust_stack_sub_di */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_424 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case COMPARE:
      return split_5 (x1, insn);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[1] = x2;
      res = split_1 (x1, insn);
      if (res != NULL_RTX)
        return res;
      switch (GET_CODE (x2))
        {
        case REG:
          if (REGNO (x2) != 17
              || pattern56 (x1, 
E_CCCmode) != 0
              || !(
#line 9883 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9885 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_195 (insn, operands);

        case SUBREG:
          if (maybe_ne (SUBREG_BYTE (x2), 0))
            return NULL;
          x3 = XEXP (x2, 0);
          switch (GET_CODE (x3))
            {
            case NOT:
              switch (pattern250 (x1))
                {
                case 0:
                  if (!
#line 15143 "../../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_549 (insn, operands);

                case 1:
                  if (!
#line 15143 "../../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_550 (insn, operands);

                case 2:
                  if (!(
#line 15143 "../../../gcc/config/i386/i386.md"
(reload_completed
   && !(rtx_equal_p (operands[0], operands[1]))) && 
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                    return NULL;
                  return gen_split_551 (insn, operands);

                default:
                  return NULL;
                }

            case LSHIFTRT:
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              switch (pattern291 (x2))
                {
                case 0:
                  if (!((
#line 16736 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16738 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_601 (insn, operands);

                case 1:
                  if (!((
#line 16736 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 8 * BITS_PER_UNIT) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16738 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_603 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFTRT:
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              switch (pattern291 (x2))
                {
                case 0:
                  if (!((
#line 16736 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 4 * BITS_PER_UNIT) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 16738 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_602 (insn, operands);

                case 1:
                  if (!((
#line 16736 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && UINTVAL (operands[2]) < 8 * BITS_PER_UNIT) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 16738 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                    return NULL;
                  return gen_split_604 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case PLUS:
      return split_6 (x1, insn);

    case IOR:
      return split_7 (x1, insn);

    case XOR:
      return split_8 (x1, insn);

    case FLOAT_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_CODE (operands[1]))
        {
        case SUBREG:
        case MEM:
          if (memory_operand (operands[1], E_VOIDmode)
              && any_fp_register_operand (operands[0], E_VOIDmode)
              && 
#line 4614 "../../../gcc/config/i386/i386.md"
(reload_completed
   && (GET_MODE (operands[0]) == TFmode
       || GET_MODE (operands[0]) == XFmode
       || GET_MODE (operands[0]) == DFmode)
   && ix86_standard_x87sse_constant_load_p (insn, operands[0])))
            return gen_split_49 (insn, operands);
          break;

        case REG:
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        default:
          break;
        }
      if (!nonimmediate_operand (operands[1], E_SFmode)
          || !sse_reg_operand (operands[0], E_DFmode)
          || GET_MODE (x2) != E_DFmode)
        return NULL;
      if (
#line 5339 "../../../gcc/config/i386/i386.md"
(TARGET_USE_VECTOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()
   && reload_completed
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return gen_split_70 (insn, operands);
      if (!
#line 5402 "../../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_FP_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!REG_P (operands[1])
       || (!TARGET_AVX && REGNO (operands[0]) != REGNO (operands[1])))
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return NULL;
      return gen_split_71 (insn, operands);

    case ZERO_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !(
#line 4660 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 4662 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_53 (insn, operands);

            case E_DImode:
              if (GET_MODE (x2) != E_DImode)
                return NULL;
              if (memory_operand (operands[0], E_DImode)
                  && memory_operand (operands[1], E_SImode)
                  && 
#line 4784 "../../../gcc/config/i386/i386.md"
(reload_completed))
                return gen_split_54 (insn, operands);
              if (general_reg_operand (operands[0], E_DImode)
                  && general_reg_operand (operands[1], E_SImode)
                  && 
#line 4791 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed
   && REGNO (operands[0]) == REGNO (operands[1])))
                return gen_split_55 (insn, operands);
              if (!nonimmediate_gr_operand (operands[0], E_DImode)
                  || !nonimmediate_operand (operands[1], E_SImode)
                  || !
#line 4799 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && reload_completed
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))))
                return NULL;
              return gen_split_56 (insn, operands);

            default:
              return NULL;
            }

        case UNSPEC:
          if (XVECLEN (x3, 0) != 1
              || XINT (x3, 1) != 19
              || GET_MODE (x3) != E_SImode)
            return NULL;
          x5 = XVECEXP (x3, 0, 0);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !(
#line 23045 "../../../gcc/config/i386/i386.md"
(TARGET_X32) && 
#line 23047 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_909 (insn, operands);

        default:
          return NULL;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!sse_reg_operand (operands[0], E_SFmode))
        return NULL;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return NULL;
      if (
#line 5578 "../../../gcc/config/i386/i386.md"
(TARGET_USE_VECTOR_FP_CONVERTS
   && optimize_insn_for_speed_p ()
   && reload_completed
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return gen_split_72 (insn, operands);
      if (!
#line 5632 "../../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_FP_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!REG_P (operands[1])
       || (!TARGET_AVX && REGNO (operands[0]) != REGNO (operands[1])))
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
        return NULL;
      return gen_split_73 (insn, operands);

    case FLOAT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (GET_MODE (x2) != E_SFmode)
            return NULL;
          if (sse_reg_operand (operands[0], E_SFmode)
              && nonimmediate_operand (operands[1], E_SImode))
            {
              if (
#line 6159 "../../../gcc/config/i386/i386.md"
(TARGET_SSE2
   && TARGET_USE_VECTOR_CONVERTS
   && optimize_function_for_speed_p (cfun)
   && reload_completed
   && (MEM_P (operands[1]) || TARGET_INTER_UNIT_MOVES_TO_VEC)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
                return gen_split_79 (insn, operands);
              if (
#line 6244 "../../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
                return gen_split_87 (insn, operands);
            }
          if (register_operand (operands[0], E_SFmode)
              && register_operand (operands[1], E_DImode)
              && 
#line 6188 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (SFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)
   && can_create_pseudo_p ()))
            return gen_split_81 (insn, operands);
          if (!sse_reg_operand (operands[0], E_SFmode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 6244 "../../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_88 (insn, operands);

        case E_DFmode:
          if (GET_MODE (x2) != E_DFmode)
            return NULL;
          if (sse_reg_operand (operands[0], E_DFmode)
              && nonimmediate_operand (operands[1], E_SImode))
            {
              if (
#line 6159 "../../../gcc/config/i386/i386.md"
(TARGET_SSE2
   && TARGET_USE_VECTOR_CONVERTS
   && optimize_function_for_speed_p (cfun)
   && reload_completed
   && (MEM_P (operands[1]) || TARGET_INTER_UNIT_MOVES_TO_VEC)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
                return gen_split_80 (insn, operands);
              if (
#line 6244 "../../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)))
                return gen_split_89 (insn, operands);
            }
          if (register_operand (operands[0], E_DFmode)
              && register_operand (operands[1], E_DImode)
              && 
#line 6188 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (DFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)
   && can_create_pseudo_p ()))
            return gen_split_82 (insn, operands);
          if (!sse_reg_operand (operands[0], E_DFmode)
              || !nonimmediate_operand (operands[1], E_DImode)
              || !(
#line 6244 "../../../gcc/config/i386/i386.md"
(!TARGET_AVX
   && TARGET_SSE_PARTIAL_REG_CONVERTS_DEPENDENCY
   && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && (!EXT_REX_SSE_REG_P (operands[0])
       || TARGET_AVX512VL)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_90 (insn, operands);

        case E_XFmode:
          if (!register_operand (operands[0], E_XFmode)
              || GET_MODE (x2) != E_XFmode
              || !register_operand (operands[1], E_DImode)
              || !
#line 6188 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_INTER_UNIT_MOVES_TO_VEC
   && TARGET_80387 && X87_ENABLE_FLOAT (XFmode, DImode)
   && TARGET_SSE2 && optimize_function_for_speed_p (cfun)
   && can_create_pseudo_p ()))
            return NULL;
          return gen_split_83 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      x3 = XEXP (x2, 0);
      if (!rtx_equal_p (x3, operands[0]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!general_reg_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !const1248_operand (operands[1], E_SImode)
              || !
#line 6428 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed))
            return NULL;
          return gen_split_96 (insn, operands);

        case E_DImode:
          if (!general_reg_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !const1248_operand (operands[1], E_DImode)
              || !(
#line 6428 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && reload_completed) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_97 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      switch (XVECLEN (x2, 0))
        {
        case 2:
          switch (XINT (x2, 1))
            {
            case 40:
              if (GET_MODE (x2) != E_CCCmode)
                return NULL;
              x7 = XVECEXP (x2, 0, 0);
              if (GET_CODE (x7) != LTU
                  || pattern714 (x7) != 0
                  || pattern247 (x1) != 0)
                return NULL;
              x8 = XEXP (x7, 0);
              switch (GET_MODE (x8))
                {
                case E_CCmode:
                  if (!(
#line 9904 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9906 "../../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_198 (insn, operands);

                case E_CCCmode:
                  if (!(
#line 9904 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 9906 "../../../gcc/config/i386/i386.md"
( 1)))
                    return NULL;
                  return gen_split_199 (insn, operands);

                default:
                  return NULL;
                }

            case 45:
              if (pattern295 (x2) != 0)
                return NULL;
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              if (!register_operand (operands[0], E_SImode))
                return NULL;
              x9 = XVECEXP (x2, 0, 1);
              operands[2] = x9;
              if (!register_operand (operands[2], E_SImode)
                  || !(
#line 19556 "../../../gcc/config/i386/i386.md"
(ix86_pre_reload_split ()) && 
#line 19558 "../../../gcc/config/i386/i386.md"
( 1)))
                return NULL;
              return gen_split_856 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          switch (XINT (x2, 1))
            {
            case 97:
              switch (pattern299 (x2))
                {
                case 0:
                  if (!((
#line 21642 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21624 "../../../gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 21644 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_890 (insn, operands);

                case 1:
                  if (!((
#line 21642 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && (((
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21624 "../../../gcc/config/i386/i386.md"
(TARGET_BMI)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21624 "../../../gcc/config/i386/i386.md"
(TARGET_BMI))) && 
#line 21644 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_892 (insn, operands);

                default:
                  return NULL;
                }

            case 96:
              switch (pattern299 (x2))
                {
                case 0:
                  if (!((
#line 21642 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && 
#line 21625 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 21644 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_891 (insn, operands);

                case 1:
                  if (!((
#line 21642 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF) && (((
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT) && 
#line 21625 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT)) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21625 "../../../gcc/config/i386/i386.md"
(TARGET_LZCNT))) && 
#line 21644 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
                    return NULL;
                  return gen_split_893 (insn, operands);

                default:
                  return NULL;
                }

            case 19:
              x7 = XVECEXP (x2, 0, 0);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              switch (pattern23 (x2))
                {
                case 0:
                  if (!
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == SImode))
                    return NULL;
                  return gen_split_907 (insn, operands);

                case 1:
                  if (!
#line 1408 "../../../gcc/config/i386/i386.md"
(ptr_mode == DImode))
                    return NULL;
                  return gen_split_908 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case AND:
          switch (pattern401 (x2))
            {
            case 0:
              return gen_split_400 (insn, operands);

            case 1:
              return gen_split_403 (insn, operands);

            case 2:
              return gen_split_409 (insn, operands);

            case 3:
              if (!
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_406 (insn, operands);

            case 4:
              if (!
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_412 (insn, operands);

            case 5:
              if (!
#line 13868 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_415 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern401 (x2))
            {
            case 0:
              return gen_split_401 (insn, operands);

            case 1:
              return gen_split_404 (insn, operands);

            case 2:
              return gen_split_410 (insn, operands);

            case 3:
              if (!
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_407 (insn, operands);

            case 4:
              if (!
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_413 (insn, operands);

            case 5:
              if (!
#line 13868 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_416 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern401 (x2))
            {
            case 0:
              return gen_split_402 (insn, operands);

            case 1:
              return gen_split_405 (insn, operands);

            case 2:
              return gen_split_411 (insn, operands);

            case 3:
              if (!
#line 1164 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_408 (insn, operands);

            case 4:
              if (!
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_414 (insn, operands);

            case 5:
              if (!
#line 13868 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT))
                return NULL;
              return gen_split_417 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case NOT:
      switch (pattern40 (x1))
        {
        case 0:
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !nonimmediate_operand (operands[1], E_DImode)
                  || !((
#line 14976 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, DImode, operands, TARGET_APX_NDD)) && 
#line 1235 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT)) && 
#line 14978 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_540 (insn, operands);

            case E_TImode:
              if (!nonimmediate_operand (operands[0], E_TImode)
                  || GET_MODE (x2) != E_TImode
                  || !nonimmediate_operand (operands[1], E_TImode)
                  || !((
#line 14976 "../../../gcc/config/i386/i386.md"
(ix86_unary_operator_ok (NOT, TImode, operands, TARGET_APX_NDD)) && 
#line 1236 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 14978 "../../../gcc/config/i386/i386.md"
( reload_completed)))
                return NULL;
              return gen_split_541 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 15059 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 15063 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_542 (insn, operands);

        case 2:
          if (!(
#line 15059 "../../../gcc/config/i386/i386.md"
(!TARGET_PARTIAL_REG_STALL || optimize_function_for_size_p (cfun)) && 
#line 15063 "../../../gcc/config/i386/i386.md"
( reload_completed
   && !(rtx_equal_p (operands[0], operands[1])))))
            return NULL;
          return gen_split_543 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[2], E_QImode))
            return NULL;
          switch (pattern126 (x2))
            {
            case 0:
              if (!
#line 15978 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
                return NULL;
              return gen_split_570 (insn, operands);

            case 1:
              if (!(
#line 15978 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_571 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
          if (!const_0_to_3_operand (operands[2], E_VOIDmode))
            return NULL;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (!general_reg_operand (operands[0], E_QImode)
                  || GET_MODE (x2) != E_QImode
                  || !index_reg_operand (operands[1], E_QImode)
                  || !
#line 16300 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_581 (insn, operands);

            case E_HImode:
              if (!general_reg_operand (operands[0], E_HImode)
                  || GET_MODE (x2) != E_HImode
                  || !index_reg_operand (operands[1], E_HImode)
                  || !
#line 16300 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_582 (insn, operands);

            case E_SImode:
              if (!general_reg_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !index_reg_operand (operands[1], E_SImode)
                  || !
#line 16300 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD))
                return NULL;
              return gen_split_583 (insn, operands);

            case E_DImode:
              if (!general_reg_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !index_reg_operand (operands[1], E_DImode)
                  || !(
#line 16300 "../../../gcc/config/i386/i386.md"
(reload_completed
   && REGNO (operands[0]) != REGNO (operands[1])
   && !TARGET_APX_NDD) && 
#line 1161 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_584 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LSHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (pattern230 (x2))
        {
        case 0:
          if (!
#line 17425 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
            return NULL;
          return gen_split_618 (insn, operands);

        case 1:
          if (!(
#line 17425 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
            return NULL;
          return gen_split_620 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern230 (x2))
            {
            case 0:
              if (!
#line 17425 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed))
                return NULL;
              return gen_split_619 (insn, operands);

            case 1:
              if (!(
#line 17425 "../../../gcc/config/i386/i386.md"
(TARGET_BMI2 && reload_completed) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)))
                return NULL;
              return gen_split_621 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          if (pattern289 (x2, 
E_V2DImode) != 0)
            return NULL;
          if ((
#line 18006 "../../../gcc/config/i386/i386.md"
(!TARGET_64BIT && TARGET_STV && TARGET_AVX512VL
   && INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 32) && 
#line 18010 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return gen_split_676 (insn, operands);
          if (!(
#line 18023 "../../../gcc/config/i386/i386.md"
(!TARGET_AVX512VL
   && INTVAL (operands[2]) == INTVAL (operands[3])
   && UINTVAL (operands[2]) < 32
   && ix86_pre_reload_split ()) && 
#line 18028 "../../../gcc/config/i386/i386.md"
( 1)))
            return NULL;
          return gen_split_677 (insn, operands);

        default:
          return NULL;
        }

    case ROTATE:
      return split_9 (x1, insn);

    case ROTATERT:
      return split_11 (x1, insn);

    case IF_THEN_ELSE:
      return split_12 (x1, insn);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      switch (GET_CODE (x2))
        {
        case GEU:
        case LTU:
          res = split_4 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case GTU:
        case LEU:
          operands[1] = x2;
          if (shr_comparison_operator (operands[1], E_QImode))
            {
              x4 = XEXP (x1, 0);
              operands[0] = x4;
              if (nonimmediate_operand (operands[0], E_QImode))
                {
                  x3 = XEXP (x2, 0);
                  operands[2] = x3;
                  if (register_operand (operands[2], E_DImode))
                    {
                      x6 = XEXP (x2, 1);
                      operands[3] = x6;
                      if (const_int_operand (operands[3], E_VOIDmode)
                          && 
#line 19443 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT
   && IN_RANGE (exact_log2 (UINTVAL (operands[3]) + 1), 32, 63)))
                        return gen_split_850 (insn, operands);
                    }
                }
            }
          break;

        case NE:
          switch (pattern231 (x1))
            {
            case 0:
              return gen_split_857 (insn, operands);

            case 1:
              return gen_split_858 (insn, operands);

            default:
              break;
            }
          break;

        case EQ:
          switch (pattern231 (x1))
            {
            case 0:
              return gen_split_859 (insn, operands);

            case 1:
              return gen_split_860 (insn, operands);

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 17)
        return NULL;
      x6 = XEXP (x2, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !ix86_comparison_operator (operands[1], E_DImode)
              || !(
#line 19481 "../../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && TARGET_64BIT && !TARGET_PARTIAL_REG_STALL) && 
#line 19483 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_851 (insn, operands);

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || !ix86_comparison_operator (operands[1], E_HImode)
              || !(
#line 19514 "../../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))) && 
#line 19517 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_854 (insn, operands);

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !ix86_comparison_operator (operands[1], E_SImode)
              || !(
#line 19514 "../../../gcc/config/i386/i386.md"
(!TARGET_APX_ZU && !TARGET_PARTIAL_REG_STALL
   && (!TARGET_ZERO_EXTEND_WITH_AND || optimize_function_for_size_p (cfun))) && 
#line 19517 "../../../gcc/config/i386/i386.md"
( reload_completed)))
            return NULL;
          return gen_split_855 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      return split_10 (x1, insn);

    case CLZ:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern126 (x2))
        {
        case 0:
          if (!(
#line 21481 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_LZCNT) && 
#line 21483 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_884 (insn, operands);

        case 1:
          if (!((
#line 21481 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_LZCNT) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 21483 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_885 (insn, operands);

        default:
          return NULL;
        }

    case POPCOUNT:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern126 (x2))
        {
        case 0:
          if (!(
#line 22138 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_POPCNT) && 
#line 22146 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_898 (insn, operands);

        case 1:
          if (!((
#line 22138 "../../../gcc/config/i386/i386.md"
(TARGET_APX_NF && TARGET_POPCNT) && 
#line 1167 "../../../gcc/config/i386/i386.md"
(TARGET_64BIT)) && 
#line 22146 "../../../gcc/config/i386/i386.md"
( TARGET_AVOID_FALSE_DEP_FOR_BMI && epilogue_completed
   && optimize_function_for_speed_p (cfun)
   && !reg_mentioned_p (operands[0], operands[1]))))
            return NULL;
          return gen_split_899 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_45 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (nonimmediate_gr_operand (operands[0], E_V8QImode)
          && nonimmediate_gr_operand (operands[1], E_V8QImode)
          && 
#line 310 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_979 (insn, operands);
      break;

    case E_V4HImode:
      if (nonimmediate_gr_operand (operands[0], E_V4HImode)
          && nonimmediate_gr_operand (operands[1], E_V4HImode)
          && 
#line 310 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_980 (insn, operands);
      break;

    case E_V2SImode:
      if (nonimmediate_gr_operand (operands[0], E_V2SImode)
          && nonimmediate_gr_operand (operands[1], E_V2SImode)
          && 
#line 310 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_981 (insn, operands);
      break;

    case E_V1DImode:
      if (nonimmediate_gr_operand (operands[0], E_V1DImode)
          && nonimmediate_gr_operand (operands[1], E_V1DImode)
          && 
#line 310 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_982 (insn, operands);
      break;

    case E_V2SFmode:
      if (nonimmediate_gr_operand (operands[0], E_V2SFmode)
          && nonimmediate_gr_operand (operands[1], E_V2SFmode)
          && 
#line 310 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_983 (insn, operands);
      break;

    case E_V4HFmode:
      if (nonimmediate_gr_operand (operands[0], E_V4HFmode)
          && nonimmediate_gr_operand (operands[1], E_V4HFmode)
          && 
#line 310 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_984 (insn, operands);
      break;

    case E_V4BFmode:
      if (nonimmediate_gr_operand (operands[0], E_V4BFmode)
          && nonimmediate_gr_operand (operands[1], E_V4BFmode)
          && 
#line 310 "../../../gcc/config/i386/mmx.md"
(!TARGET_64BIT && reload_completed))
        return gen_split_985 (insn, operands);
      break;

    case E_V4QImode:
      if (push_operand (operands[0], E_V4QImode)
          && sse_reg_operand (operands[1], E_V4QImode))
        {
          if ((
#line 440 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1003 (insn, operands);
          if ((
#line 440 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1008 (insn, operands);
        }
      break;

    case E_V2HImode:
      if (push_operand (operands[0], E_V2HImode)
          && sse_reg_operand (operands[1], E_V2HImode))
        {
          if ((
#line 440 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1004 (insn, operands);
          if ((
#line 440 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1009 (insn, operands);
        }
      break;

    case E_V1SImode:
      if (push_operand (operands[0], E_V1SImode)
          && sse_reg_operand (operands[1], E_V1SImode))
        {
          if ((
#line 440 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1005 (insn, operands);
          if ((
#line 440 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1010 (insn, operands);
        }
      break;

    case E_V2HFmode:
      if (push_operand (operands[0], E_V2HFmode)
          && sse_reg_operand (operands[1], E_V2HFmode))
        {
          if ((
#line 440 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1006 (insn, operands);
          if ((
#line 440 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1011 (insn, operands);
        }
      break;

    case E_V2BFmode:
      if (push_operand (operands[0], E_V2BFmode)
          && sse_reg_operand (operands[1], E_V2BFmode))
        {
          if ((
#line 440 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1007 (insn, operands);
          if ((
#line 440 "../../../gcc/config/i386/mmx.md"
(TARGET_64BIT && TARGET_SSE && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1012 (insn, operands);
        }
      break;

    case E_V2QImode:
      if (push_operand (operands[0], E_V2QImode)
          && sse_reg_operand (operands[1], E_V2QImode))
        {
          if ((
#line 614 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == SImode)))
            return gen_split_1013 (insn, operands);
          if ((
#line 614 "../../../gcc/config/i386/mmx.md"
(TARGET_SSE4_1 && reload_completed) && 
#line 1398 "../../../gcc/config/i386/i386.md"
(Pmode == DImode)))
            return gen_split_1014 (insn, operands);
        }
      break;

    case E_P2QImode:
      if (nonimmediate_operand (operands[0], E_P2QImode)
          && nonimmediate_operand (operands[1], E_P2QImode)
          && (
#line 30958 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 30961 "../../../gcc/config/i386/sse.md"
( reload_completed)))
        return gen_split_3807 (insn, operands);
      break;

    case E_P2HImode:
      if (nonimmediate_operand (operands[0], E_P2HImode)
          && nonimmediate_operand (operands[1], E_P2HImode)
          && (
#line 30958 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VP2INTERSECT
   && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 30961 "../../../gcc/config/i386/sse.md"
( reload_completed)))
        return gen_split_3808 (insn, operands);
      break;

    default:
      break;
    }
  if (GET_CODE (x2) != SUBREG)
    return NULL;
  operands[0] = x3;
  switch (SUBREG_BYTE (x2))
    {
    case 8:
      if (GET_MODE (x2) != E_DFmode
          || !register_operand (operands[0], E_DFmode))
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_V2DFmode)
          || !
#line 14652 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
        return NULL;
      return gen_split_3162 (insn, operands);

    case 0:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !
#line 14705 "../../../gcc/config/i386/sse.md"
(TARGET_SSE))
                return NULL;
              return gen_split_3164 (insn, operands);

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || GET_MODE (x2) != E_SImode
                  || !register_operand (operands[1], E_VOIDmode)
                  || !
#line 21462 "../../../gcc/config/i386/sse.md"
(can_create_pseudo_p ()
   && REG_P (operands[1])
   && VECTOR_MODE_P (GET_MODE (operands[1]))
   && ((TARGET_SSE && GET_MODE_SIZE (GET_MODE (operands[1])) == 16)
       || (TARGET_AVX && GET_MODE_SIZE (GET_MODE (operands[1])) == 32)
       || (TARGET_AVX512F && TARGET_EVEX512
	   && GET_MODE_SIZE (GET_MODE (operands[1])) == 64))
   && (SImode == SImode || TARGET_64BIT || MEM_P (operands[0]))))
                return NULL;
              return gen_split_3390 (insn, operands);

            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_VOIDmode)
                  || !
#line 21462 "../../../gcc/config/i386/sse.md"
(can_create_pseudo_p ()
   && REG_P (operands[1])
   && VECTOR_MODE_P (GET_MODE (operands[1]))
   && ((TARGET_SSE && GET_MODE_SIZE (GET_MODE (operands[1])) == 16)
       || (TARGET_AVX && GET_MODE_SIZE (GET_MODE (operands[1])) == 32)
       || (TARGET_AVX512F && TARGET_EVEX512
	   && GET_MODE_SIZE (GET_MODE (operands[1])) == 64))
   && (DImode == SImode || TARGET_64BIT || MEM_P (operands[0]))))
                return NULL;
              return gen_split_3391 (insn, operands);

            default:
              return NULL;
            }

        case SS_TRUNCATE:
          switch (pattern722 (x2))
            {
            case 0:
              if (!(
#line 15425 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15427 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3176 (insn, operands);

            case 1:
              if (!(
#line 15520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15522 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3179 (insn, operands);

            case 2:
              if (!(
#line 15520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15522 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3182 (insn, operands);

            case 3:
              if (!(
#line 15871 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15873 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3198 (insn, operands);

            case 4:
              if (!((
#line 15618 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)) && 
#line 15620 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3185 (insn, operands);

            case 5:
              if (!(
#line 15618 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15620 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3188 (insn, operands);

            case 6:
              if (!(
#line 16134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 16136 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3205 (insn, operands);

            case 7:
              if (!(
#line 15780 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15782 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3192 (insn, operands);

            case 8:
              if (!(
#line 15780 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15782 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3195 (insn, operands);

            case 9:
              if (!(
#line 16021 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 16023 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3202 (insn, operands);

            default:
              return NULL;
            }

        case TRUNCATE:
          switch (pattern722 (x2))
            {
            case 0:
              if (!(
#line 15425 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15427 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3177 (insn, operands);

            case 1:
              if (!(
#line 15520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15522 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3180 (insn, operands);

            case 2:
              if (!(
#line 15520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15522 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3183 (insn, operands);

            case 3:
              if (!(
#line 15871 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15873 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3199 (insn, operands);

            case 4:
              if (!((
#line 15618 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)) && 
#line 15620 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3186 (insn, operands);

            case 5:
              if (!(
#line 15618 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15620 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3189 (insn, operands);

            case 6:
              if (!(
#line 16134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 16136 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3206 (insn, operands);

            case 7:
              if (!(
#line 15780 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15782 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3193 (insn, operands);

            case 8:
              if (!(
#line 15780 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15782 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3196 (insn, operands);

            case 9:
              if (!(
#line 16021 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 16023 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3203 (insn, operands);

            default:
              return NULL;
            }

        case US_TRUNCATE:
          switch (pattern722 (x2))
            {
            case 0:
              if (!(
#line 15425 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15427 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3178 (insn, operands);

            case 1:
              if (!(
#line 15520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15522 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3181 (insn, operands);

            case 2:
              if (!(
#line 15520 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15522 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3184 (insn, operands);

            case 3:
              if (!(
#line 15871 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15873 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3200 (insn, operands);

            case 4:
              if (!((
#line 15618 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15600 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512BW)) && 
#line 15620 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3187 (insn, operands);

            case 5:
              if (!(
#line 15618 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15620 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3190 (insn, operands);

            case 6:
              if (!(
#line 16134 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512 && ix86_pre_reload_split ()) && 
#line 16136 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3207 (insn, operands);

            case 7:
              if (!(
#line 15780 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15782 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3194 (insn, operands);

            case 8:
              if (!(
#line 15780 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 15782 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3197 (insn, operands);

            case 9:
              if (!(
#line 16021 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512VL && ix86_pre_reload_split ()) && 
#line 16023 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3204 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_60 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DFmode:
          if (!register_operand (operands[1], E_V8DFmode)
              || !(
#line 12484 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_1549 (insn, operands);

        case E_V4DFmode:
          if (!nonimmediate_operand (operands[1], E_V4DFmode)
              || !
#line 12902 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed))
            return NULL;
          return gen_split_1558 (insn, operands);

        default:
          return NULL;
        }

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return NULL;
      switch (GET_MODE (operands[1]))
        {
        case E_V8DImode:
          if (!register_operand (operands[1], E_V8DImode)
              || !(
#line 12484 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512DQ
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 717 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
            return NULL;
          return gen_split_1550 (insn, operands);

        case E_V4DImode:
          if (!nonimmediate_operand (operands[1], E_V4DImode)
              || !
#line 12902 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed))
            return NULL;
          return gen_split_1557 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_62 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (pattern833 (x3) != 0)
    return NULL;
  x4 = XVECEXP (x3, 0, 4);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return NULL;
  x5 = XVECEXP (x3, 0, 5);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return NULL;
  x6 = XVECEXP (x3, 0, 6);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return NULL;
  x7 = XVECEXP (x3, 0, 7);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return NULL;
  switch (pattern1529 (x2))
    {
    case 0:
      if (!(
#line 12854 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return NULL;
      return gen_split_1555 (insn, operands);

    case 1:
      if (!(
#line 12854 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && !(MEM_P (operands[0]) && MEM_P (operands[1]))
   && reload_completed
   && (TARGET_AVX512VL
       || REG_P (operands[0])
       || !EXT_REX_SSE_REG_P (operands[1]))) && 
#line 721 "../../../gcc/config/i386/sse.md"
(TARGET_EVEX512)))
        return NULL;
      return gen_split_1556 (insn, operands);

    case 2:
      if (!(
#line 13094 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13096 "../../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1564 (insn, operands);

    case 3:
      if (!(
#line 13094 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13096 "../../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1565 (insn, operands);

    case 4:
      if (!(
#line 13094 "../../../gcc/config/i386/sse.md"
(TARGET_AVX && !(MEM_P (operands[0]) && MEM_P (operands[1]))) && 
#line 13096 "../../../gcc/config/i386/sse.md"
( reload_completed)))
        return NULL;
      return gen_split_1566 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_64 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
    case NOT:
      switch (pattern531 (x2))
        {
        case 0:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1667 (insn, operands);

        case 1:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1694 (insn, operands);

        case 2:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1721 (insn, operands);

        case 3:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1748 (insn, operands);

        case 4:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1775 (insn, operands);

        case 5:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1802 (insn, operands);

        case 6:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1829 (insn, operands);

        case 7:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1856 (insn, operands);

        case 8:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1883 (insn, operands);

        case 9:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1910 (insn, operands);

        case 10:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1937 (insn, operands);

        case 11:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1964 (insn, operands);

        case 12:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1670 (insn, operands);

        case 13:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1697 (insn, operands);

        case 14:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1724 (insn, operands);

        case 15:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1751 (insn, operands);

        case 16:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1778 (insn, operands);

        case 17:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1805 (insn, operands);

        case 18:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1832 (insn, operands);

        case 19:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1859 (insn, operands);

        case 20:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1886 (insn, operands);

        case 21:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1913 (insn, operands);

        case 22:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1940 (insn, operands);

        case 23:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1967 (insn, operands);

        case 24:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1673 (insn, operands);

        case 25:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1700 (insn, operands);

        case 26:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1727 (insn, operands);

        case 27:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1754 (insn, operands);

        case 28:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1781 (insn, operands);

        case 29:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1808 (insn, operands);

        case 30:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1835 (insn, operands);

        case 31:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1862 (insn, operands);

        case 32:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1889 (insn, operands);

        case 33:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1916 (insn, operands);

        case 34:
          if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1943 (insn, operands);

        case 35:
          if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_1970 (insn, operands);

        case 36:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2951 (insn, operands);

        case 37:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2960 (insn, operands);

        case 38:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2969 (insn, operands);

        case 39:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2978 (insn, operands);

        case 40:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2987 (insn, operands);

        case 41:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2996 (insn, operands);

        case 42:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3005 (insn, operands);

        case 43:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3014 (insn, operands);

        case 44:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3023 (insn, operands);

        case 45:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3032 (insn, operands);

        case 46:
          if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3041 (insn, operands);

        case 47:
          if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_3050 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern533 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2315 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2342 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2369 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2396 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2423 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2450 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2477 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2504 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2531 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2558 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2585 (insn, operands);

        case 11:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2612 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern533 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2318 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2345 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2372 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2399 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2426 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2453 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2480 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2507 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2534 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2561 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2588 (insn, operands);

        case 11:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2615 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern533 (x2))
        {
        case 0:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2321 (insn, operands);

        case 1:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 331 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2348 (insn, operands);

        case 2:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2375 (insn, operands);

        case 3:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2402 (insn, operands);

        case 4:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 332 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2429 (insn, operands);

        case 5:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2456 (insn, operands);

        case 6:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2483 (insn, operands);

        case 7:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 333 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2510 (insn, operands);

        case 8:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2537 (insn, operands);

        case 9:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2564 (insn, operands);

        case 10:
          if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 334 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2591 (insn, operands);

        case 11:
          if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
            return NULL;
          return gen_split_2618 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_74 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case AND:
      return split_72 (x1, insn);

    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern535 (x2))
            {
            case 0:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1984 (insn, operands);

            case 1:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2011 (insn, operands);

            case 2:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2038 (insn, operands);

            case 3:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2065 (insn, operands);

            case 4:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2092 (insn, operands);

            case 5:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2119 (insn, operands);

            case 6:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2146 (insn, operands);

            case 7:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2173 (insn, operands);

            case 8:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2200 (insn, operands);

            case 9:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2227 (insn, operands);

            case 10:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2254 (insn, operands);

            case 11:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2281 (insn, operands);

            case 12:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1987 (insn, operands);

            case 13:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2014 (insn, operands);

            case 14:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2041 (insn, operands);

            case 15:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2068 (insn, operands);

            case 16:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2095 (insn, operands);

            case 17:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2122 (insn, operands);

            case 18:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2149 (insn, operands);

            case 19:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2176 (insn, operands);

            case 20:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2203 (insn, operands);

            case 21:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2230 (insn, operands);

            case 22:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2257 (insn, operands);

            case 23:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2284 (insn, operands);

            case 24:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1990 (insn, operands);

            case 25:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2017 (insn, operands);

            case 26:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2044 (insn, operands);

            case 27:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2071 (insn, operands);

            case 28:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2098 (insn, operands);

            case 29:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2125 (insn, operands);

            case 30:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2152 (insn, operands);

            case 31:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2179 (insn, operands);

            case 32:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2206 (insn, operands);

            case 33:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2233 (insn, operands);

            case 34:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2260 (insn, operands);

            case 35:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2287 (insn, operands);

            case 36:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3058 (insn, operands);

            case 37:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3067 (insn, operands);

            case 38:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3076 (insn, operands);

            case 39:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3085 (insn, operands);

            case 40:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3094 (insn, operands);

            case 41:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3103 (insn, operands);

            case 42:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3112 (insn, operands);

            case 43:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3121 (insn, operands);

            case 44:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3130 (insn, operands);

            case 45:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3139 (insn, operands);

            case 46:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3148 (insn, operands);

            case 47:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3157 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern536 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2632 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2659 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2686 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2713 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2740 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2767 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2794 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2821 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2848 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2875 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2902 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2929 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern536 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2635 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2662 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2689 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2716 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2743 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2770 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2797 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2824 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2851 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2878 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2905 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2932 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern536 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2638 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2665 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2692 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2719 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2746 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2773 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2800 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2827 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2854 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2881 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2908 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2935 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case XOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
        case MEM:
        case NOT:
          switch (pattern535 (x2))
            {
            case 0:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1993 (insn, operands);

            case 1:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2020 (insn, operands);

            case 2:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2047 (insn, operands);

            case 3:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2074 (insn, operands);

            case 4:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2101 (insn, operands);

            case 5:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2128 (insn, operands);

            case 6:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2155 (insn, operands);

            case 7:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2182 (insn, operands);

            case 8:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2209 (insn, operands);

            case 9:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2236 (insn, operands);

            case 10:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2263 (insn, operands);

            case 11:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2290 (insn, operands);

            case 12:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1996 (insn, operands);

            case 13:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2023 (insn, operands);

            case 14:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2050 (insn, operands);

            case 15:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2077 (insn, operands);

            case 16:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2104 (insn, operands);

            case 17:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2131 (insn, operands);

            case 18:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2158 (insn, operands);

            case 19:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2185 (insn, operands);

            case 20:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2212 (insn, operands);

            case 21:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2239 (insn, operands);

            case 22:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2266 (insn, operands);

            case 23:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2293 (insn, operands);

            case 24:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_1999 (insn, operands);

            case 25:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2026 (insn, operands);

            case 26:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2053 (insn, operands);

            case 27:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2080 (insn, operands);

            case 28:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2107 (insn, operands);

            case 29:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2134 (insn, operands);

            case 30:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2161 (insn, operands);

            case 31:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2188 (insn, operands);

            case 32:
              if (!(
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2215 (insn, operands);

            case 33:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2242 (insn, operands);

            case 34:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2269 (insn, operands);

            case 35:
              if (!((
#line 13790 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13802 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2296 (insn, operands);

            case 36:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3061 (insn, operands);

            case 37:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3070 (insn, operands);

            case 38:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3079 (insn, operands);

            case 39:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3088 (insn, operands);

            case 40:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3097 (insn, operands);

            case 41:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3106 (insn, operands);

            case 42:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3115 (insn, operands);

            case 43:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3124 (insn, operands);

            case 44:
              if (!(
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3133 (insn, operands);

            case 45:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3142 (insn, operands);

            case 46:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3151 (insn, operands);

            case 47:
              if (!((
#line 13959 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13963 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_3160 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern536 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2641 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2668 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2695 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2722 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2749 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2776 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2803 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2830 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2857 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2884 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2911 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2938 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern536 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2644 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2671 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2698 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2725 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2752 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2779 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2806 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2833 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2860 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2887 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2914 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2941 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern536 (x2))
            {
            case 0:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2647 (insn, operands);

            case 1:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 335 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2674 (insn, operands);

            case 2:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2701 (insn, operands);

            case 3:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2728 (insn, operands);

            case 4:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 336 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2755 (insn, operands);

            case 5:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2782 (insn, operands);

            case 6:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2809 (insn, operands);

            case 7:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 337 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2836 (insn, operands);

            case 8:
              if (!(
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2863 (insn, operands);

            case 9:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((64 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX512F && TARGET_EVEX512)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2890 (insn, operands);

            case 10:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((32 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_AVX)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2917 (insn, operands);

            case 11:
              if (!((
#line 13875 "../../../gcc/config/i386/sse.md"
((16 == 64 || TARGET_AVX512VL
    || (TARGET_AVX512F && TARGET_EVEX512 && !TARGET_PREFER_AVX256))
   && ix86_pre_reload_split ()
   && (rtx_equal_p (STRIP_UNARY (operands[1]),
		    STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[4]))
       || rtx_equal_p (STRIP_UNARY (operands[1]),
		       STRIP_UNARY (operands[3]))
       || rtx_equal_p (STRIP_UNARY (operands[2]),
		       STRIP_UNARY (operands[3])))) && 
#line 338 "../../../gcc/config/i386/sse.md"
(TARGET_SSE2)) && 
#line 13887 "../../../gcc/config/i386/sse.md"
( 1)))
                return NULL;
              return gen_split_2944 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
